===========================================================
                RJ TextEd history of changes
===========================================================

-----------------------------------------------------------
Version 1.46 (Mars 29, 2026)
-----------------------------------------------------------

Customize keyboard shortcuts
    Added a new menu item "Environment -> Customize keyboard..." that opens a 
    file with all shortcuts in the program. Just edit the shortcuts you want to
    change and save (and restart the program).

Fold regions (C#, PHP, ...)
	Some languages, like C#, use #region ... #endregion to define a foldable region.
	
	This should now work properly in both C# and PHP (and other languages if defined 
	in the syntax file).

Fixed
    * Load file issues (display correct encoding in the statusbar).

-----------------------------------------------------------
Version 1.45 (Jan 25, 2026)
-----------------------------------------------------------

YAML
	Added a new syntax file for YAML.

TOML
	Added a new syntax file for TOML (Tom's Obvious Minimal Language).

SYX (RJ TextEd syntax files)
	Added a new syntax file for syntax definition files used in RJ TextEd and
	MPad. It contain some user menu (Ctrl+Space) items as well.

Fixed
	* Very minor issues found while coding.

-----------------------------------------------------------
Version 1.44 (Dec 6, 2025)
-----------------------------------------------------------

Column statistics
    Added a button to copy the result to the clipboard.
    
    Fixed a few display issues.

Find/Replace
    * Replace should work now with an empty replace string.
    * Fixed a few issues with replace.

Fixed
    * Print preview window should scale properly now.
    * Minor issues found while coding.

-----------------------------------------------------------
Version 1.43 (Nov 5, 2025)
-----------------------------------------------------------

Editor freeze/crashing...
    Sometimes when editing certain large files the editor could freeze or
    crash. Especially if the code explorer tag tree was displayed or used.
    
    It should be fixed in this version.

Code folding
    Fixed a few issues with code folding visible in some languages like
    PHP, Perl, JavaScript, TypeScript, Pascal...

Objective-C
    Added a simple highlighter for Objective-C.

Misc
    * Updated the JavaScript/TypeScript syntax file.
    * Updated language files.

Fixed
    * Several find/replace issues.

-----------------------------------------------------------
Version 1.42 (July 17, 2025)
-----------------------------------------------------------

Fixed
    * A *serious* save bug in version 16.42 that may have stripped lines 201, 402... 

-----------------------------------------------------------
Version 1.41 (July 15, 2025)
-----------------------------------------------------------

Plain text files
    Added an option "in the highlighting section" to allow syntax highlighting and
    code folding in plain text files. A syntax file (PlainText.syx) is used.
    
    The option is off by default.
    
    Below is a list of features that works with plain text files.
     
    * Highlighting of quotes, symbols, numbers, braces...
    * Structural block highlighting (only with fixed width font).
    * Indent lines (only with fixed width font).
    * Vertical line at cursor position.
    * Folding (indent based).
    
    Some features only work with a fixed width font (or alt font "Ctrl+").
    
    You can copy the syntax file to the "User defined" folder and add your own
    options.
    
    Colors can be set using the customize theme dialog and selecting "PlainText"
    as the highlighter. 

Editor
    Made several code changes in the background thread to prevent visual updates to
    block the background thread and use much less synchronize calls. Hopefully, 
    redrawing and editing is a little bit smoother now. 
    
    Optimizations in the background thread should speed up:
    
    * Opening and loading new files
    * Creation of code fold blocks
    * All highlight features, e.g. brace highlight, matching words...

Save (large files)
    Save should be much faster now for all files. Especially very large files.
    
Misc
    * Made a small change to the auto parentheses completion function.

Fixed
    * Toggle alternative font.
    * Save to a hidden file.
    * Emmet: wrap with abbreviation issue.
    * Auto completion hint position issue.
    * Brace highlight issue in plain text.

-----------------------------------------------------------
Version 1.40 (Mar 12, 2025)
-----------------------------------------------------------

Sort lines (unique)
    Added new menu items to sort selected lines and remove duplicates (unique).

PHP
    Regions should work properly now.
    
    E.g. 
        #region ... #endregion
        //__START__ ... //__END__

Fixed
    * UI strings should default to English if no translation is found.
    * Edit font size values in options.
    * Some issues in the code folding routines.
    * Triple mouse click on last line. 
    * Some issues with auto completion in CSS/SASS/LESS
    * Markdown syntax highlight issue.
    * C++ syntax fold and code explorer issue.

-----------------------------------------------------------
Version 1.38 (Oct 4, 2024)
-----------------------------------------------------------

Fixed
    * Tag highlight issue.
    * Select tag issue.
    * Issue with tab (expand property and open auto completion).

-----------------------------------------------------------
Version 1.37 (Sep 7, 2024)
-----------------------------------------------------------

CSS (LESS,SCSS) auto completion and hover hints
    Made several improvements to auto completion when editing CSS files, and 
    inside HTML style tags. Both Ctrl+space and other auto completions should
    work much better now.
    
    Changed the icons used in the auto completion window.
    
    Auto completion items and hints are now collected from a Json file (css.json).
    It's the same file used in VSCode.

HTML auto completion and hover hints
    Made several improvements to auto completion. Both Ctrl+space and other
    auto completions should work much better now.
    
    Changed the icons used in the auto completion window.
    
    All auto completion items and hint are collected from a Json file (Html.json).
    It's the same file used in VSCode.

EditorConfig
    Added support for EditorConfig files (.editorconfig).
    Whenever the editor opens a file it looks for .editorconfig files in the current
    and parent folders. The files contain settings that override the editor settings.
    This is helpful when you share source between different environments (and developers).
    
    You can turn this off in options, if you encounter some issues...
    
    For more information about EditorConfig see https://editorconfig.org/

GML (GameMaker Language)
    Added a new highlighter (syntax file) for GML code.

Json
    Fixed some highlighting issues.

Fixed
    * Text cursor blinking or disappearing issue.
    * JavaScript template literal highlighting issue.
    * Some minor editor paint issues.
    * Select line issue (last line).

-----------------------------------------------------------
Version 1.36 (July 13, 2024)
-----------------------------------------------------------

Customize themes dialog
    Made some minor visual changes when you set individual highlighter settings.

Indent lines
    Made some minor changes to fix High DPI issues when using dotted lines.

Help menu
    Added a few new menu items.

Fixed
    * A few theme issues when you create a new one based on the "Windows" theme.
    * Document map draw issues.
    * Structure highlighting flicker in some situations.

-----------------------------------------------------------
Version 1.35 (July 4, 2024)
-----------------------------------------------------------

Structural highlighting
    Added new options to highlight the current code block (based on indention) by
    displaying colored vertical and optional horizontal lines.
    
    Options are located in "Options -> Display -> Structural highlighting and indent lines".

Highlight words
    Made some color changes to make both background and text colors adaptive and
    look better on different background colors (light/dark background color). 
    
Code completion
    Code completion inside HTML style="" attribute should work now.

Markdown
    Fixed a few word wrap issues.

Fixed
    * Code completion issues in CSS style blocks or inside style="" attributes.
    * Undo issue.

-----------------------------------------------------------
Version 1.34 (May 23, 2024)
-----------------------------------------------------------

Options
    Made changes in the "Highlight and margin" and "Font and tabs" sections.
    
Current line border color
    Added the option to change the current line border color in customize themes dialog
    window.
    
Space between lines
    This option should work better now on really high DPI monitors.

High DPI
    Improved main window scaling and scaling in dialog windows. It's most notable
    when moving main window between different monitors.

Log file highlighter
    Added a simple log file highlighter.

Misc
    * Word (identifier) highlighting in JavaScript files...

Fixed
    * Open/Close fold when scrolled horizontally.
    * Jumping between lines in large files when document map is visible (e.g. Ctrl+End).
    * Ctrl+Arrow and Ctrl+Del issue.
    * Brace highlighting using alternative font.
    * Color hint text color issues.
    * Minor color issues in the pick color dialog.

-----------------------------------------------------------
    Made some changes to make sure the text cursor stops at the same positions
    when using the option to always stop at the beginning of a word and pressing
    Ctrl+left or Ctrl+right.

Delete next word (Ctrl+Delete)
    Changed how Ctrl+Delete behaves. The default behavior should be the same
    as in VS Code or Sublime. Ctrl+Del deletes to the end of the next word.
    
    Added options to change the behavior to delete to the start of next word
    and ignore symbols.

Triple click to select line
    Added an option to enable/disable triple mouse click to select the current
    line.
    
    Also fixed a few select issues.

    * Double click select issue when using vertical cursor line.

-----------------------------------------------------------
Version 1.32 (Feb 21, 2024)
-----------------------------------------------------------

Mini toolbar
    Added a "Capitalize" button.
    
    Made some minor visual changes.
    
Code hints
    Made some code changes to make long text fit better inside the window and
    made some small size changes.
    
Auto completion
    Added code to prevent the auto completion window to become wider than the
    current display.
    
Emmet abbreviations
    Tabs are now used for indention unless the option to insert spaces is set in options.

Vyper
    Added a new highlighter for Vyper.

AutoIt
    Fixed an issue with #cs ... #ce block comments.

Fixed
    * Search issue in the options window.

-----------------------------------------------------------
Version 1.31 (Jan 25, 2024)
-----------------------------------------------------------

Move to next/previous word (Ctrl+Right/Left)
    Changed how this works. It should work similarly to how it works in other
    editors like VS Code or Sublime.
    
    Ctrl+left
    Move the cursor to the beginning of a word, or to the right of open braces
    e.g. ([{
    
    Ctrl+right
    Move the cursor to the end of a word, or to the left of closing braces
    e.g. )]}

    Added options to change the behavior.
    
    - Always move to beginning of word. This will include some symbols as well, like ()[]{}"'.
    - Ignore symbols. Will find letters and numbers. Symbols are ignored.
    
    Also, fixed a few issues.

Delete word (and previous word) (Ctrl+Del)
    This function should ignore the options above.

Option window
    Should handle high DPI screens better now.
    
Customize themes window
    Window size is save between sessions.
    Changed some behavior when resizing the window.

AutoIt
    Comment blocks should be highlighted properly now.
    
    E.g.
        #cs --------
            Code...
        #ce --------

Fixed
    * Toggle comment and undo issues.
    * Minor issues.

-----------------------------------------------------------
Version 1.30 (Oct 24, 2023)
-----------------------------------------------------------

Hide fold/unfold icons in gutter
    Fold/unfold icons are now hidden by default and only displayed when the mouse is hovering
    the left margin (gutter). This is the default behavior in many code editors
    and now also in this one. It can be changed in options though.
    
    An option has been added to always show fold/unfold icons in gutter, if you want
    the old behavior and always display the icons:
    
    "Options->Display->Code folding->Always show fold/unfold icons in gutter"
    
Find/Replace
    Find all and replace all will now open a search result panel to list all
    items found or replaced.
    
    Double click a listed item to goto the found/replaced text in the file.
    
    Added a new menu item in "Search" called "Show result panel". This allows
    you to close and reopen the result panel after a search.

Find in files
    Added a new menu item in search called "Find in files".
    
    Use it to search all open files or files in a folder.

Mojo
    Added a new highlighter for Mojo programming language.

Reason
    Added a new highlighter for Reason programming language.

Purescript
    Added a new highlighter for Purescript.
    
Pony
    Added a new highlighter for the Pony programming language.
    
Elm
    Added a new highlighter for Elm.

Fixed
    * Open from commandline with "Reopen last open documents at startup".
    * Goto dialog issues.
    * UNC path issue.
    * Create aligned columns marking all lines as changed.
    * Link in about dialog.
    * Misc minor changes in the editor component.

-----------------------------------------------------------
Version 1.28 (Sep 15, 2023)
-----------------------------------------------------------

Themes (Editor color profiles)
    Added a new submenu in the "Themes" menu with editor color profiles. The
    default colors are stored as color profile #0.
    
    Most themes will have 4 different color profiles defined.
    
    You can make changes to a color profile or define any number of new color profiles
    in the customize dialog.
    
JavaScript highlighter
    Fixed some highlighting issues with regular expressions in JavaScript code.

Misc
    * A few minor cosmetic changes.

Fixed
    * Toolbar dropdown draw issue.
    * (Log) file monitoring read issue.
    * Some theme related issues.
    * Open file at cursor.
    * Many minor issues found while coding.

-----------------------------------------------------------
Version 1.27 (Aug 18, 2023)
-----------------------------------------------------------

Crystal highlighter
    Added a new highlighter for Crystal source code.

Fixed
    * Mouse click in document map to scroll.
    * Issues when using the two options "Allow text cursor beyond end of line" and 
      "Paste should not move the text cursor" together.


-----------------------------------------------------------
Version 1.26 (July 9, 2023)
-----------------------------------------------------------

Hyperscript (in HTML)
    Added support for _hyperscript in HTML.
    
    Highlighting enabled for:
        Script tag
            * <script type="text/hyperscript"></script>
        
            * hs=""         (hs='')
            * data-hs=""    (data-hs='')
    Made some changes at windows shutdown, restart and logoff when the program
    

GDScript highlighter
    Added a new highlighter for GDScript script files.

Julia highlighter
    Added a new highlighter for Julia source files.

Zig highlighter
    Added a new highlighter for Zig source files.
    
Fixed
    * Several issues with makefiles.
    * A few other issues reported by users.

-----------------------------------------------------------
Version 1.25 (June 17, 2023)
-----------------------------------------------------------

Activate highlighter when opening a file
    I've added new options to activate a highlighter if a new file type is opened
    and the file extension and highlighter is not activated in "Addons".
    
    The default behavior is to display a prompt asking the user if the highlighter
    should be activated, with all its file extensions. But you can change that
    in option to automatically activate the highlighter, without the prompt.    
    
    Ex. You open a FSharp file and the FSharp highlighter is not active and available
    in the syntax highlighter list. Normally you would have to activate it manually
    in "Addons". But with these options it can be done for you.
    
    The options can be found in "Options -> File -> Miscellaneous":
        
        - Activate highlighter on unknown file extension
          - Prompt user to activate highlighter 

Always open application on active monitor
    Added a new option to always open the program on the same monitor as the mouse
    cursor.
    
    The option is turned off by default, but can be turned on in 
    "Options -> Program -> Program start".

Open large files as plain text
    Added an option to open large files as plain text in "Options -> File -> Open".
    The large file limit is set in MB.
    
    This option is turned off by default.

Auto completion
    Made changes to fix some issues when the auto completion list is visible
    while you type.
    
    I also fixed a few other issues found while testing.

Lisp Highlighter
    Created a new highlighter for Lisp.

Misc
    * Option to enclose selection with quotes now include backticks.

Fixed
    * System dialogs (e.g. open, save...) should not have any theme colors.
    * Editor tab color and font issues.
    * Updates after changes in themes manager.
    * Some issues with color value highlighting.
    * Issues with color value hints.
    * Several other reported issues.

-----------------------------------------------------------
Version 1.24 (Apr 2, 2023)
-----------------------------------------------------------

Dart
    Created a new syntax file (highlighter) for Dart programming language.

Lua
    Updated and made several changes to the Lua highlighter (syntax file).

Groovy
    Created a new syntax file (highlighter) for the Groovy programming language.

D
    Created a new syntax file (highlighter) for D programming language.

F#
    Created a new syntax file (highlighter) for F#.

MASM
    Created a new syntax file (highlighter) for MASM.

Pascal/Delphi
    Updated the syntax file (highlighter) for Pascal.

Solidity
    Created a new syntax file (highlighter) for Solidity.

Objeck Programming Language
    Created a new syntax file (highlighter) for Objeck.

Fixed
    * Emmet abbreviation issue.
    * Several issues found while testing new highlighters.
    * A few issues reported in the forum.


-----------------------------------------------------------
Version 1.23 (Mar 16, 2023)
-----------------------------------------------------------

Java
    Updated and made several changes to the Java highlighter (syntax file).

Scala
    Created a new syntax file (highlighter) for the Scala programming language.

R
    Created a new syntax file (highlighter) for the R programming language.

Kotlin
    Updated and made several changes to the Kotlin highlighter (syntax file).

Ruby
    Updated the Ruby highlighter (syntax file).

SQL
    Updated the SQL highlighter (syntax file).

Fixed
    * Warn if document has been changed by external program should work now.
    * Strange behavior when saving custom theme.
    * Fixed some issues with auto completion hints.
    * Brace color issues in some situations.
    * Brace highlighting in some situations.
    * Keyword RegEx issue with case.

-----------------------------------------------------------
Version 1.22 (Mar 4, 2023)
-----------------------------------------------------------

Go highlighter
    Updated the Go syntax file.
    
Fixed
    * Misc handle issues while closing documents.
    * Some column mode issues.
    * Minor issues reported by users.

-----------------------------------------------------------
Version 1.21 (Feb 22, 2023)
-----------------------------------------------------------

Mouse wheel scrolling
    Mouse wheel scrolling should work now for all controls under the mouse
    cursor.

Rust highlighter
    Created a new syntax file for Rust. I also added information in the forum
    on how to add a Rust language server (Rust Analyzer).

Highlighter settings
    Some settings for a specified highlighter may not have worked in previous
    versions. It should be fixed now in this version.
    
Syntax files
    In previous versions, you could get an exception error when creating a new
    syntax file without any keywords. It should be fixed now in this version.

Fixed
    * CSS, PHP... text draw issue.
    * Auto completion issues when word completion is enabled.
    * Select issue in plain text with brace highlighting.
    * Column mode undo issue with paste.
    * Minor issues reported by users.

-----------------------------------------------------------
Version 1.20 (Feb 13, 2023)
-----------------------------------------------------------

Color nested braces
    Braces are drawn using different color depending on nesting level.
    E.g. in (10-(a+2)) the first matching (...) pair may be drawn using an orange
    color while the inner (a+2) pair are drawn using a blue color.
    
    This can be turned off in "Environment->Themes->Customize...". 
    Find the checkbox on the "Symbols" row.
    
    This change affect all (), [] and {} brace pairs.

Highlight nearest braces
    Added option to highlight the nearest braces that encloses the text cursor.
    Braces highlighted are (), [] and {}. The editor will always try to find the nearest
    left and right braces, from the text cursor, and highlight them.
    
    It's turned on by default, but can be turned off in options.

    Added option to highlight the current word or identifier under the text
JavaScript (JSDoc)
    Made several changes to the highlighter and added support for JSDoc comments.
    other tag used. E.g. @dummy is highlighted.
    
PHP (DocBlocks)
    Made some changes to the highlighter and added support for DocBlocks.
    All DocBlock tags are highlighted and checked strictly. No other tags are
    highlighted. E.g. @dummy is not highlighted.
    
Cpp (Doxygen)
    Made some changes to the highlighter and added support for Document commands (Doxygen).
    highlighted. E.g. @dummy is not highlighted.
    
Powershell
    Made several changes to the highlighter.

Goto (Ctrl+G)
    Selected word, or word under cursor is now added to the "Functions" find field.
    This makes it easier and faster to navigate to a function in the code. Just
    place the cursor at a function name, press Ctrl+G, select the function
    in the list, if not already selected and press enter.

Fix commonly reported bugs
    In this version I tried to fix two common issues. Highlight issues 
    after some editing and exceptions after closing the program.
    I found a lot of highlighting issues while scanning the code. They should all
    be fixed now. I also fixed several close down issues. Mostly in third party
    components.

Options
    The default highlighter in "Highlight and margin" and "Font and tabs" are
    now set to "All languages".
    
    If you want to set individual settings for e.g. PHP - select PHP in the
    highlighters dropdown list.

Fixed
    * Focus issues after opening file(s).
    * Several highlighting issues when editing.
    * Several errors when closing the program.
    * Highlighter issue when open remote file.
    * Bookmarks on empty lines.
    * Highlight matching braces.
    * Vertical/Horizontal split issues.
    * A few brace highlight issues.
    * Pressing close button repeatedly could cause an error.
    * Issue in Delphi library when closing application.
    * High DPI issues when clicking checkboxes in themes dialog.
    * Focus error in options window.
    * Undo issue in column mode.
    * If the program was minimized and forced to close, it should start as normal window.
    * Several other minor issues reported by users.

-----------------------------------------------------------
Version 15.75 (Jan 10, 2023)
-----------------------------------------------------------

Undo/Redo in column mode
    Was able to make some undo buffers much smaller. The undo buffers could grow
    in size and become really large when doing column editing on very large files.

Misc
    * Changed the default XML engine to not use the MSXML.
    
Fixed
    * Convert text to HTML code issue.
    * Minor changes to prevent errors at startup.

-----------------------------------------------------------
Version 15.74 (Jan 6, 2023)
-----------------------------------------------------------

Highlighters
    Updated some highlighters (syntax files) for HTML, PHP.
    And added the latest RepRap highlighter.

Misc
    * Updated a few language files.

Fixed
    * Error when closing program and using a HTML preview panel.

-----------------------------------------------------------
Version 15.73 (Dec 30, 2022)
-----------------------------------------------------------

Open command-line interface
    Changed the command prompt menu item in the tools menu to open any command-line 
    shell you want.
    
    The command-line shell can be set in the tools section in options.
    Three shells are available in the dropdown box. Windows Terminal, PowerShell
    and Command Prompt. Select "Other" if you want to set something else as the
    command-line interface.
    
    Also changed the caption in the tools menu.
    
Internal code changes
    Made some internal changes to prevent issues when switching highlighter, or
    converting text to code (HTML).

Fixed
    * Convert to HTML issues.
    * Edge browser issue when closing the program.
    * Misc reported issues.

-----------------------------------------------------------
Version 15.72 (Dec 23, 2022)
-----------------------------------------------------------

Emmet
    Fixed a few class related issues.
    
    Also made some space improvements between tags and attributes.
    
Browser preview (Edge)
    Made some internal changes to prevent error messages when opening a new
    page or when closing a browser window. An error may occur when closing
    the program as well.

Home
    Selecting/Un-selecting items by clicking checkboxes should work better now.
    
Stability improvements
    Identified several instances in code throughout the project that may cause
    errors, crashes or memory corruption over time.

Fixed
    * Annotation-bar issue with split window.
    * Browser preview issues.

-----------------------------------------------------------
Version 15.71 (Dec 22, 2022)
-----------------------------------------------------------

Snippets
    Added a new tree node in the text clips panel called "Snippets".
    
    All snippets are available in an XML file and maintained by me. Which means
    users are not allowed to add/delete or edit snippets. It's a write protected
    node. The file will be overwritten when you install an update.
    
    I may add more items to the snippets file in later versions. Suggestions
    are welcome.

SFTP component
    Updated the SFTP component to the latest version.

Mouse cursor over splitter
    Changed the mouse cursor to the Windows standard one when hovering over a
    splitter between document views.

Fixed
    * Split document window issues.
    * Folding issue introduced in v15.70.

-----------------------------------------------------------
Version 15.70 release 2 (Dec 19, 2022)
-----------------------------------------------------------

Split document window to another document view
    In this version you can split the current document window to a new tab in
    another document view. E.g. split the current document to a new tab to the
    right document view.
    
    A new menu item has been added to the document tab context menu called
    "Split document window". It also contain the items to split vertically or
    horizontally.

Brace highlighting
    Braces are now highlighted in plain text.
    
Text cursor width (caret)
    If you set the text cursor width to 0 (zero) a block cursor will be used.
    Note that the block cursor is only used with monospaced fonts, like "Consolas",
    "Courier New"...

    The width limit has been set to 5.
    
Temporary backup (timer)
    Modified files and open tabs data should be periodically saved to a temp 
    folder. Made some code changes to save more data in a more reliable format.

Exception tracer
    Made some option changes to create a better bug report.
    The bug report should now include some debug files as well.
    
WebView2Loader (Edge browser preview)
    Updated the dll file to the latest version.

Fixed
    * Close tab issue with delayed loading.
    * Zoom in external document window.
    * Drag n drop issues.
    * Many minor issues reported by users.
    
Version 15.68 (Dec 11, 2022)
-----------------------------------------------------------

    
Text comparison
    Made some improvements to the line compare display. It should handle Unicode
    better now.
    
Quick Find (Ctrl+E)

Projects
    Replaced some old code and units.
    
    Added an option to indicate open project files with a colored line in the
    document tab.
    
Restart (as admin, update...)
    Made some changes to the saved data to prevent issues when re-opening
    files.

Exception tracer
    Disabled the builtin exception tracer and installed EurekaLog instead.
    Hopefully it will catch a few more exceptions. It also has options to
    check memory or hang issues. They are disabled by default for speed.

Fixed
    * Some theme issues with standard dialog windows.
    * Running tool in the background.
    * Some high dpi issues when moving between monitors.
    * Install issue when running the program as a "Standard User".
    * Update issue where open tabs were not re-opened.
    * Many minor issues reported by users.

-----------------------------------------------------------
Version 15.65 (Oct 31, 2022)
-----------------------------------------------------------

Associate file extensions
    In options you can now assign the icon to be displayed in Explorer, for your
    associated file type. There are several text document icons to choose from,
    including the default program icon.
    
    Associate file extensions should work better now on Windows 10/11 as well.
    If a file extension was previously associated with a different program, you
    may have to open a file with that extension and select RJ TextEd as the 
    default app, when Windows asks which app to use.
    
FTP profile
    The option for passive connection is now always checked when creating a new profile.

Fixed
    * FTP file size display error.

-----------------------------------------------------------
Version 15.64 (Oct 29, 2022)
-----------------------------------------------------------

Program icon
    Changed the program icon (thanks Jeff). It simply says RJ, but it has a more modern
    look and feel.
    
    I also changed the window caption from "RJ TextEd" to simply "TextEd".
    
Themes
    Added a new option in the customize themes dialog window to theme window border and
    title bar. Or not.
    
    Some themes looks pretty good with the standard windows title bar. E.g. Windows 11 light.

Find All
    In this version you can set the output result to both "list all items found" and
    "highlight all items found".

Document views
    Splitters between document views are now highlighted when hovering the mouse over a splitter.

Syntax files
    SymbolWords should work again in this version. Note that you need to select
    the correct highlighter in the customize theme dialog to see the style and
    color options.

Misc
    * Redesigned the about dialog window.
    * Redesigned the opening splash screen.

Fixed
    * Font size issues in some windows.
    * Misc minor issues reported by users, or found while coding.

-----------------------------------------------------------
Version 15.63 (Sep 27, 2022)
-----------------------------------------------------------

Clone document window
    There are some important changes in this version.
    
    * A cloned tab, or document window, is an exact copy of the original tab.
    * Undo/redo history, bookmarks, code folds etc. are all copied to the new document window.

Tab order
    Tabs are now opened at the end of the tab row and always in alphabetical order.
    
Tab sort
    Added a menu item to the tab-bar context menu to sort all tabs.
    
Startup
    Made some changes when the program close and re-start.
    
    * The search result panel is closed and not re-opened at program startup.
    * Multiple document tab views are closed and not re-opened at startup.
    
Korean language
    A Korean language file has been added.
    
    Select Korean in "Environment->Languages".

Fixed
    * File Commander: Path display in right pane.
    * Misc minor issues reported or found while coding.

-----------------------------------------------------------
Version 15.62 (Sep 9, 2022)
-----------------------------------------------------------

(S)FTP
    A separate connection is now always created when saving a remote file.
    In previous versions, an existing connection was used if available.
    
File Commander
    The lists are now rebuilt when switching to the file commander tab. This
    will update the modified dates and possibly other changes done
    while on the editor tab.
 
 Printing
    Made some changes to code and added more validations. Abort should work
    now as well (I hope).
    
Fixed
    * Word wrap issue with variable width fonts.
    * A few high DPI issues.
    * Fixed a few issues in the color selection dialog.

-----------------------------------------------------------
Version 15.61 (Aug 28, 2022)
-----------------------------------------------------------

Emmet abbreviations (HTML)
    Tags are first validated before expanded.
    
    E.g. p[tab] should expand to <p></p>, but xyz[tab] should not expand to 
    <xyz></xyz>. xyz is not a valid HTML tag.

Reload current document
    All code folds are now opened and document re-scanned for folding areas.

Import/Export highlighter colors
    Some items were not imported/exported properly, using the themes manager.
    I've added some missing items.

Fixed
    * Issues with large files and really large lines.
    * Several highlighting issues.
    * Some position issues with Mini Toolbar.

-----------------------------------------------------------
Version 15.60 (Aug 17, 2022)
-----------------------------------------------------------

Digital code signing
    All executables and install scripts are now digitally signed. This should
    help with some antivirus programs and any issues you may have when
    downloading and installing the program.

Selection mini toolbar
    Added a mini toolbar that is displayed when making a selection. It fades
    away after a short while, or if you press the left mouse button.
    
    Added an option to turn the mini toolbar on or off.

CSS highlighting
    Updated the CSS syntax files and made some highlighting changes.
    
    The file css.xml was added in the syntax folder. The file is provided by microsoft
    and renamed from css-scheme.xml to css.xml. It contain most items needed for
    auto completion and hints.

Syntax files
    Added a new option in syntax files to turn on/off sorting in the 
    auto completion list (AutoCompleteSort=0|1).

Misc
    * Made some internal changes in the paint function and the move cursor
      function when using folding.
Fixed
    * A few FTP save issues.
    * Auto completion hint flicker.
    * Restart Windows issues when program is still running.
    * Selection color issue with plain text files.
    * Find issues.
    * Misc issues while coding.
-----------------------------------------------------------
Version 15.54 (June 17, 2022)

    Added 2 new themes to the "Environment -> Themes" menu.
    Made some more optimizations to speed up browsing directories.

Fixed
    * Favorites menu in FTP panel missing.
    * Made some changes in "Replace All" undo code.
    * Selection issue.

-----------------------------------------------------------
Version 15.53 (June 6, 2022)
-----------------------------------------------------------

Zoom (CTRL+MouseWheel Up/Down)
    Added a new menu item in the "View" menu named "Zoom" with sub-menu items
    to zoom in, zoom out and reset zoom. You can also use the mouse wheel
    while pressing the CTRL key.
    
    Zoom will affect all open documents, as well as new or opened documents.    
    The zoom value is saved between sessions. Use "Reset zoom" to undo any
    zooming you have done.
    
    Note that zoom will not change the font size you have set in options.

File Commander
    Fixed some display issues when connected to a remote site.
    
FTP Profile manager
    Passwords are now shown as a masked string (***).

Misc
    * Made some minor changes to the maximize window code.
    * Made some minor additions to the FTP client code.

-----------------------------------------------------------
Version 15.52 (May 30, 2022)
-----------------------------------------------------------

Vertical line at cursor position 
    Added an option in the view menu to "Show vertical line at cursor position".
    
    The line can be a dotted or solid line and is displayed at the current text cursor position.    
    You can change the color and style in "Environment->Themes->Customize...".

FTP Panel
    Added a new right click context menu to the FTP panel that contains the
    following menu items:
    
    Permissions  - Change read/write/execute access
    New file...  - Create a new file and upload it to the server 
    New folder   - Create a new folder on the server
    Edit file    - Download and open the selected file(s)
    Upload current document to remote server  - Save the currently open document on the server
    Refresh      - Reload the remote folder
    Rename       - Rename file or folder
    Delete       - Delete selected files and folders
    
    I also made some optimizations to speed some things up a bit and fixed a
    few issues.

Fixed
    * Language display issue when opening document tab as an external window.
    * Heredoc highlight issue in bash documents.
    * External compare of remote files.
    * Issue when trying to open remote files several times.

-----------------------------------------------------------
Version 15.51 (May 16, 2022)
-----------------------------------------------------------

FTP
    * Add favorite dialog will ask you for both a name and a path.
    
Text comparison (text diff)
    Made some visual changes in the row compare panel. Tabs and spaces should
    now be displayed to help see the difference between the two current rows.
    
    Fixed a few issues.
    
Fixed
    * Close document tab issue when tab is close to the right edge.
    * Maximize issues.
    * Open a session may close the program when certain options are enabled.

-----------------------------------------------------------
Version 15.50 (May 7, 2022)
-----------------------------------------------------------

Word/Selection highlighting
    The highlight color is now different for each word or selected phrase you
    want to highlight. So if you select e.g. 3 different words - they will be
    highlighted using different colors.

Brace Highlighting
    You can now highlight matching braces as bold, underlined or framed. With
    or without a background color. You can also use a background only if you
    set the type to "None".
    
    Options can be found in [Environment/Themes/Customize...].
    
    Also fixed a few issues with background color.

Highlight Expressions
    Fixed an issue with regular expressions.
    
    Added a menu item to the editor context menu.
    (It was previously only available in the Search->Highlight menu)
    
Windows XP
    Fixed some issues with open file dialog.
    
Syntax highlighters
    Updated the bash highlighter to add functions to the code explorer. 
    Changed how folding works and how strings are highlighted.

Misc
    * Chinese language issue in installer.
    * Possible FTP reconnect issue with "Keep alive". 

Fixed
    * Install issue when using standard user accounts.
    * Some minor issues found while coding.

-----------------------------------------------------------
Version 15.49 (Apr 5, 2022)
-----------------------------------------------------------

Misc
    * Updated JavaScript syntax to handle Template Literals (template strings).
    * Updated PHP syntax to handle execution operators.

Search dialog
    You can now use Ctrl+Tab and Ctrl+Shift+Tab to switch between tabs. 

Fixed
    * Calling editor with command line switches when the editor is already open.
    * Alt shortcuts in search dialog.
    * XML fold issue.

-----------------------------------------------------------
Version 15.48 (Mar 25, 2022)
-----------------------------------------------------------

Fixed
    * Syntax editor theme issue.
    * Issue with linebreaks in selection of empty lines.
    * Issues when "Run as administrator".
    * Goto matching bracket should work even if brace highlighting is disabled.

-----------------------------------------------------------
Version 15.47 (Mar 14, 2022)
-----------------------------------------------------------

Fixed
    * Some Emmet abbreviation issues.

-----------------------------------------------------------
Version 15.46 (Mar 14, 2022)
-----------------------------------------------------------

Emmet abbreviations
    Added support for the standard Emmet lorem abbreviation.
    
    Ex1. p>lorem100 
    Ex2. ul>lorem10.item*4
    Ex3. lorem120

Fixed
    * Exception message when changing theme.

-----------------------------------------------------------
Version 15.45 (Mar 11, 2022)
-----------------------------------------------------------

Run multiple instances
    You can open another instance of the program if you hold the CTRL key while 
    launching the editor.
    
    If you select several files in explorer and open them in the editor using the
    context menu while holding the CTRL key - every file will be opened in its
    own editor window.
    
    Removed the option to allow another instance on a different virtual desktop.

Code Explorer
    Added a search box to the method list.
JavaScript
    Made changes to improve Code Explorer navigation.
    
Explorer context menu
    icon and open multiple files properly.
    
    You can also open each selected file in its own instances of the program 
    if you press the CTRL key.

    * Path issue when opening a file with no path and app is running.
    * Folder picker issue on Windows XP.
    * Tcl/Tk namespace support.
-----------------------------------------------------------

Toolbar images
    Updated the image lists to the latest version.
Fixed
    * Context menu issue when installing the application.
    * Possible directory issue when opening a file with no path.

-----------------------------------------------------------
Version 15.43 (Feb 22, 2022)
-----------------------------------------------------------

Selection
    Added a new option in Themes->Customize to show/hide tabs, spaces and line-breaks
    inside a selection.
    
    All selection features should work now with variable width fonts like Arial, 
    Calibri... which is mostly used in plain text. Space characters are ignored
    and not indicated with a dot in selections though.
    
    Fixed several issues. Mostly with highlighter specific settings.

Themes manager (Themes -> Customize)
    Made the window larger and a few other visual changes.

Fixed
    * Move left/right issues in document panel.
    * Selection issues (options).


-----------------------------------------------------------
Version 15.41/15.42 (Feb 12, 2022)
-----------------------------------------------------------

Selection
    Added several options for selection in "Environment -> Themes -> Customize".
    
    * Selections can be drawn to the right window edge when spanning multiple lines.
    * Selections can be drawn to the line break when spanning multiple lines.
    * Selections can be transparent and display highlighting.
    
    Tabs and white spaces are always displayed inside selections (when mono-spaced
    fonts are used). Line breaks are shown inside the selection if the selection 
    extend to the window edge.

    Default behavior is transparent selection extending to the window edge.

Fixed
    * Close to hibernate.
    * Fixed a potential issue with selection.

-----------------------------------------------------------
Version 15.40 (Feb 4, 2022)
-----------------------------------------------------------

Highlight braces inside strings
    If you enter a string and the cursor is positioned at a brace character
    the current and the matching brace inside the string is highlighted.

Highlight braces
    You can now switch highlight type between underlined or squared.
    Open Environment -> Themes -> Customize to change highlight type.

Toolbar button
    Added a new toolbar button with a "Compare text" dropdown menu.
    
    The same menu is available in the "Tools" main menu and in the
    document tab context menu.
    
    Go to "Environment - Customize toolbar..." to enable the toolbar button.

Highlighters (syntax files)
    Updated the JavaScript syntax files.
    
Emmet abbreviations
    Fixed a few issues with empty tags.
    
Web preview
    Added a button to open Edge (Chromium) developer tools on the browser preview tab.
    
    The WebView2 control open the developer tool window as a stand alone window
    and it can't be docked.

Misc
    * Windows 11 Dark theme is set as standard with new installations.

Fixed
    * Remote save issue.
    * Search folder drop down menu position.
    * Several Alternative font issues.
    * Syntax highlighting issue when saving file remotely.

-----------------------------------------------------------
Version 15.31 (Dec 29, 2021)
-----------------------------------------------------------

New themes
    Added two new Windows 11 style themes. A light and a dark one with rounded
    corners.
    
Visual changes
    Made visual changes to all dialog windows.
    
Fixed
    * F3 in dual view when searching all open files.
    * Installer should close the application before proceeding.
    * Hex number search issue.

-----------------------------------------------------------
Version 15.30 (Dec 18, 2021)
-----------------------------------------------------------

Run external script
    It is now possible to run an external script from a local script using
    e.g. NodeJS. It should be possible to run any type of script, including
    JScript, VBScript, PHP, Python ...
    
    The function "RunScript" has been added to the ScriptUtils object.
    
        RunScript(sCommand, sScript, sInputText: String): String;

    Example
    {
        // Run a JavaScript using NodeJS
        var s = Document.SelText;
        var sz = "Node";
        var sc = "c:\\Users\\Me\\Documents\\Source\\JavaScript\\numsort.js";
        var sr = ScriptUtils.RunScript(sz,sc,s);
        Document.SelText = sr;
    } 

Visual changes
    Made visual changes to all dialog windows throughout the application. In 
    some dialogs more than others. The goal was to give them a more
    modern look and feel.
    
    There are some minor changes in other places as well.
    
Advanced sort
    Made it possible to save the current sort options using a name.
    
Regular expressions
    Error messages should be displayed with all search operations if an error
    occur.
    The "Abort" button in the search progress dialog should work as expected
    now (only displayed if the search takes some time to complete).

Options
    Made it possible to close or open all panels in options with two buttons
    located at the search field.
    
Fixed
    * Session issue with document views.
    * Open template file.
    * Some issues when creating new document.
    * Rare open file issue.
    * Convert HTML to text.
    * Offline - Beautify HTML (Tidy).
    * Wordwrap issues.
    * List text clip folder using keyboard shortcut.
    * Fixed a few issues in the text clips panel.
    * TclTk Code Explorer issue.
    * Other minor issues found and reported by email.

-----------------------------------------------------------
Version 15.23 (Nov 8, 2021)
-----------------------------------------------------------

FTP
    The program can sometimes "hang" when e.g. reading a remote directory list.
    This usually happens when trying to connect to the site.
    I've added a read timeout of 10 seconds, so if the read fails - you wont
    have to kill the program.
    
Misc
    The application is compiled and built using an updated version of Delphi. I also updated several components.
    
    Made several minor changes. Fixed some theme and high DPI issues ...

Fixed
    * Toggle column mode when using an alternative font.
    * Edit language server (LSP) settings.
    * Possible wordwarp issue.

-----------------------------------------------------------
Version 15.22 (Oct 20, 2021)
-----------------------------------------------------------

    * Strange display issue in search window when not using a theme.

-----------------------------------------------------------
Version 15.21 (Oct 19, 2021)
-----------------------------------------------------------

    
External document window (drag tab outside main window)
    Added a few new actions and menu items.
    
    * Format JSON menu.
    * Shift+Alt+Down/Up/Left/Right should work now.
    * Text display issues in search window.
    * Delete issue in search window and search bar.
    * Selection fold in plain text document should work now.
    * Issue with blank document at startup.
-----------------------------------------------------------
Version 15.20 (Sep 28, 2021)
-----------------------------------------------------------

Terminal panel
    The terminal panel can now open several tabs. You can split the panel and
    open tabs both to the left and to the right.
    You can also open Windows PowerShell tabs.
    
    To close a tab type "exit".
    
    Improved speed in the command prompt tab for large outputs like from the
    "dir" command. (Unfortunately, that doesn't work with the PowerShell tab.)

Toolbar images
    It is now possible to change the toolbar and menu image scaling in options,
    if you want larger images.
    
    The scale factor is given in percent. Available values are: 100%, 125%, 150%
    and 200%.

Document tabs drop down list
    Added an option to sort (or not sort) the drop down list, located in the
    document tab row.

Themes
    Added several new themes to the environment menu. The default theme for new
    installations is now Windows 10 Charcoal.
    
    The themes menu is now sorted and so is the themes list in the customize
    dialog window.

Moving between monitors
    Fixed a few issues when moving between monitors. Especially if they use
    different scaling (DPI).

Tools (Syntax Editor, Character Viewer...)
    Recompiled all tools using the newest version of Delphi and fixed a few
    issues.

Toggle comment
    Should handle indented comments as well as comments at the start of the line.
    
    Changed the toolbar icon.

Misc
    * Document tab context menu item "Reload as binary file" changes to 
      "Reload as text document" after being selected.

Fixed
    * Undo issues.
    * Reload as binary file.
    * Select color issues in CSS/LESS/SCSS files.
    * Text compare issues.
    * Saved document indicator issue.
    * Document tab issues when resizing the window or with minimize/maximize.
    * Fixed several minor issues while testing this new version.

-----------------------------------------------------------
Version 15.10 (Aug 28, 2021)
-----------------------------------------------------------

Terminal panel
    Added a new panel which works as a terminal window. It uses Cmd.exe in the
    background and should have most of the functions a real command prompt window 
    has, and more.
        
    The panel toolbar allows you to:
    
    * Enter a path manually in the combo box and move to it.
    * Select a favorite folder in drop down list and move to it.
    * Save current terminal directory as favorite.
    * Change terminal directory to the current document folder.
    * Open a folder selection window and change directory to it.
    * Change font (and background color if you're not using a theme).
    * Restart the terminal (restart cmd.exe).
    * Keyboard action to start an external terminal window. Set shortcut in customize keyboard.
    * Keyboard action to open/hide or show/close terminal panel. If the panel is
      auto hidden (minimized) the action will open/hide the panel. Otherwise it's
      closed or shown.
        
    Note!
    The panel use a standard windows edit control and only communicate with an
    open (hidden) command prompt window using standard input/output.
    There may be commands that doesn't work properly, like "more" (it displays all
    of the text at once, but you don't have the space bar control to switch page).
    Some special keys may work differently (since it's an edit control).
    
    Some features I had to add to the panel myself:
    
    * Command history (up/down arrow). It should work the same as in a real command
      prompt window. The command history is saved between sessions.
    * Auto completion (tab). Should work the same as in a real command prompt
      window.
    * Ctrl+C. Should work the same as in a real command prompt. If it doesn't work
      use the restart terminal button instead.

Terminal - PHP interactive shell (php -a)
    This should work fairly well, but it will never work perfectly over standard
    input/output.
    Up/Down arrows can be used for history and use "exit", or hit Ctrl+Z to exit
    the php interactive shell.
    
Terminal - Python interpreter mode (python or python -i)
    This should work fairly well, but it will never work perfectly over standard
    input/output.
    Up/Down arrows can be used for history and use "exit()", or hit Ctrl+Z to exit
    the python interactive mode.
    The help utility is supported as well and should work normally.

Language server templates
    Templates make adding language servers much easier. Once you've added a
    language server as a template you never have to add the server settings again.
    
    Several server templates have been added already for you to use. And you can
    easily change or add one yourself.
    
    Open LSP templates located in the environment menu to modify or add templates.
    
    You can add a language server as a template from project/sites settings if you've
    already added a server.
    
    Some environment variables can be used in paths:
    
    %appdata%       = <AppData>\Roaming
    %localappdata%  = <AppData>\Local
    %programfiles%  = c:\Program files
    %homepath%      = c:\Users\<username>

Text clips panel
    Changed the Keyboard action to open/hide or show/close terminal panel. If the panel is
    auto hidden (minimized) the action will open/hide the panel. Otherwise it's
    closed or shown.
    
    * Return key should now insert selected item and close/expand folders.
    * Select color issue fixed with themes.

Misc
    * Added a new command-line switch /NOREOPEN. It allows you to open the editor
      without reopen the last open files.
      The next time you open the editor without this option - the old last open
      files are reopened.
      
    * A few issues on high dpi monitors.

Fixed
    * A few reported issues from users.

-----------------------------------------------------------
Version 15.03 (Aug 4, 2021)
-----------------------------------------------------------

Fixed
    * Symbols drawn with incorrect colors.
    * Word wrap issue.
    * Minor hex view issues.
    * Misc issues reported by email.

-----------------------------------------------------------
Version 15.02 (July 25, 2021)
-----------------------------------------------------------

Fixed
    * Editing issues when text caret is allowed beyond end of line.
    * Several undo issues.
    * Disabled folder options when searching in open documents.

-----------------------------------------------------------
Version 15.01 (July 20, 2021)
-----------------------------------------------------------

Fixed
    * Highlight braces in word wrap mode.
    * Text caret movement in word wrap mode.

-----------------------------------------------------------
Version 15.0 (July 16, 2021)
-----------------------------------------------------------

HTML Preview
    for Microsoft WebView2 (Microsoft Edge component) instead.
    
    WebView2 is already installed on most Windows 10 systems and is built into
    Windows 11. The installer will check and ask the user to install WebView2 if
    needed (e.g. on Windows 7).
    This means I don't have to distribute large libraries in the installations
    anymore. The WebView2 component is also much easier to use. The old one had
    
    Chrome and Microsoft Edge use the same code base, so there is no difference in
    the displayed content.
    
    The Edge preview tab has a new button for "IE Mode". You can use it to display
    the content in a Internet Explorer view.
    
    and press the toolbar button "IE Mode".
Code completion
    Made some changes to the code completion. It should work better now and behave
    more as in other code editors.

Hover hint (LSP Client)
      - Code information presented by the server
      - Diagnostic errors, warnings, information or hints
      - Links. These can be code actions, goto definition, show references, rename identifier...

Highlight References (LSP Client)
    Highlight all references in the current document for the item found under
    the mouse cursor. This is similar to the find references feature, but the
    referenced identifier is highlighted and not added to a list.
    
    Highlight references can be found in the hover hint and right click context menu.
    
    In the context menu two items have been added:
      - Highlight references
      - Clear highlights

Code Actions (LSP Client)
    Code actions can be found in the hover hint and right click context menu.
    
    Code actions in the context menu include all available code actions presented
    by the language server.
    
    Code actions in the hover hint only include quick fixes.

Check for update
    Minor updates and beta version are downloaded and installed as before. But
    for major version the only option is to open the download site in your browser
    and download it manually. This was done to make the XP/Vista version consistent
    with the Windows 10/11 version and it also fix a few problems.
    It also allows the user to download and install the new version when they are
    ready...

Misc
    * Shift-DblClick can be used instead of Alt-DblClick if you have trouble with
      column mode is being activated.
      
Fixed
    * LSP functions didn't work properly in wordwrap.
    * Change case in column mode.
    * Font size issue in search result panel.
    * Fixed a few reported issues.

-----------------------------------------------------------
Version 14.90 (June 13, 2021)
-----------------------------------------------------------

Find References (View-Panels-LSP Client)
    This is a language server feature. It will list all references to the item
    under the text cursor. It can be a variable, function, object ...
    
    Menu item is found in the right click context menu (Find - Find References).
    
    The references tree will list file and references found in that file. Double
    click on an item to select it in the document.
    
Document Symbols (View-Panels-LSP Client)
    This is a language server feature. You can use the panel to display a hierarchical
    tree view of all classes, methods, properties etc. in a file or open document.
    
Symbol Search
    Another language server feature.
    The search box is located in the document symbols panel. The search is project wide
    and will list items found in both your project files and in library files.
    
    Some useful keys:
      - DOWN    Move down to the tree view below.
      - ESC     Clear search and change focus to the editor.
      - SPACE   Select focused item in the tree view, but keep focus on the tree view.
      - ENTER   Select focused item in the tree view and change focus to the editor.
    
Diagnostics (View-Panels-LSP Client)
    Another language server feature.
    The tree view will display diagnostic errors, warnings, hint and information
    found in any of the open documents.
    
    Diagnostics are also displayed in the code explorer, but only for the currently
    active document. The diagnostics panel display information from all open documents.

Rename symbol
    This is another language server feature. 
    The menu item can be found in the right click context menu. Use it to rename a class,
    object, method, field variable or any other symbol under the cursor. The 
    renaming is project wide, so all instances of the symbol will be renamed
    (even if the file isn't open).
    
Format document
    Another language server feature to format a selection, or the whole current
    document. The menu item is available in the right click context menu.
    A prompt asking for options is displayed when selecting the menu item.

Preview Commands
    Available in the HTML menu. Allows you to assign a file extension to
    a command used when previewing a file. The command can e.g. convert the current
    document to a HTML file and allow you to preview the converted file.
    
    Ex.
      Command:  showdown      
      Argument: makehtml -i "%s" -o "%d"
      
      "%s" = current document
      "%d" = converted HTML file used for preview
      
    This is used in all previews, e.g. live preview, internal browsers, browser tabs...

Fixed
    * Open local help file.
    * Temp files should be deleted and not moved to the recycle bin. 
    * A few reported issues.

-----------------------------------------------------------
Version 14.81 (May 23, 2021)
-----------------------------------------------------------

CSS/LESS/SCSS
    Made some changes to auto completion when selecting property.
    
Project todo panel
    Added a todo panel that list all project wide todos and notes found in your 
    project files.
    
    The listview display todo/note string, filename, path and the line number.
    
UI RTL support
    Made some changes to better support Arabic and Urdu languages in menus and toolbar
    dropdown menus.
    
Fixed
    * Some reported bugs.

-----------------------------------------------------------
Version 14.80 (May 12, 2021)
-----------------------------------------------------------

Language server (LSP) support
    It's now possible to use language servers with projects and sites.
    
    The language server will scan your project files (or site) and provide
    completion, mouse hover information, parameter hints and 
    diagnostics (errors, warnings, information, hints). And if the server supports
    it, find definition/type definition/declaration/implementation.
    
    You need to install the language server yourself. And when done, you can add 
    it to your project or site.
    The forum has a thread containing information on how to install different
    language servers and how to add them to your project or site.
    
    You can add several language servers to each project or site.
    
    The editor support stdio and tcp socket communication, so it should work with
    most language servers.

Misc
    * Made some changes to the JScript (JavaScript/Typescript) syntax file.
    * Made some minor changes in the C++ syntax file.
    * Added some hover hints for script elements.
    
Fixed
    * Navigation in explorer panel.
    * Favorites click in explorer panel.
    * Quick find icons.
    * C++ fold issue.
    * Several fold issues.
    * Duplicate line undo issue.
    * Find/Replace issue with line-feeds.
    * Find issue in hex mode.
    * Scrollbar issue when opening file in hex mode.
    * Fixed several reported issues.

-----------------------------------------------------------
Version 14.73 (Mar 2, 2021)

Script functions
    Added a few new functions to "Document" and "MainApp".
    
    * Document.Capitalize()
      Capitalize selection. Should work the same way as the menu item.
    
      Output a string and value to the message panel. "value" is a Variant and can
      be an integer, float, date, boolean or string.
      
      Output a string and values from public properties found in the object.
      "obj" can be any object, TStringlist, TElMenuItem...
      (Inherited fields and properties are not included in the output.)

Misc
    * Added script function "Document.Capitalize()".
    * Made a small change in how items are listed in project panel search.

Fixed
    * Window startup position on multi monitor setup.
    * Current folder toolbar icon not working properly in explorer panel.
    * Color dialog window background with some themes.
    * A startup issue.
    * Fixed many potential issues (compiler warning) in the code.

Version 14.72 (Feb 17, 2021)
-----------------------------------------------------------

Misc
    * Arabic was added to the list of available languages. 
    * Cpp syntax file was updated.
Fixed
    * SFTP issues when changing remote directory.
    * Lorem Ipsum in HTML menu could not be translated.
    * Exit compare mode error.
    * Change case functions in multi selection mode.
    * A startup issue where some file may not be accessible.
    * Minor issues in the Regular expression Creator.
    * Dual view action issue.
    * Error in customize keyboard shortcut window.
    * Redraw issue when a panel is hidden to a side.
    * Current file path in explorer panel toolbar should work now.
    * Delete issue when external document is visible (tab dragged outside the document area).
    * Save All enable issue when using multiple document views.
    * Close bracket issue in style section.

-----------------------------------------------------------
Version 14.71 (Nov 15, 2020)
-----------------------------------------------------------

New text clip commands
    Added commands to extract file name, file directory and file extension from a
    variable inside a text clip.
    
    It is possible to use one of the following commands with a variable containing
    a file path:

	#d	=	folder path (dir)
	#f	=	file name (without path)
	#e	=	file extension

    E.g.
    
    If we have a file variable defined like
     
    [[file]]	=	@fi[]
    
    Then, we can create a text clip like below:

    The file "#f[[file]]" is located in the "#d[[file]]" folder.
    
FTP panel (drag n drop)
    The FTP panel now accepts a document tab to upload the document to the
    currently open remote folder. 
    
SFTP
    Updated the libraries and component to the latest version.

Fixed
    * Scrollbar issue in explorer panel.
    * Rare brace matching issue that may occur with certain theme options.
    * Context menu items in sites panel should be disabled if no site is open.
    * Issue in editor component.
    * Issue when closing a cloned document.

-----------------------------------------------------------
Version 14.70 (Nov 2, 2020)
-----------------------------------------------------------

Chrome Preview
    Updated component and libraries to version 86.0.4240.

Open in new window (drag tab outside the main window)
    Added menus and most menu items found in the main window. Actions and keyboard
    shortcuts are added as well.
    
    Added a statusbar similar to the one in the main window.

Goto (Ctrl+G)
    Bookmarks are now listed in a list box for easier access.
    
Menu search box
    Added an option to auto hide the menu search box. It's opened and displayed
    by pressing CTRL+H.

Toolbar dropdown menus
    Made some minor changes to make it easier to handle highlighter and dictionaries.

Color background
    Background colors containing alpha values in CSS and HTML documents are now
    displayed with the base color as a frame around the colored background rectangle.
    
    Fixed some color inconsistencies in documents and the color select window.  

Script
    Document.Reload(true) will invoke a prompt to save changes before reloading 
    the document. Also fixed the warning message saying the document has been
    altered by an external program.
    
Misc
    * Replaced and updated several components.
    * Delete in sites panel should now move deleted items to the recycle bin.
    * Misc improvements on 4K monitors.
    
Fixed
    * Statusbar draw issues on 4k monitor.
    * Color hint and color dialog window issue.
    * A few code fold issues.
    * Ignore folds spanning less than x lines.
    * File explorer scrollbar issue.
    * Project manager search issue.
    * Sites panel issues.
    * Print preview issues.
    * Reopen documents at startup when search panel is visible.
    * A few close document issues.
    * Fixed misc reported issues.

-----------------------------------------------------------
Version 14.64 (Aug 23, 2020)
-----------------------------------------------------------

Indent lines
    Indent lines are now always drawn at a tab position, regardless of how
    your code is indented. This makes it easier to properly align your code.
    
Highlighting matching braces
    Matching braces are now underscored using the brace highlighting foreground 
    color, set in theme manager. And the brace background is set to the brace
    highlighting background color.

Compare files using external compare tool
    The document is saved if modified and the files on disk are used for comparison
    if possible. The editor should allow you to reload the document if it was
    changed by the external tool.
    
    Fixed a few issues.

Color dialog window
    Adding or pasting a color value to the edit box should work now as expected.
    
    Fixed a few issues.

Fixed
    * File Explorer panel refresh issue.
    * File Commander refresh issue.
    * PHP tag highlighting.

-----------------------------------------------------------
Version 14.63 (Aug 15, 2020)
-----------------------------------------------------------

Clipboard keyboard actions
    Added new keyboard actions to copy and paste from any user clipboard.
    Open "Customize keyboard..." to assign keyboard shortcuts to copy to clipboard x
    and paste from clipboard x.
    
Misc
    * Reduced flicker in customize keyboard list view when themes are used.

Fixed
    * File Commander error message.

-----------------------------------------------------------
Version 14.62 (Aug 7, 2020)
-----------------------------------------------------------

File Explorer Panels
    Updated the controls and fixed a few DPI issues when moving the program
    between monitors.
    
File Commander
    Updated the controls and fixed a view issue.
    
File modified by external program
    A warning is displayed if the file on disk has been modified by another
    has been modified.
    
    NOTE! If you reload the file you will loose all additions you've made since
    the last time you saved the document.

-----------------------------------------------------------
Version 14.61 (Aug 2, 2020)
-----------------------------------------------------------
Fixed

-----------------------------------------------------------
Version 14.60 (Aug 2, 2020)
-----------------------------------------------------------

Chrome Preview
    Updated component and libraries to version 83.0.4103.

    Made some extensive changes to the download/upload threads. They should
    display a more meaningful progress dialog window, be much faster and handle
    hidden files and folders.
    
    All FTP operations should handle hidden files and folders properly now. That
    includes the sites panel and synchronizations.    

Code folding and syntax files
    Made a complete re-write of the code folding feature. It is now (mostly)
    files for the folding to work.
    
    If you need to tweak it a bit and add items to the code explorer - you still
    
    Line comments spanning more than 3 lines are now fold-able as well as normal 
    block comments.
    
    Indention based folding can be turned off in the syntax file 
    (fold options section). This can be useful when you only want a few elements
    to be foldable and you want to use a specific start and end.
    It is also possible to turn off folding of line comment blocks.
    
    All syntax files have been updated.
    
    Fixed several issues with the code explorer.
    
Code folding options
    Added new options to reduce the number of folds displayed.
    
    * Only display necessary folds like for classes and methods...
      Use this to hide some folds like if statements and loops.
      
    * Ignore folds spanning less than x lines. Default is 5.
      Important folds like classes and methods are always displayed. But other
      smaller folds are ignored if they span less than the specified number of
      lines.
      
    Both options can be very helpful if you find the left margin cluttered with
    fold icons. They can both greatly reduce the number of folds and fold icons
    displayed.

Code fold icons
    Added a few smaller versions of existing fold icons. You can select them
    in the theme manager.
    
High DPI and themes
    Fixed several theme issues on high DPI screens and when moving between
    monitors.
    
    Most themes (vcl styles) have been updated to newer versions which include
    high resolution bitmaps for use on high DPI monitors. 

Theme manager
    Made some small changes and made some improvements to the theme preview on
    high DPI monitors.

Emmet Abbreviations
    Single quotes in custom attributes should expand properly now.
    E.g. td[title='Hello world!' colspan=3]

Fixed
    * Several code explorer issues.
    * Several code folding issues.
    * Close file(s) issue.
    * Copy and paste issue.
    * Dead files in projects.
    * Issue when using virtual desktops.
    * Syntax highlight issue in CSS and LESS.
    * monitor current file issue.
    * Synchronized scroll issues.
    * Shell context menu issues.
    * Save status for plain text files.
    * Theme loading issue.
    * Many misc issues reported or found during testing.

-----------------------------------------------------------
Version 14.52 (May 25, 2020)
-----------------------------------------------------------

Online validation (HTML, CSS)
    Added new online validators to the HTML menu.

    Validators are: HTML5 Validator, W3C HTML Validator and W3C CSS Validator.

Programming ligatures
    Programming ligatures should display properly now after some minor changes.
    Ligatures are used with fonts that supports them, like Fira Code or 
    Cascadia Code.
    
New Options
    * Close editor if all open files are closed.
    * Allow one instance on each virtual desktop (Windows 10).
      This option only work if you close all open instances and restart the editor.

Misc
    * Rearranged a few menu items in the HTML menu.
    * Made changes to the line diff view in compare documents view.

Fixed
    * Clipboard issue with very large clips.
    * SFTP download issue (and drag n drop).
    * Misc reported issues.    

-----------------------------------------------------------
Version 14.51 (May 12, 2020)
-----------------------------------------------------------

Misc
    * Updated a few visual components.
    * Changed toolbar images in print preview.

Fixed
    * Error message that may occur using the 32-bit version of the program.
    * Call stack issue with bug reports on the 32-bit version.
    * An issue with manually changing highlighter.
    * Some High DPI issues in print preview window.
    * Fixed a few help hints in options (translations are still missing).

-----------------------------------------------------------
Version 14.50 (May 9, 2020)
-----------------------------------------------------------

Chrome Preview
    Updated component and libraries to version 81.0.4044.

Code hints
    Added code hints. Hover the mouse over a tag, CSS property, method or 
    function name to display information about it. In HTML hints are displayed for
    both tags and attributes.
    
    The hint may contain a description, return value, parameters and example code.
    
    A code hint is also displayed when an item is selected in auto completion list box.
    
    For this to work the [Hints] section in the syntax file must contain the
    function i question. 
    
    Updated syntax files are: Cpp, python, css, less, sass, HTML, JavaScript, PHP.

Image hints
    Image hints are displayed when you hover the mouse over an image link.
    The hint will display a miniature of the image.
    
    You can turn this off this hint in options.

Hints and options    
    The editor is now able to show the following hint types:
    
    Code hints
        Hover the mouse over a function to display information like
        parameters and description.
                
    Parameter hints 
        Press Ctrl+Shift+H or type "(" to display a hint with all parameters.
                     
    Color hints
        Hover the mouse over a color value to display the color in different
        formats. Click on a format to convert the value or on the color box
        to open the color dialog window.
        
    Image hints
        Hover the mouse over an image link to display a thumbnail.
        
    You can set which hints should be enabled in options and also decide whether
    the code or parameter hint should be displayed above or below the code.  

Auto completion
    Auto completion can now include Emmet abbreviations. The hint will display
    the expanded code.

    In HTML you can now type a letter and press CTRL+Space to get a list of
    tags and Emmet abbreviations beginning with that letter.
    
    This is turned on by default but you can change that in options.

Auto completion speed
    Optimized a few functions and the auto completion should be way faster
    than before.

    Added a new toolbar placed between the two documents being compared.
    The toolbar contain most functions available in compare mode like copy
    difference left or right, move to the next or previous difference, save
    diff file...

Syntax Editor
    Made several changes to the syntax editor to handle the changes made to the
    syntax files. The hints page has been redesigned and some changes were made
    when adding items to the class completion and user menu sections.
    Added two new toolbar buttons to the save remote dialog box. 
    "New folder" and "goto parent folder".

Fixed
    * Open file issue after closing document views.
    * Theme manager high DPI issues.
    * A few Emmet expand abbreviation issues.
    * RegEx search issue.
    * Problems with sessions.
    * Create new file panel issues.

-----------------------------------------------------------
Version 14.41 (Feb 25, 2020)
-----------------------------------------------------------

Line number hint
    Added a line number hint when scrolling using the mouse. The hint is
    displayed top right in the editor window. When the document map is visible
    it's displayed to the left of the document map.

    Added a context menu item to display synchronize info for selected file.
    The message window will tell you if the file on local and test/remote site
    is synchronized, if the file has been changed on either side, and which one
    appears to be newer.
(S)FTP synchronize
    Fixed several issues with file synchronization in sites panel and file commander.

Recent files drop down list
    Made several visual and behavioral changes. 
    
    * Mouse tracking will no longer scroll the list.
    
      has been checked and you enter select mode. 
      In select mode all check boxes are displayed.
    
    * When in select mode (check boxes are visible) you can use shift+mouse or
      ctrl+mouse to select items. List items will behave as in windows explorer.
      A single mouse click on an item outside of the check box will deselect all
      items and exit select mode.

Fixed
    * Misc minor issues.

-----------------------------------------------------------
Version 14.40 (Feb 11, 2020)
-----------------------------------------------------------

Chrome Preview
    Updated component and libraries to version 79.0.3945.

FTP SSL
    Made some changes and fixed a few issues. Both SSL explicit and SSL implicit
    connections should work better now.
    
    If the server certificate isn't deemed valid during the validation process, a
    window is opened containing information about the certificate - allowing the
    user to examine the certificate and except or abort the connection.
    If the user accept the certificate - the decision is remembered and the certificate
    window is not presented again.  

FTP profiles
    Made some minor visual changes in dialog windows.

Document Views
    Changed the document view layout. Views are now aligned in a maximum of three
    columns. Each column can have two views (top and bottom).
    It may seem similar to how it worked before and most users may not see any
    difference. But some layouts are now possible, that wasn't previously. The 
    document view drop down selector should be more intuitive to use as well.

File open dialog window
    Added a new option to add opened files to the most recently used list (MRU).
    This is, of course, the standard behavior. But the option allows you to open
    files without adding them to the MRU list.

Emmet
    Added support for markdown files. Supported abbreviations are:
    a           = link
    b           = bold
    bq          = blockquote
    code        = inline code snippet
    h1..h6      = heading. E.g. h2 = ## Heading 2
    hr          = horizontal rule
    i           = italic
    img         = image
    ol          = ordered list
    pre         = code block with language based highlighting
    strike      = strike through
    table       = table
    ul          = unordered list
    @l or @l80  = create lorem generated text

Misc
    * Toolbar button for Character viewer was added. Enable in "Customize toolbars...".

Fixed
    * Site synchronize issues.
    * Site synchronize exclude issues.
    * Minor issue in sites options.
    * Minor mouse cursor issue over auto completion list box.
    * Auto completion with array [].
    * Compatibility issue with WordWeb and default shortcut (Ctrl+Alt+W).
    * A few menu language issues.
    * Undo issue in column mode.
    * Run script issue.

-----------------------------------------------------------
Version 14.30 (Jan 15, 2020)
-----------------------------------------------------------

Chrome Preview
    Updated component and libraries to version 78.0.3904.
    
Remote files (S)FTP
    Added menu items to upload current document to a remote server.
    
    You can still save to a remote server. 
    
    The difference between upload and save is that if you upload
    to a remote server - the document is still saved to a local folder.
    But if you save to a remote folder - the document is then always saved to that
    remote location.
    
    * The option "Save to remote location" should now always allow the document
      to be saved to it's last saved location. E.g. if you save to a remote server - 
      the document is always saved to the remote location.
      
Sites panel
    Added a new panel to handle web sites.
    Create a new site by adding a name for the site, add local, remote server
    and test server locations. The remote and test server locations is selected
    using a remote folder dialog window. This allows you to select the (S)FTP profile 
    to use with the site. New sites are listed in the drop down menu.
    
    * Local site
      This is were you store the site on local disk for editing.

    * Test site
      You can use a test server for testing your site before publishing it.

    * Remote site
      This is where you publish your web site.
      
    * Active Remote site
      On the toolbar buttons you can see a yellow dot marking the active remote
      site. All transfers will commends between the local and active site.
      E.g. if the test server site is active - all uploads, downloads, synchronize
      operations etc. is done between the local site and the test server site.
    
    * Site panel toolbar
      Open an existing site from the drop down menu.
      From the site panel you can upload, download files and folders. Or you can
      synchronize local and remote folders. The synchronize feature will
      either synchronize the entire web site, except folders you have excluded in the
      synchronize dialog window, or synchronize the files and folders you have 
      selected.
    
    * Context menu
      The context menus contain menu items to cut, copy and paste selected files
      and folders. You can copy and move files between the local folder and any 
      remote location. Or you can copy and move files between locations on the
      local or remote site.
    
      Duplicate allows you to duplicate selected files and folders.
      Rename allows you to rename any file or folder.
      Delete allows you to delete selected files and folders.
      Permissions allows you to change remote file and folder permissions.
    
      Open in browser will open the selected local or remote file in an web browser.
      For this to work with remote files - make sure you add a web path in the site
      settings.

File commander (upload, download and sync)
    File date and time information is now stored inside XML files. It's now
    possible to use the same local web site and sync it to several remote locations.
    This is useful if you have the same site under different domains. 
    E.g. www.dummy.com, www.dummy.org, www.dummy.eu ...
    
    You can choose if you want to synchronize the currently opened folders or
    synchronize selected files and folders.
    
    Made several optimizations. All operations should be much faster now.
    
    Fixed several issues found when writing the new code and when testing.
    
Site and file commander sync dialog window
    only synchronize selected files and folders.

Enclose toolbar dropdown menu
    Added a new toolbar button to the main toolbar that opens a dropdown menu
    for enclosing selected text. The dropdown menu contain many different quote
    types and braces.
    
    The same toolbar button is available in the user toolbar.
Misc
    * Macro edit window is now sizable and can be maximized.
    * Search dialog window should open faster now (made some optimizations).
    * Reduced flickering when resizing the main window.
    * Updated the Pearl syntax files.
    
Fixed
    Fixed a large number of reported issues.

-----------------------------------------------------------
Version 14.20 (Oct 7, 2019)
-----------------------------------------------------------

    Updated component and libraries to version 76.0.3809.
    
SFTP
    Updated the SFTP component to the latest version.
    
    Fixed several issues.

Remote files
    Added options (default actions) in "Options - File - Remote files" to set the default action 
    when saving remote files. The options are:
    
    Use this option if you want to save both local and remote files to a local disk. In this 
    working mode you can edit remote files and store them locally until they are 
    ready to be uploaded. You can use the menu items in "File -> FTP" to upload 
    the files. You can also use the file commander.

    Local files are always saved locally. Remote files are saved (uploaded) to 
    the server. This is the default behavior.

      + If you create a new document and upload it to a server - the file will always be saved to the server.
      + If you open a remote file and save - it will always be saved to the server.
      + If you create a new document and first save it locally and then upload it - it is considered a local file and always saved to disk.
      + If you open a local file and upload it to the server - the file is still considered local and always saved to disk.

    * Save to both local and remote location
    to a server - it will always be saved to both the local disk and uploaded to 
    the server. It doesn't matter if the file was opened from disk or the server. 

      + If you create a new document and upload it to a server - the file will always be saved to both disk and server. If a local path doesn't exists - a file save dialog window is opened.
      + If you open a remote file and save - the file is always saved to both disk and server. A save file dialog window is displayed if needed.
      + If you open a local file, that has previously been saved to a server - it will always be saved to both disk and server.

    * Ask me once for every new (or opened) document
    With this option set you are prompted for an action when you hit save. The 
    actions are the same as in options above. 
    The action is remembered as long as the document is open. 
    
    Made several changes to improve the user experience when using the different
    options. Document tab hint now display both local and remote paths.

Search (All open files)
    Find and replace can now be used on all open files. Find or replace
    start at the current cursor position and circle through all open document tabs.
    
    To use it just set the search scope to "All open files".
    
    Added two new options (Options - Search):
    * Limit find/replace search scope to current document view
    * Limit find/replace all search scope to current document view

Highlight Expressions
    Added expressions are now stored between sessions. A checkbox is used to
    activate an expression to highlight, for the current file.
    
    Active highlighted expressions are now stored between sessions for 
    each file. You can activate/deactivate this in options, with other file
    options like store wordwrap state, encryption, code fold state etc.

Document tabs
    Added an option to change the tab position. You can set the tab position
    to the top, or to the bottom of the document window.

Tools
    Added a new type to send POST requests. It is used to post the current document 
    or a selection to a web address and open the returned text in a new 
    document tab.
    
    I also added two new presets. One will add the following:

    Title:      'JavaScript Minifier'
    Type:       'Send POST request to URL'
    Command:    'https://javascript-minifier.com/raw'
    Argument:   'input=[CurrentDocument]'

Misc
    * Several speed improvements and optimizations.
    * If save fails you are asked if you wish to restart the program in administrator mode.

Fixed
    * Document view draw and resize issues.
    * Browser preview panel issues.
    * Misc language issues.
    * Path display when all files are closed.
    * Program search issue.
    * Numerical statistics in column mode should handle leading or trailing non-digit values.
    * Search bar issues.
    * Misc reported minor issues.

-----------------------------------------------------------
Version 14.12 (Aug 20, 2019)
-----------------------------------------------------------

Highlight Expressions
    Added a new function in the "Search" highlight menu. In the opened dialog
    window you can add as many text strings or regular expressions as you like.
    Each expression will be highlighted using a set text and background color.
    
    You can set individual options for each expression, like
    
    * Case sensitive
    * Match whole words
    * Regular expression
    
    You can also set individual text and background color for each expression.

Hint on auto hidden panels
    Added hints to auto hidden panels with no caption (only the image is visible).

Fixed
    * Minor search bar issues.
    * Theme issue in Windows 7.
    * Add to project with delayed opening of files.
    * Printer setup issue.

-----------------------------------------------------------
Version 14.11 (Aug 10, 2019)
-----------------------------------------------------------

Dual document view
    A prompt is shown when closing the dual document view. The prompt lets you
    move or close the document tabs.

Replace All in hex view (binary files)
    Made some changes to the "Replace All" code and changed how the output is
    displayed.
    
    Fixed a few issues and improved performance.

Fixed
    * Issue with minimize if all documents are closed and dual document view.
    * Hex view replace all issues.
    * Several issues (exception errors) reported by users.

-----------------------------------------------------------
Version 14.10 (July 28, 2019)
-----------------------------------------------------------

Document views
    It is now possible to open up to six document views. They can be opened on
    two rows and each row can contain one, two or three views.
    Each row is independent so you can have two document views at the top row,
    and three at the bottom.
    
    Document views can be handled using a toolbar button, or from the "Window" menu.
    
    Everything should work as in dual document view. Drag n drop, text compare,
    sync scrolling, close and move tabs ...

Emmet filters
    Emmet abbreviations can now handle filters. A filter is added at the end of 
    the abbreviation using a pipe |. 
    E.g. ul>li*|t

    Available filters are:
      c - Comment important tags (containing class or id attributes).
      e - Escape XML-unsafe characters: <, > and &. E.g. <p>|e => &lt;p&gt;&lt;/p&gt;
      s - Single line. Expand everything to a single line of code.
      t - Trim line markers from wrapped lines e.g. * or 1.
      w - Wordwrap selected or lorem generated text. Default width is 80.
      w120 - Wordwrap at column 120.

      Ex.
        Abbreviation: ul>li*|t

        Selection:
          * Line 1
          * Line 2

        Result:
          <ul>
            <li>Line 1</li>
            <li>Line 2</li>
          </ul>
          

Emmet options
    A config file is available from the Format->Abbreviations menu. The config
    file contain some option you can set for different highlighters.
    
    Options available are:
    
    AlwaysAddNewLine:    Always add linefeed after each tag (usually used in XML)
    CommentTags:         Comment important tags (containing class or id attributes).
    IndentChilds:        Indent child tags. If you set this to false - no indention will be used.
    SingleLine:          Expand everything to a single line of code.
    Wordwrap:            Word wrap selected or lorem generated text.
    WordwrapAt:          Wrap at given column. The nearest space or symbol will be used as wrap position.

Search result option
    Added an option to use double click to open found items, instead of single click.

Fixed
    * A close document exception error.
    * Code explorer issues.
    * Wrap with abbreviation hint issue.
    * Print issue with page ranges.
    * Minor find issue.

-----------------------------------------------------------
Version 14.03 (June 30, 2019)
-----------------------------------------------------------

Fixed
    * Open files from minimized state.
    * Reopen project and project files at startup.
    * Misc issues found while examining the code.

-----------------------------------------------------------
Version 14.02 (June 26, 2019)

Fixed
    * Text caret issues with word wrap and last open documents.
    * Strange save issue that may occur if you try to exit the program, but 
      cancel when saving your work.
    * Context help issue in options.

-----------------------------------------------------------
Version 14.01 (June 23, 2019)
-----------------------------------------------------------

Fixed
    * Internal Chrome browser crash.
    * Some misc document map issues.
    * Open as binary file issue.
    * Copy in message panel.
    * Open files from minimized.
    * Hex view issue.
    * Misc issues reported by users.

-----------------------------------------------------------
Version 14.0 (June 18, 2019)
-----------------------------------------------------------

Chrome Preview
    Updated component and libraries to version 74.0.3729.

Markdown
    Added a Markdown syntax file. It should highlight most elements and add
    code folding.
    
    Shift+Space list (auto complete list) contain some useful commands.
    
    Updated the Markdown to HTML conversion and improved the browser preview.
    The CSS file used to add styles to the output is found in 
    "<AppData>\Roaming\RJ TextEd\Data\markdown.css".

Delay opening file until tab is active
    Added an option to delay the loading of a file until you click on the
    tab or activate the document tab in any other way. This makes opening
    files much faster.
    
    Tabs with not yet opened files have there file name enclosed with **, so
    you can see which documents have yet to be opened. E.g. **My file**
    
    The option is off by default in the final version.

Search bar
    Redesigned the search bar and added a new toolbar for folder options. 
    It's only visible when searching folders.
    
    Fixed a few issues as well.

Message panel
    Added a context menu item to copy selected lines, or copy the current line
    if nothing is selected.
    
    You should also be able to use keyboard shortcuts for copy and select all
    (Ctrl+A, Ctrl+C).

Emmet
    Added standard vendor prefix "-" to CSS. E.g. -bdrs (which works the same as -v-bdrs).
    
    Wrap with Abbreviation
    Added support for placeholders $#.
    The placeholder is replaced with one line of selected text.
    
    E.g.
        Abbreviation
            ul>li[title=$#]*>{$#}+img[alt=$#]

        Selection
            About
            New
            Products
            Contacts

        Result in
            <ul>
              <li title="About">About<img src="" alt="About" /></li>
              <li title="New">New<img src="" alt="New" /></li>
              <li title="Products">Products<img src="" alt="Products" /></li>
              <li title="Contacts">Contacts<img src="" alt="Contacts" /></li>
           </ul>
    
    Fixed several issues and updated the snippets.ini file.

Select Brace Enclosed
    Should work now with plain text. Supported braces are (), [], {} and "".
    
Tools
    Added a few presets that can be used when adding new tools. It's only
    a few. I'll try to add more in later versions.

Fixed
    * Shortcut issues with dragged out editor window.
    * Temporary background save issues.
    * Text cursor position and tab issues when document map is visible.
    * Startup issue if floating panels are found.
    * Chrome preview issue at close down.
    * Update issues.
    * Search bar issues.
    * Home page issue with selecting files.
    * Other misc issues reported by users.

-----------------------------------------------------------
Version 13.90 (May 9, 2019)
-----------------------------------------------------------

I've written my own version of Emmet in Delphi (object pascal). It's not based 
on the Emmet JavaScript plugin code at all, so there are some minor differences and probably 
some things not implemented (yet).

The Delphi version is compiled to native machine code which makes it much much faster. 
And it enables me to add some new functionality. It also works on Windows XP.


Abbreviation auto completion list
    Press ALT+ENTER to display all available abbreviations from the text clips panel, 
    Emmet snippets and Emmet abbreviations in a list. The list will also display any
    favorites you may have added.

    Press ENTER to select an abbreviation. It's inserted as is and not expanded. 
    This allows you to combine abbreviations and snippets to create your own abbreviation.
    To expand the abbreviation - press SHIFT+ENTER.
    
    If text is selected - the abbreviation will wrap the selected text.
    
    E.g. if the lines below are selected:
    
    1. First line.
    2. Second line.
    
    and you select an abbreviation favorite like "ul>li*", the selection is replaced
    with
    
    <ul>
      <li>1. First line.</li>
      <li>2. Second line.</li>
    </ul>
    
    when you hit ENTER.

Abbreviation hint
    Press SHIFT+CTRL+ENTER to show a hint displaying what the expanded code will look like.
    To expand the abbreviation you can just press ENTER (as long as the hint is visible). 
    You can also use SHIFT+ENTER to expand the abbreviation.

Expand abbreviation at cursor
    This function will now expand both user defined abbreviations in the text 
    clip panel and Emmet abbreviations. Type an abbreviation in your document. 
    E.g. "ul>li*5" in an HTML document or "for" in a PHP document. Press SHIFT+ENTER to expand the abbreviation.
    
    If you set a key as a trigger - you can use that as well to expand the abbreviation. 
    E.g. the TAB key.

    Note that you can use SHIFT+CTRL+ENTER to preview the abbreviation before 
    expanding it.

Expand abbreviation using input box
    preview the result.
    Open as normal with CTRL+, and enter your abbreviation inside. A hint pops up 
    showing the expanded code.

    The hint is displayed when you wrap with abbreviations (SHIFT+CTRL+,) as well.

    Move the text cursor to the next tab position using the TAB key. 

    A tab point can look something like this: {#1} or {#2: Document}. 

    If the tab point contain text e.g. {#2: Document} contain the text "Document", 
    it will be selected when moving to the tab position.
Vendor prefix in abbreviations
    In e.g. CSS you can start an abbreviation with a vendor prefix.
    
    E.g. 
        -moz-ac     expands to -moz-align-content: ;
        -webkit-ac  expands to -webkit-align-content: ;
        ac          expands to align-content: ;
        
    There are 3 special abbreviation prefixes you can use to expand into different 
    properties with different vendor prefixes. -v-, -w- and -m-.
    
    E.g.
        -v-ac
            -moz-align-content: |;
            align-content: |;
        
        -w-ac
            -webkit-align-content: |;
            align-content: |;
        
        -m-ac
            -moz-align-content: |;
            align-content: |;
            
    Note that | is a multi cursor position so you can edit all lines at the same
    time.
Abbreviation favorites
    Favorites are display at the top of the abbreviation auto complete list (ALT+ENTER).
    Manage favorites in the abbreviation input box (CTRL+,).

Find and Replace options
    Added two new options to skip strings or comments when finding a match.
    The options only affect documents that are already open. They are not available
    
Fixed
    * Move line up/down in a detached editor window.
    * Decimal issue in convert panel.
    * Issue in regular expression creator.
    * Spell check issue.
    * Misc issues found while coding or reported by users.

-----------------------------------------------------------
Version 13.81 (Mars 29, 2019)
-----------------------------------------------------------
Fixed
    * HTML/CSS preview issue.
    * Hex view issues with XML files.
    * Some language string issues.
    * Minor issues in syntax editor.

-----------------------------------------------------------
Version 13.80 (Mars 25, 2019)
-----------------------------------------------------------

Chrome Preview (Chromium)
    Updated libraries and component to version 73.0.3683.75.

Code explorer favorites
    It is now possible to add classes, functions, properties, tags etc. to a 
    favorite list. Favorites and TODO:s are displayed in the same pane, but in 
    different tabs.
    
    The mouse hint can display more information, like which class a method belongs
    too.
    
    Favorites can be removed or clear using a right click context menu.
    
    NOTE! Favorites are connected to a document and only available as long as 
    that document is open. 

Find/Replace
    Changed how auto completion in search fields work when pressing UP and DOWN
    keys. Only items beginning with the entered search term is displayed. All
    other items in the drop down history list is ignored.
        
    This change only work if the drop down list is closed (auto drop down disabled).
    
    If auto drop down is enabled the drop down list is now sorted.

Replace field option
    Added an option to have an empty replace string every time a search window
    or search-bar is opened.

Misc
    * The options window should open faster in this version.

Fixed
    * File may randomly open as binary file in hex mode.
    * Possible replace tool window issue.
    * Find issue in hex mode.
    * A few redraw issues in character viewer.
    * Update issue in Windows XP/Vista (introduced in v13.73).
    * Many minor issues found during development and reported by users.

-----------------------------------------------------------
Version 13.73 (Mars 9, 2019)
-----------------------------------------------------------

Selection color
    The editor should now use the selection colors set in themes manager
    with all texts and fonts. Even if a variable width font or a complex
    text script is used, like Hebrew or Arabic...

Major updates
    Major updates will be downloaded from Fosshub in the feature. Minor updates and
    beta versions are still downloaded from the main site. The update procedure 
    is almost the same as before. But with major version updates,
    the update window will display the Fosshub site were you click on the
    version you want to install. The rest is exactly as before.
    
    I changed this because my web hotel can't handle the bandwidth.

Fixed
    * Minor theme color issue with hints in open/save dialog windows.
    * Tab key issue in search bar.
    * Some issues reported by users. 

-----------------------------------------------------------
Version 13.72 (Feb 28, 2019)
-----------------------------------------------------------

Window menu
    Added new menu items to pin or unpin left, right and bottom panels. The menu
    will not close any panels. Just open and pin them, or hide (unpin) them.
    
    Note that it doesn't works if e.g. all left side panels are closed.

Keyboard shortcuts
    Added new keyboard actions to open or hide left, right and bottom panels. Actions
    will not close any panels. Just pin or unpin them.

Fixed
    * Maximize window issues when using themes.
    * Minor replace dialog window issues.
    * Added some missing entries in the language files.
    * Some minor draw issues when switching between text diff mode.
    * A few minor misc issues throughout the application.

-----------------------------------------------------------
Version 13.71 (Feb 18, 2019)
-----------------------------------------------------------

Fixed
    * Left margin update and redraw issues.
    * A (rare) fold highlight error that may occur in some situations.
    * A few SFTP issues, including "Save As (Remote)".

-----------------------------------------------------------
Version 13.70 (Feb 15, 2019)
-----------------------------------------------------------

Chrome Preview (Chromium)
    Updated libraries and component to version 72.0.3626.

Fold highlighting
    Completely redesigned the fold highlight feature.
    
    If the text cursor is inside a foldable area - the fold node icon and
    left margin line color, within the current fold, change to a color set in the 
    themes manager. 
    
    The default Windows theme color is black and gray and for most
    dark themes it is set to white and silver. You can change it to anything you
    want in the theme manager (syntax highlighting section).
    
    The current fold is also displayed in the annotation bar.

Script functions
    Added a few new function to the "MainApp" object.
    
    * MainApp.JSON_Minify()
    * MainApp.JSON_PrettyPrint()
    * MainApp.HTML_TidyHTML()
    * MainApp.HTML_TidyXHTML()
    * MainApp.HTML_TidyXML()
    * MainApp.Sort_Ascending()
    * MainApp.Sort_Descending()
    * MainApp.Sort_AscendingNumeric()
    * MainApp.Sort_DescendingNumeric()

Running on Linux Wine
    File explorer panels and file commander should both work now on Linux.
    Made several UI and font changes to improve the experience when running on 

    Tested on Linux Mint 19.1 Cinnamon (Wine 4.x - emulating Windows 7) using 
    both 32-bit and 64-bit versions of the program.

High DPI
    Fixed a few dialog window issues.

Program styles
    Added a few new styles you can use when creating your own themes.

Misc
    * Made visual changes to the font drop-down lists in options.

    * Title bar font should be the same as the GUI font set in options.
    * Color select issues in themes manager.
    * Save diff file issue.
    * Code fold draw issues.
    * Word count should include single digit numbers.
    * Some compare document issues.
    * Reload document issue.
    * Code explorer issue with Java.
    * File commander toolbar icon issue.

-----------------------------------------------------------
Version 13.61 (Jan 22, 2019)
-----------------------------------------------------------

    Made extensive changes to handle high DPI and 4K displays. Everything
    should be displayed properly now even if you are using themes.
    
    * All window title bar elements should scale properly throughout the application.
    * All message windows should scale properly.
    * File open/save windows should scale properly.
    * All elements in the "Home" page should scale properly.
    * Replaced several components.
    * Fixed several minor issues throughout the program.

Search options
    Added a new sub option to the search field auto completion option. If enabled it
    will auto drop down the search field list.

    Changed how line numbers for the current line is displayed in wordwrap
    mode.

Fixed
    * Exception errors in "Tab color" dialog window.
    * TODO list button issue in code explorer panel.

-----------------------------------------------------------
-----------------------------------------------------------

GUI changes
    Made several changes to fix some high DPI issues when moving the program
    between monitors.
    
    Changes were made in options, search-bar, search window and addons.

Replace and preserve case
    Added a new option to preserve case when doing a replace.
    The find string is used to find a string in your text, just as usual. The
    case of the found string is then used to create a replace string, were the
    
    Ex.
    Find: "member_name"
    Replace with: "auth_fullname"

    Result
        member_name => auth_fullname
        Member_Name => Auth_Fullname
        MEMBER_NAME => AUTH_FULLNAME

Replace prompt or tool window
    Added options to choose if you want a prompt dialog box, or a tool window 
    to appear when executing replace using the modal search window.
    
    Prompt dialog box
        This dialog box is displayed every time a string is found to ask the user
        to replace the string, or not.
        
    Tool window
        The tool window remains open as long as strings are found, or the user closes
        the window. It contain buttons like [Find Next] [Replace] ...
        This is now the default window used when executing a replace.
    
    Note than none of these options affect the search-bar behavior in any way.

Regular expressions
    Changed the component and replaced regex functions throughout the program.
    The new component is using the open source PCRE library (v8.42).
    
    Made some minor changes in the "Regular expression creator".
    
Multi edit and multi selection in overwrite mode
    This was never implemented in earlier versions when adding multi editing and
    multi selection capabilities to the editor. But, now it's finally been added.

SFTP
    Updated the SFTP component to the latest version.

Reopen remote files
    The option to "Reopen last open documents at startup" - only reopen local 
    files. I've added an sub-option to include remote files as well.
    It's turned off by default.

External document
    Fixed several issues when dragging a document tab outside the main window.
    
    * Document map issues.
    * Document map hint issues.
    * Navigation keys not working properly.

Document map
    Improved performance when document map is visible.

Toolbar button hints
    Added current project name to all project toolbar button hints.
    Added current macro name to the macro play toolbar button hint.

Misc
    * RJ TextEd should be displayed now when adding default apps for extensions in Windows.

Fixed
    * Auto complete issues in search edit fields.
    * Issue with "Document has been changed by external..." warning.
    * Minor find/replace issues.
    * Page up/down issue when vertical scrollbar is hidden.
    * Document map issue with minimize to system tray.
    * Some undo/redo issues.
    * Some document map and hint issues.
    * Find / replace issues with binary files.
    * Some issues with remote files (FTP, SFTP).
    * Highlighter issues.
    * /MONITOR command line option.
    * Find issue in hex mode.

-----------------------------------------------------------
Version 13.50 (Nov 29, 2018)
-----------------------------------------------------------

Chrome Preview
    Updated all files and components to version 70.0.3538.

GUI components
    Updated several GUI components to the newest version.

Text clip and abbreviation synchronization
    Added a synchronize sub-menu to the more menu on the text clips panel.
    
    You can synchronize abbreviations and clips manually by selecting
    "Synchronize now...". This will sync files to the ones stored in a shared
    folder.
    How the local and remote data is updated depends on your settings.
    
    Options are available in two sections. Manual and auto sync settings.
    
    Manual synchronize may be safer to use in a large organization. Especially if
    more than one user is able to save to the shared folder.
    You should also be careful with the "Allow delete" option, since it may remove
    clips you just added.
    That doesn't mean you can't use auto sync. You just have to be careful of
    who is able to save to the shared folder and mind your settings 
    (delete option).
    If all users are allowed to save and everyone disable the settings to delete
    clips when syncing, nothing will be lost. Everyone is just adding to the shared
    clips. But that also means you may not be able to remove any clips. After
    the next sync - they will be added from the shared clips.
        
    Auto synchronize will periodically read from the shared folder and sync your
    local clips based on your settings. If "Allow save" is enabled - all your 
    clips are then saved to the shared folder.     

Text clip panel
    Added items are now properly sorted.
    
    Fixed a few issues.

Open and save dialog windows
    With newer versions of Windows 10 the light/dark Windows system themes now 
    change the colors used in the open/save dialog windows. To fix some draw
    issues when using program themes in the editor - I had to make some changes
    to the style hooks used to retrieve system colors and draw theme elements. 

Home tab
    Made several design changes to make it easier to navigate using keyboard.
    I also added check boxes on the recent files tab.
    
    The search on all tabs have been replaced by a fuzzy search.
    Fuzzy search will find all items with entered letters in correct order. Then
    order them depending on relevance. The most relevant items at top. 
    Relevance is decided by factors like found string in the file name, most 
    found letters in the file name or path, capitalization...
    
    * You can use left/right arrows to switch between recent list tabs.
    * You can use Ctrl+Space to select items and Ctrl+Up/Down to move without selecting.
    * You can select several items by clicking on the check boxes, using the mouse.
      using a mouse.
    
Recent files list
    Fussy search is now used to find and list items in order of relevance.
    priority. The same happens if a matching capital letter is found.  

Project panel
    You can now drag a document tab to the project tree to add the document to 
    an open project.
    
    The search field now use "fuzzy search". The match order, in the drop down 
    list, is sorted by relevance. 
    
    Mouse click on a found search item should now open the file properly.
Scripts
    Added two new properties to the "MainApp" object.
    - ProjectName  : string  // Get project name without file extension
    - ProjectDefaultDir   : string  // Get default project source folder set in project options
 
Auto completion
    Made some changes and changed several icons.

CSS/LESS/SASS
    Made extensive changes and updated the syntax files.

Search Results (find and replace all)
    Items are now selected by a single mouse click, instead of a double click.
    A click on a file now open and selects the first found or replaced item.

    Added several new toolbar buttons and functions.
    
    * Drop down list to instantly change the icon of the selected items.
    * Two type of sorting: normal sort and sort by grouping items by its icon.
    * Cut, copy and paste. If you have several syntax files open at once - you
      can copy and paste between syntax files.

Find in files
    Added prompt when doing "replace all", to prevent accidental replace.

Code dropdown trees (user toolbar)
    Made some minor visual changes and fixed a few issues.

Misc
    * Minor improvements in explorer panel options.
    * Added error messages when converting file encoding and it fails.

Fixed
    * Abbreviation issue in new installs.
    * Performance issues.
    * Search bar issues.
    * Auto completion issues in search dialog box.
    * Document map issue when closing dual document view.
    * Preview panel issue.
    * Browser preview panel issues.
    * Issue with highlighting braces.
    * Issue with convert encoding. 
    * Conflict between different scroll bar options.
    * Plus many other issues sent by email. 

-----------------------------------------------------------
Version 13.40 (Sep 10, 2018)
-----------------------------------------------------------

Chrome preview
    Updated all files and component to version 68.0.2440.

    Redesigned the advanced sort window and added new options and functions.
    
    The program is able to identify text columns automatically. To get an automatic
    start and end column value press the [...] button. Select the text column
    you wish to use as sort key, from all identified text column values listed.  
    
    New option:
    * Only keep duplicated key lines - will remove all lines unless the specified
      key has duplicates.

Options
    Redesigned the options window to make it easier to maintain and to add new
    options.
    
    All options are now moved to section panels that can be opened or closed by
    clicking on the section header.
    
    The overall look has been changed to make the layout cleaner.

User defined delimiters
    Added an option to add new characters that is used to separate words. 
    Normal ASCII characters like ,.;! etc. are already used and I've added a
    few Unicode characters, which you will see in options as user defined delimiters.
    
    These delimiters are used with most functions that identify words, like
    "find/replace (whole words)", move text caret to next word (CTRL+Left Arrow),
    or spellcheck.

Color Window
    The color dialog box can now handle alpha transparency.
    In languages like CSS and LESS the alpha value is written as a decimal value 
    between 0 and 1.
    E.g. rgb(120,80,60,0.5), where 0.5 is the alpha value and gives 50% opacity.
    
    You can also use hexadecimal values. E.g. #AA002288 (or #A028), where the last two
    digits (88) represent the alpha value. In a hex value the alpha part can
    be written between 0 and 255 ($0 - $FF). 

Color hint window
    The color hint window can now handle alpha values (transparency).

Modal Search Window
    * Made the window dialog resizable.
    * Added new search scopes ("In current function" and "All open files").
    * Changed the folder picker window dialog.
    * Auto completion in search boxes should work again (if option is set).
    * Changed how search field behave when switching tabs. 
    * It's now possible to delete a find/replace drop down item by 
      pressing the [DEL] key while the drop down list is displayed.
    * Window position is saved between sessions.

Search bar
    * Auto completion in search boxes should work again (if option is set).
    * Made some changes to the scope drop down list.
    * Added right click context menu to find/replace fields so you can now delete
      an entry.

Search multiple folders
    Added folder drop down menu items to handle multiple folders. You can add, 
    delete or edit folders to search. 

Search in current function
    Added a new search scope. Besides from being able to search from the beginning,
    from cursor position and inside selection, you can now search inside the current
    procedure/function/method...

Search in hex (binary) mode
    Made several improvements and fixed some issues in both the modal search window
    and the search bar.

Bookmarks
    Added new items to cut/copy bookmarked lines and "bookmark duplicated lines".
    
    Menu items where added to Search -> Bookmarks and toolbar buttons to the
    bookmarks panel.

File Commander
    Made some changes to font settings. The default is to use the default GUI
    font, unless you set your own font in file commander settings.
    
    Fixed a few issues as well.

Syntax Editor
    The class completion and user menu sort now group items based on the selected
    icon.

Scripts (added as tool to the tools menu)
    Scripts can now be executed every time the program is focused.

Misc
    * Changed all folder picker dialog boxes throughout the program.
    * Added toolbar button to "Upload to remote server".
    * Ctrl+Shift+F should be set as the default shortcut for "Find in Files".
    * Minor changes to the auto completion.
    * Spellcheck should skip HTML tags.
    * Some fields in the status bar are now automatically resized when text changes.

Fixed
    * Find All issues.
    * Search progress window issues.
    * Result window wasn't displayed with find all.
    * Auto completion issues (and auto complete words).
    * Some toolbar hint issues.
    * Statusbar redraw issues.
    * Fold issue with insert or delete line.
    * Delete current line issue.
    * Select text issues with tabs.
    * Misc issues found in program.

-----------------------------------------------------------
Version 13.30 (July 7, 2018)
-----------------------------------------------------------

Chrome Preview
    Updated the chromium component and libraries to version 67.0.

Goto Function/Line/Bookmark... (CTRL+G)
    Redesigned the "Goto line..." page in the modal search window and
    added a search field and a list with all classes, structures, methods,
    properties and functions found in the current document. 
    
    Use the search field to find a code element and, if necessary, the up and 
    down arrows to select the class, method or function you wish to 
    go to.
    
    There are four different keyboard actions to open the goto page.
    * GotoAction - will open the page with the last active option (Ctrl+G).
    * GotoSelectFunctionAction - will open the page with the function option active.
    * GotoSelectLineAction - will open the page with the line option active.

Find/Replace dialog box
    Redesigned the modal search window and added a new page for "Find in Files".
    All buttons are now placed to the right of the find/replace text fields. 
    
    Most combo boxes have been replaced by radio buttons to make option selection
    easier.
    
Search bar
    Made several changes to the search bar, removed some dropdown lists and
    added a popup form to the folder option button.

Find in Files
    Added a "Find in Files" menu item and toolbar button.

    Added navigation history buttons and moved a few buttons to the new "more"
    button dropdown menu. I also added a favorites button.
    
    History navigation can also be done using the mouse back/forward buttons. But
    it only works if the explorer panel has focus. 

Navigation history
    It's now possible to navigate backwards and forward using the mouse
    back/forward buttons (if you have them).

Fixed
    * Clear recent list string issue.
    * A few replace issues.
    * Remove item in recent file list.
    * A few issues reported by users.
    * Some minor visual changes.
-----------------------------------------------------------
Version 13.25 (May 29, 2018)
-----------------------------------------------------------

Document map
    The page marker can now be dragged and used as a scrollable handle and
    even replace the scrollbar.
    
    Options added:
        * Hide vertical scrollbar when document map is visible.
        * Document map width.

Indent by Fold
    Indent by fold is a simple way to format your code. A menu item has been 
    added to the format menu. The function will indent selected code or the 
    entire document, if nothing is selected. Indention follows the code folding 
    
    For the most part it formats the code fairly well, but some manual editing
    may be required. 

Fixed
    * Code explorer issue.
    * Toolbar button and dropdown issues.
    * Dual document view issue with compare mode.
    * Close document tab issue.

Version 13.20 (May 18, 2018)
-----------------------------------------------------------

Chrome preview
    Updated the Chrome preview component and libraries to version 66.0.3359.

Document map
    Changed the appearance of the current page representation inside the document
    map. 
    
    Border and background can be changed in customize themes.
    
    Added a document map hint window. Move the mouse inside the document
    map to see the hint window. The hint displays the content of the document 

Overwrite mode
    Added an option to make paste from clipboard work like most Linux editors 
    when in overwrite (OVR) mode.
    
    The option is labeled
    "Paste from clipboard should overwrite text in overwrite mode."

Fixed
    * Annotation bar flicker when switching document tab.
    * Alt+Key issues.
    * Find issue with match whole words.
    * Focus issue with auto-hidden panels.
    * Code explorer issue.
    * Copy as RTF.
    * Select All in search bar.
    * Small memory and resource leak.
    * (S)FTP upload issues.
    * Misc minor issues found while adding new features and testing.

-----------------------------------------------------------
Version 13.10 (May 7, 2018)
-----------------------------------------------------------

Chrome preview
    Made several changes to how preview panels and windows are created and 
    closed. I may have fixed a few potentially random close down 
    errors as well. 
    
Program startup
    Prevented the creation of some components at startup if they aren't needed or
    currently viewed. It may speed up the startup sequence a little.

Misc
    * Exception error report should now contain a better screenshot.

Fixed
    * Found and fixed several minor issues while testing.
    * Several column mode issues.
    * Toolbar hint issue.
    * Local help should work again (if no internet and local help file available).
    * A script issue.
    * C and Cpp code explorer issue.
    * Print issue.
    * (S)FTP upload issue.
    * Find/Replace All issues.
    * Portable install issues on 32-bit Windows.

-----------------------------------------------------------
Version 13.0 (Apr 20, 2018)
-----------------------------------------------------------

Chrome preview
    Updated the Chromium preview component and libraries to version 65.0.3325.

Exception catcher
    Made extensive changes to the bug report format and added several new items.
    A new tab was added to the exception window for loaded modules and
    running Win32 processes. 
    
    The screenshot now captures the entire window.

Startup
    Made some code changes to minimize disk access during startup and moved
    some functions to be used first when actually needed.

Code improvements and code testing
    I've taken the time to stress test functions and analyze classes and code to
    find possible issues.
    
    Some issues where found using different debug flags. or tools, and others
    where found using Application Verifier.
    
    I also corrected a few issues found using static code analysis tools and found
    several minor problems while testing.

Explorer tabs and File Commander tab
    Auto refresh should work properly now. And also turning it off in explorer
    tab.

Script debugging (step over)
    Made several improvements and fixed some issues.
    
    * The executed line is highlighted with a red background.
    * The debugging stops at the end of the script, or when moving focus to the
      script window, or when pressing the stop button.

Misc
    * Added remote file operations (save and save as) to the document tab context menu.
    * Menus can be accessed by pressing ALT then a char code. E.g. ALT+F+S for save.

Fixed
    * Find highlight issue.
    * Find RegEx highlight issue.
    * Ruler paint issue.
    * Chrome preview issue.
    * Rename remote file and server has disconnected.
    * Project wide class explorer issues.
    * Hex view paste issue.
    * Toolbar image issue.
    * Indent issue with expand abbreviation.
    * Delete multiple selections.
    * PHP tags inside HTML tag issues.
    * TODO/NOTE display issues in code explorer.
    * TODO/NOTE display issues in project class viewer.
    * Toggle browser view shortcut issue.
    * Switch tab from Chrome preview tab using keyboard shortcut.
    * Document tab hint issue.
    * Shutdown issues and issues that could lead to a crash.
    * Misc reported issues.

-----------------------------------------------------------
Version 12.91 (Mar 18, 2018)
-----------------------------------------------------------

Toggle browser view
    Made some code changes to fix a few issues with the browser view. The IE
    browser should work now and the Chrome browser should open more
    reliably now.

IE and Chrome preview
    Made some code changes to the preview functions to make sure the document
    is opened properly in the preview pane.


Insert abbreviation and text clip
    and clips are converted to spaces. Otherwise, real tabs are inserted.

Find/Replace
    Unicode searches should work properly now using \x{FFFF}.

    Ex.
    To find "€" use "\x{20AC}" as a search string.
    Or to find any non-ASCII character use "[^\x{0000}-\x{007F}]".

Misc
    * Made some internal improvements to the editor background thread.
    * Documents should close a little bit faster.
    * Improved communication between editor and background thread.

    * Heredoc issue in PHP syntax highlighter.
    * Word wrap issues.
    * Highlight selections.
    * Misc issues reported by users or found while testing.

-----------------------------------------------------------
Version 12.90 (Mar 7, 2018)
-----------------------------------------------------------

New Chromium Component
    Removed the old chrome preview component and replaced it with a brand new
    one. It's actively updated to use the latest Chromium library version and
    has some advantages compared to the old one.

    All Chromium files are now stored in the "RJ TextEd\cef" folder.

    The version included in this release is 64.0.3282.
Updated visual controls
    Updated controls (check boxes, radio boxes, dropdown lists...) to the latest
    version.

Updated SFTP controls
    This new version fix a few issues.

URL highlighting and follow link
    Added an option to enable URL highlighting and to follow the link by
    Ctrl + Mouse click.
    The mouse cursor change to a pointing hand when hovering an URL

(S)FTP Open (File - FTP - Open...)
    This feature allows you to open remote file(s). A file open dialog is displayed
    allowing you to connect to a remote server, browse remote folders and select
    files to open.

    Made several improvements to the FTP client. It should be able to detect
    a remote disconnect properly now and reconnect if necessary.

FTP panel drag n drop
    You can now drag files to the editor panel to open the remote files.

Evaluate Expression
    Added a new menu item to evaluate and replace an expression.
    I also renamed some menu items to make there function clearer.

Status bar character hint
    character column) now contain a character position value. The value include
    line feeds.

LESS and SASS
    Made some minor changes to improve color value identifying.

Import diff file
    Replaced the Windows standard input dialog with a custom made. It's larger
    and can be resized to make reading and editing easier.

Fixed
    * Several reported issues.
    * Script highlighting and folding.
    * Remote file transfer dialog theme color issues.
    * Highlight colors.
    * RegEx "find all" issues.
    * Undo issues.
    * Dual document view startup issue.
    * Should startup properly on Linux (Wine, latest version).
    * Fixed some install and update issues.

-----------------------------------------------------------
Version 12.80 (Feb 18, 2018)
-----------------------------------------------------------

Updated program files
    Re-compiled all files using the latest Delphi version. All files are now
    Windows XP compatible (again). Which means I don't need to have separate
    install scripts for Windows XP anymore.

Install scripts (Windows XP)
    All executable files have been compiled using the latest Delphi version. There is
    no longer any need to use separate installers for Windows XP.

    All install scripts can now be used on Windows XP .. Windows 10.

Reload current document
    Added support for remote files. If the current document has been altered you
    are presented with a save prompt, before the remote file is downloaded.

(S)FTP Save As
    You can use this feature to save the current document to a remote server.
    It lets you connect to a remote server, browse the remote folders and save
    the file.

    I made several improvements in this version.

Install script
    Made some changes to the install script to fix issues when using several
    Windows user accounts.

Document links (URL:s)
    Links inside a document can no longer be opened with Ctrl+MouseClick.
    Instead, use the document context menu to open the link.

    This was changed to enable multiple selections and multiple editing on
    web links inside the document.

Misc
    * Visual changes in recent file list and fixed a few issues.
    * Visual changes in navigation history list.
    * Warn if file has been deleted on disk now has "Yes to all", and "No to all" buttons.

Fixed
    * Send bug report issue.
    * Navigation history issues.
    * Column copy/paste issues.
    * Warn if file on drive has been deleted.
    * Import diff patch file issue.
    * Save diff patch file extension problem.
    * A few open/save dialogs in Windows XP.

-----------------------------------------------------------
Version 12.71 (Feb 6, 2018)
-----------------------------------------------------------

Update function
    The update window is now modeless so you can place it in the background, or
    minimize it, while it's downloading the new version.

    The update window will be moved to the front and inform you when the update
    is ready for installation.

FTP/SFTP
    Changed the connect timeout values to 15 seconds.
    If the connection times out a message is displayed.

Save As (Remote)
    The menu item "File / FTP / Save As (Remote)" will now open a connect window,
    to allow a remote connection. And a file save dialog window for browsing
    the remote site and add a file name.

    This works with both FTP and SFTP.

Navigation history
    Navigation history should handle remote files now. Even if you have closed
    them.

CSS highlighter
    Made some minor changes to the CSS syntax file which affect the highlighting.

Fixed
    * CSS highlighter issues.
    * Exit error when option "Close to hibernate" is used.
    * Edit macro issue.
    * Folder option menu issue in search-bar.
    * Code fold issue inside ini files when wordwrap is on.

-----------------------------------------------------------
Version 12.70 (Jan 26, 2018)
-----------------------------------------------------------

Shell Extension (Explorer context menu)
    Wrote a new shell extension in Delphi (instead of C++). It's easier to update,
    builds into a smaller dll file and the menu image looks better.

Portable version
    The portable version is now only available as an install script. The script
    unpack and copy (or update) the files in the given location.

    Settings and used data is not overwritten. And nothing is written to the
    registry.

    The auto update procedure is simpler as well. Just press the "Update" button
    and the update script is executed after download.

Menu and toolbar image settings
    Images used in menus and toolbars are now handled in options
    (Style and Fonts section).

    Any image list you create yourself must end with a size e.g. 16x16.bin.
    If a size is not found the 16x16 image list is used and images are scaled.
    E.g. if the program needs the 32x32 images, but are not found.


    * Pure flat images. These are new and may look better when using a dark theme.

New menu and toolbar images
    Added new image lists in the sizes 16x16, 20x20, 24x24, 32x32 and 48x48.
    The new image list is called "Pure_Flat_Toolbar" and can be set in options
    (Style and Fonts section).

    The new images looks better when using a dark theme. But you may like them
    even without a theme.

Find/Replace
    Underscore should be treated as a word character and dash (-) as a word
    separator when searching for whole words only.

Document context menu
    if you right click on a web link in the document, the context menu will

Misc
    * Improved RegEx search speed (Find Next/Previous).
    * Improvements to text diff mode when using multiple tab rows.
    * Some visual changes in the search panel.
    * Several minor changes throughout the program.
    * A few code optimizations to speed functions up.

Fixed
    * FTP download using file commander.
    * Minor changes to FTP upload that should make it more reliable.
    * Issue with command line option /COMPARE.
    * Double click on tool output in message panel.
    * Changes to prevent "Cannot access clipboard" errors.
    * Search issues in Text clips panel.
    * Refresh after replace all.
    * Possible abbreviation issues.
    * Ctrl+leftmouse URL click issue.
    * A great number of minor issues.

-----------------------------------------------------------
Version 12.62 (Dec 22, 2017)
-----------------------------------------------------------

Updated compiler
    Recompiled all executables. The error handler should work properly now.


Windows XP
    This compiler version doesn't support Windows XP, so I've compiled an XP version
    using an older compiler. Just make sure you download the correct installation
    file.

    The auto update function should work in this version. As well as
    "Help -> Check for updates".

    * Exception catcher issue (error handler).
    * Smart highlight issues.

-----------------------------------------------------------
Version 12.61 (Dec 18, 2017)
-----------------------------------------------------------

Fixed
    * Wrong search list used in the project panel.
    * Search highlight issue.

-----------------------------------------------------------
-----------------------------------------------------------

Abbreviations
    Added a new branch to the clip tree, located in the text clips panel, called
    "Abbreviations". I also added a few example abbreviations for a few highlighters.

    Abbreviations are expanded by hitting ALT+ENTER and are highlighter dependent.
    You can have an abbreviation named "for" in several highlighter branches. Which
    version expanded depend on the current highlighter.

    You can also set TAB or SPACE as triggers to expand abbreviations. This is done
    in the "Format" menu.

    Abbreviations (and text clips) can handle tab positions and multiple selections.
    E.g. if you insert the same tab position variable several times - they will
    all be highlighted and you can edit all positions at the same time.
    Ex: This is the clip added to the PHP branch with the name "for".

    [[#1]] = $tab x
    [[#2]] = $tab 0
    [[#3]] = $tab
    [[#4]] = $tab

    for ($[[#1]] = [[#2]]; $[[#1]] <= [[#3]]; $[[#1]]++) {
       [[#4]]
    }

    To use this clip open a PHP file and type "for" and press ALT+ENTER (TAB or SPACE).

    The clip is expanded and the first tab(s) are selected. In this case [[#1]] is
    replaced with "x" and all three instances are selected.

    for ($x = [[#2]]; $x <= [[#3]]; $x++) {
       [[#4]]
    }

    To keep the x as variable just press TAB. Otherwise type the new variable name.
    Press TAB to select [[#2]], which is replaced by "0".
    Tab positions [[#3]] and [[#4]] are replaced by "".

    NOTE! You only need to open the text clip panel to edit or add new abbreviations.
          It doesn't have to be open for abbreviations to work.

Menu style
    Changed the default menu style in Windows 10. You can use it in other Windows
    versions as well by changing the menu style option.
    The "old" style is still available in options and used as the default style
    in older Windows versions.

    On Windows 10 (8.1) the background color is white and the accent color is
    used for menu highlighting.

    The accent color used automatically change if the system color change.

Syntax editor
    Re-designed the user interface, replaced several components and changed the
    colors and menu style. Made several changes internally to make the code easier
    to maintain.

    On Windows 10 (8.1) the accent color is used in tabs and menus.

    The accent color is automatically updated if the system color change.

New compiler version
    All executable files have been re-compiled with the latest Delphi version.

Fixed
    * Several highlighting issues.
    * Several code fold issues.
    * Shortcut issue in search bar.
    * Theme manager "Apply" issues.
    * Convert to HTML issue.
    * Script step issue.
    * Search issues in text clip panel.
    * Search issues in project manager panel.
    * Several text clip issues.
    * Insert text clip using keyboard shortcut.
    * Auto update check issue.

-----------------------------------------------------------
Version 12.50 (Nov 19, 2017)
-----------------------------------------------------------

New highlighters
    Added new highlighters (or syntax files). You have to activate them yourself
    in "Addons -> Highlighters" section.

    New highlighters:
      - Kotlin
      - Cobol
      - Swift
      - Makefile
      - Matlab
      - Go
      - NSIS

Syntax file options
    Added new block options to handle what is highlighted inside a block when
    the option "BlockAsString" is set to "No".

    The new options are:

    HighlightBlock=Yes|No
    HighlightKeyword=Yes|No
    HighlightSymbols=Yes|No
    HighlightNumbers=Yes|No
    HighlightStrings=Yes|No
    HighlightChars=Yes|No

Search bar
    Made some visible changes to the search bar.

    The tab key will only switch between the find and replace fields.
    Text in the find field is copied to the replace field if empty.

    Find and replace buttons can be focused using accelerator keyboard shortcuts
    e.g. ALT+d to focus the find next button (English language used).
    Move focus between buttons using TAB or SHIFT+TAB.

Smart highlighting while selecting
    Changed the behavior when selecting text. Other instances of selected
    words or strings will be highlighted. The word or string can be case sensitive.

    It's been added as an option so it can be turned off.

    The options added are:

    * Enable smart highlighting while selecting
        * Case sensitive
        * Whole words only
    Added menu items to handle multi selection using the keyboard.

    * Add word and find next (Ctrl+D) - will select the currently selected word, find the next
      instance and select that as well.

    * Skip word and find next (Ctrl+F3) - will skip the current selection, find the next
      and select it.

    * Undo selection (Shift+Ctrl+D) - will undo the last add or skip operation.

Document tab context menu (Find file name in project)
    Added a new menu item to search for the current file name in project files.
    The menu item is only visible if a project has been opened.

Document context menu (Find word/selection in project)
    Added a context menu item to search for the current word or selection in
    project files.

    The hash generator is now able to create a hash from a given text string or
    an opened file.

    A button to open a file has been added next to the edit field.

Syntax Editor
    Redesigned the block and code folding tabs. Blocks and folds should be
    much easier to manage now.

    * Added buttons to move items up and down.
    * Added buttons to change case of keywords and tags.
    * Made several other minor improvements and fixed a few issues.

Options
    * Added several new options and rearranged some check boxes in the general tab.
    * (File) Turn on Wordwrap - will override the option to save wordwrap state.

Fixed
    * Menu display issue with multiple monitors.
    * Mouse wheel zoom should use "scroll up" for zoom in and "scroll down" for zoom out.
    * Save on dragged out external document.
    * Auto complete issue.
    * PHP highlight issue inside HTML tag.
    * FTP issues when server disconnects.
    * Issues in Syntax Editor.
    * Misc reported issues.

-----------------------------------------------------------
Version 12.41 (Oct 19, 2017)
-----------------------------------------------------------

Misc
    * Made some minor changes in document tab drawing in dual document view.
    * Updated SFTP component.

Fixed
    * High CPU usage with sertain scrollbar options.
    * Clone document issue.
    * Find issues in options window.
    * Column mode issues.
    * Update (old) projects.
    * User bar drop down tree issue.
    * TODO/NOTE list display issue.
    * Keyboard issue in regular expression creator.
    * Save main window size on high DPI display.
    * Bookmarks are drawn with a little more space to the right.
    * Other reported minor issues.

-----------------------------------------------------------
Version 12.40 (Sep 29, 2017)
-----------------------------------------------------------
Document editing and speed
    While solving a few issues with the background thread I also improved
    editing speed for operations like typing, deleting (DEL/BACK), or any
    other operation that just changes the content of the current line.

    The change may be quit noticeable.

Other speed improvements
    Sort functions have been optimized and should be even faster than before.

Hash Generator
    Added a simple hash generator in the "Tools" menu. It can generate a string
    hash using the most common algorithms.

    NOTE! If you feel that an algorithm is missing, let me know.

Allow illegal control characters in text files
    The option is turned on by default, allowing you to open text files containing
    e.g. a few non-text characters like zeros.

    If turned off, files containing illegal control characters are handled as
    binary/hex files.

Save hex view status
    The editor can now remember the hex view status after a document has been
    closed. This should work with both text and binary files.

    The setting is available in "Options -> File -> Save status for last open files".

Fixed
    * FTP issue with older FTP servers (Unix/Linux vsftpd...).
    * Open remote (S)FTP from menu recent files.
    * Some change DPI issues.
    * A few delete issues.
    * Several hard to find exceptions that may appear randomly.
    * Open file at cursor.
    * Clipboard history display issues with delete and clear.
    * Paste text at end of line.
    * Display space and tabs issue.
    * Change newline format display issue.
    * Trim trailing spaces issue in column mode.
    * Replace issue with regular expressions.
    * Minimize/Maximize issues.

-----------------------------------------------------------
Version 12.35 (Sep 18, 2017)
-----------------------------------------------------------

Move editor between monitors with different DPI
    Made some changes to speed thing up. The main window isn't constantly
    redrawing anymore and moving the window between monitors is much faster.

Fixed
    * Reload document issues.
    * Some very hard to find editor background thread issues.

-----------------------------------------------------------
Version 12.34 (Sep 17, 2017)
-----------------------------------------------------------

Per monitor DPI awareness
    Made several improvements and fixed a few issues when moving the program
    between monitors using different pixel density or scaling in Windows.

Fixed
    * Spell check (F7) issues.
    * Clone document issues.
    * Wordwrap issues.
    * Explorer panel issues.
    * Search issue with dot and regular expressions.
    * Many misc reported exceptions.

-----------------------------------------------------------
Version 12.33 (Sep 8, 2017)
-----------------------------------------------------------

Exception window
    Added a "Show/Hide details" button which enables user to show/hide details
    of the bug report.

Editor context menu
    Added a menu item for "Select All".

Fixed
    * Horizontal scroll issues.
    * Cursor issue in wordwrap.
    * Possible issue when reloading document.
    * Help issue in "Convert file encodings...".
    * Indent selection should work on the current line even if there is no selection.

-----------------------------------------------------------
Version 12.32 (Sep 7, 2017)
-----------------------------------------------------------

Horizontal scroll bar
    The horizontal scroll bar should stay hidden until a line longer than the width
    of the display is encountered. This is not calculated at load time. It's done
    when displaying the text. So the horizontal scroll bar will only appear
    if a line longer than the window width is displayed.

Fixed
    * Quick find issues.
    * Display color hint issue.
    * Editor issue.
    * A few FTP issues.
    * File explorer panel issue (Win XP).
    * File Commander issue (Win XP).

-----------------------------------------------------------
Version 12.31 (Sep 3, 2017)
-----------------------------------------------------------

Fixed
    * Font issue in search result panel.
    * Editor undo issue.
    * FTP tree issue.
    * File explorer issue.
    * File Commander issues.
    * A few split window issues.
    * Several FTP issues.
    * Several reported exceptions (error messages).

-----------------------------------------------------------
Version 12.30 (Aug 24, 2017)
-----------------------------------------------------------

    place (Options - Customize - Style and Fonts).

    There are now 5 options to handle panel appearance and behavior.
        * Show captions in panel tabs.
        * Show images in panel tabs.
        * Show captions in hidden panels.
        * Show images in hidden panels.
        * Automatically open hidden panels on mouse hover.

    If you set the options to show images but not captions for hidden panels,
    you get only a row of images. Very much like a toolbar.
    A hint is displayed when the mouse it hovering a panel button.

    I also added hints when the mouse is hovering panel tabs.

Main tabs
    Added new options to handle the appearance of  main tabs. You can change the
    tab style and decide if the tabs should have captions and images.


Editor code folds
    Fold node icons are now drawn using GDI+ vector graphics.
    This gives more control over appearance and colors.

    Use the theme manager to change icons. Each icon can have two colors. The
    current margin line color, or a theme color version which is dark for light
    themes and light for dark themes.

Exception catcher
    The program now has its own exception catcher code. Whenever an exception
    occur - a detailed report is displayed with some program and system
    data and a stack trace. A screenshot of the active window is included as well.

    You can save the bug report. It consist of two files. One text file
    containing the bug report and a screenshot JPEG file.

    You can also send the bug report. The two bug report files are attached to the
    email sent.

    The stack trace may not give as good results in the release version because
    of optimization, but it should be helpful nonetheless.

Toolbar context menu
    Added a context menu item to hide main, editor and user toolbar.

Search result context menu
    Added context menu items to export search results as plain text.

Explorer panels
    Added an option to set auto refresh state. You can use this to turn off
    auto refresh if you encounter issues with it.

Replace (modal window)
    When doing a replace a prompt window is displayed. If the button "Yes to all"
    is pressed the regular replace all function is used, instead of making a
    single replace at a time inside a loop.
    This speeds up the replace and an abort window is displayed, so you can halt
    the replace if you wish.

    * Several DPI issues in the program.
    * DPI issues in Syntax Editor.
    * Several visual issues.
    * Few issues with the explorer panel (could crash).
    * Few issues with file commander lists.
    * FTP remote delete issues.
    * FTP remote edit file/folder name issues.
    * Split window issues.
    * Move cursor to next word issue (Ctrl+Right).
    * Tool output issue.
    * Delete block issue in Syntax Editor.
    * A few word wrap issues.
    * A few internal changes seems to have fixed several reported issues.
    * Monitor log file issue.
-----------------------------------------------------------
Version 12.21 (July 24, 2017)
-----------------------------------------------------------

Search Options
    Added a few new search options to handle selected text.

    You can:
    1. Use selected text as search string.
    2. Include multi-line selection as search strings.
    3. Or not use selection as search string.

Fixed
    * A few "Quick Find" issues.
    * Theme issues at startup.
    * Several theme issues when changing theme.
    * Increase/Decrease font size.
    * Minor issue in Edit menu.

-----------------------------------------------------------
Version 12.20 (July 9, 2017)
-----------------------------------------------------------

Hex View
    Added two options to set the behavior when switching to hex view.

    * Edit File. Reopen the file in binary mode and edit the file.
    * Edit document buffer. Just switch view and edit the text buffer, but using
      a hexadecimal display.

    Both modes support undo/redo. Edit file mode is set as the default behavior.

    * Quick find is supported in hex view.
    * Find/Replace is supported in hex view.
    * Goto line/address is supported in hex view.

    Please note that because the file is saved to a memory stream and reopened
    into a binary buffer when switching to hex view (edit file mode), the
    line change indicators will disappear when switching back.
    The editor tries to restore bookmarks, but they may be located on the
    wrong lines after an edit in hex view.

Quick Find (Ctrl+E)
    Made some changes to the incremental search and renamed it quick find.

    * A hex value button has been added to the quick find bar. It is only
      visible when in hex view and allows you to enter a search string of
      hexadecimals, e.g. "6D0D0A".

Find/Replace
    Made several changes to the search bar and the modal search window to
    enable find, find all, replace, replace all when in hex view.

    It is now possible to search for hex values, as well as ANSI.

    The search result output has been improved when searching in hex view.
    Search result context menu items has been updated and work better in
    hex view as well.

Search result context menu
    The export items now export search results as HTML code.

Display control characters (space, tab and linefeed)
    Control characters are now using the colors set inside the themes manager, unless
    you set the option to follow the current syntax color.
    All Unicode white spaces are now displayed.

Wordwrap
    Made some optimizations and wordwrap should be much faster now when using
    large files.

File Commander
    Replaced the drop down list and list view components with faster ones.

    * Changes in folders are better updated in the views.
    * Made some changes in options.
    * Header columns in report view can be resized and remembered between sessions.
      You can find more columns in the header context menu, but only the first
      7 columns are handled when changing folder and only those 7 are saved.
    * Added a thumbnail view.
    * Other views should be displayed properly now.

Explorer panels
    Replaced the drop down list, tree view and list view components with faster ones.

    * Changes in folder is better updated in the explorer panel view.
    * Made changes in options.
    * Header columns in report view can be resized and the widths are remembered
      between sessions. You can find more columns in the header context menu,
      but only the first 7 columns are handled when changing folder and only
      those 7 are saved.
    * Opened documents are highlighted with bold and using a highlight color.
    * Added a thumbnail view.
    * Other views should be displayed properly now.
    * In list view only one column is displayed at a time.

Word count/frequency
    Redesigned the dialog window and made some optimizations to speed up
    the count process. It's much faster now.

Special characters drop down grid
    It's now possible to move around in the character grid and select a value
    with [ENTER]. Mouse movements are tracked.

    A hint is displayed when hovering the mouse over a character, displaying the
    hexadecimal value and the Unicode name of the focused character.

Symbol Panel
    A hint is displayed when hovering the mouse over a character, displaying the
    hexadecimal value and the Unicode name of the focused character.

Misc
    * All supported SSH client ciphers are now available.

Fixed
    * Search bug with option to match whole words.
    * Reopen project issue at startup.

-----------------------------------------------------------
Version 12.12 (Jun 8, 2017)
-----------------------------------------------------------
Options

        * It's now possible to set a default file type when opening a file. This
          is used if the file is empty, or doesn't contain any line feeds.

    2. Made changes and added options in the "Style and fonts" section.

        * Option to show/hide change indicator on document tabs.
        * Option to show/hide changed and saved indicator on document tabs.

    3. Made a change in the "Tools" section.

        * Added a button to clear the tool icon, if assigned.

Find/Replace
    Searching folders using a multiple line find text should work properly
    now - no matter the file type. The files can be a mix of Windows, Unix and
    Mac files. Find and replace should work regardless.

Join lines
    Join lines will now remove all surrounding white spaces and add one space

Fixed
    * List view style in explorer panel.
    * Digit separator in C++ (1'000'000).
    * Document context menu caption.
    * Fixed issues with "Open in default program".
    * Selection after moving text cursor to a bookmarked line.
    * Word wrap issue with complex scripts like Japanese.
    * Fixed a language issue in options.
    * A few issues in Syntax Editor.

-----------------------------------------------------------
Version 12.11 (Jun 2, 2017)
-----------------------------------------------------------

Updated highlighters
    Updated several highlighters (C++, C#, Java, JavaScript, Python, VB.NET).

File Commander
    Added new toolbar buttons for navigation and view styles beside the drop down
    lists.
    Made several visual changes and fixed a few issues.

Tab document menu
    Added a menu item to open the current file in the default program.

Tree views
    Made several visual changes to all tree views in the program,
    e.g. text clips panel tree. They should look better now using themes and
    on high DPI displays.

Syntax Editor
    Made several changes to the syntax editor program.

    * Variables are now listed when adding class/tag completion entries.
    * All option tree components have been replaced.
    * Fixed several issues.

Misc
    * Minor visual changes and fixes.
    * Minor changes in the preview title bars.

    * Regular expression when finding block end in syntax files.
    * Fold highlight issue with comment blocks.
    * Script selection issue.
    * Reopen last open files issue when using dual view and a project is opened.
    * Draw issue with matching braces and scrolling at the same time.
    * Minor draw issues in find/replace dialog window.
    * An issue with find in files when using the find/replace dialog window.
    * Undo issue.
    * Issue with default save folder when saving new files.
    * Fixed a few issues in the text clips panel.

-----------------------------------------------------------
Version 12.10 (May 15, 2017)
-----------------------------------------------------------

    Created a new highlighter to handle SVG files and SVG code inside HTML.

    * Tags, attributes and values are highlighted.
    * Style and script blocks inside SVG objects are highlighted properly.
    * Auto completion works with both SVG tags and SVG attributes.
    * Tag highlighting when text cursor is inside a tag.

    To handle SVG in HTML documents you don't have to do anything. It should work
    out of the box.

    To handle SVG files - you need to enable the SVG highlighter
    in "Addons".

XML
    Attributes now have there own colors and can be changed using the theme
    manager.

Bash
    Made some changes to the bash highlighter. It should handle comments,

Fold marker {...}
    It's now possible to change the appearance of the fold marker that appear to
    the right of folded code. You can change background color, text color and
    style. The appearance depends on whether or not you've set the background color.

    With no background color set (transparent) you get a rectangle with ... inside.
    You can change the color of the rectangle and the dots (...). You can make
    the rectangle frame wider and dots slightly larger by setting the style to
    bold.

    With background color set the marker is drawn with dots inside curly braces
    {...}. You can change the background and foreground colors and change the
    style to bold, italic or underlined.

Log-file monitoring
    Added new items in the document tab menu to enable monitoring of log-files.
    When monitoring is enabled, all lines added to the log-file will be added to the open
    document.

    The follow tail option is turned on by default. When enabled the editor will
    jump to the end of the document as new lines are added.

    Use the highlighter options to add keywords to look for on each line.
    If found - the entire line will be highlighted using the settings you specify.

Multiple cursor mode
    Using multiple cursors or selections is now indicated in the status bar. The
    "Row" panel changes color and the number of cursors are displayed within
    parenthesis.

    If you click on the highlighted status bar panel - you exit multiple cursor
    mode and return to single cursor mode operations.

Command line option (/MONITOR)
    Added a command line switch to enable log-file monitoring using the command line.

    E.g. TextEd.exe /MONITOR F:\MyLogFile.log

Undo
    Text is re-selected after you've overwritten or deleted a selection and press undo.

Document tabs
    Changed the color of the close button. The hot color and drawing was
    changed as well.

    Changed the frame color used in the change indicator.

Join lines
    Changed the behavior of join lines. All unnecessary spaces between lines
    are now removed. If you prefer the old behavior, you can use
    join lines (prompt for options) or Format - Unwarp lines...

Compress lines/Delete blank lines/Delete redundant blank lines
    All functions in the title now remove lines containing white spaces as well as empty
    lines.

    * Compress lines remove unnecessary blank lines to compact the text. Including
      single blank lines.
    * Delete blank lines remove all blank lines.
    * Delete redundant blank lines reduce blank lines to just one if a block
      of several blank lines are found.

Misc visual changes
    Several visual changes was made in this release.

    * The "Home" page has been redesigned.
    * The help toolbar on "Home" can be hidden using a menu switch
      (View - Bars - Show help toolbar on "Home").
    * Made some changes in HTML preview tabs.
    * Internal browsers now have icon and title in the window title field.
    * Made some visual changes in Themes manager.
    * Made several visual changes in Addons and moved spell options to "Options".

Misc
    * Several speed optimizations.
    * Compiled using a newer Delphi version.
    * Right margin can now have values below 16 when word wrap is turned off.
    * Minor changes to the HTML syntax files (highlighter).

Fixed
    * Open multiple files using double click and pressing SHIFT/CTRL in Explorer panel.
    * Updated the JSON highlighter.
    * Edit right margin value in options.
    * Some high DPI issues.
    * Some issues in the project panel.
    * RTL Edit issue.
    * Print HTML code containing style and script tags (multi highlighter issues).
    * Export HTML code to HTML/RTF containing style and script tags (multi highlighter issues).
    * XML URL draw issues.
    * Issue with highlighting of matching braces (ASP/VB...).
    * Issue with select brace enclosed (ASP/VB...).

-----------------------------------------------------------
Version 12.06 (Apr 1, 2017)
-----------------------------------------------------------

    If the backup path doesn't exist the user is informed about it. A prompt
    message give you the choice to enter settings and correct the path.
Auto Save
    Made some code changes to ensure the correct document is saved and prevent
    save when other files are opened or closed.

HereDoc ("Here document" in Bash)
    Added an option to syntax files to handle HereDoc. The options has been added
    to PHP and Bash syntax files.

    NOTE! If you have written your own custom PHP syntax file - don't forget
    to add the new option.

    [Options]
    HereDocSymbol=<<<

Fixed
    * Auto check for new updates.
    * Title issue when opening an already open file and the active tab change.
    * Search dialog window position issue.
    * Goto line dialog window issue.
    * Goto line when line number exceeds the number of lines in the document.
    * Tab row drop down menu draw issue.
-----------------------------------------------------------
Version 12.05 (Mar 23, 2017)
-----------------------------------------------------------

Misc
    * Select All (Ctrl+A) doesn't scroll the window anymore.
    * A single mouse click is now enough to edit a value in the unit convert panel.
    * Ctrl+Space completion should now work even if auto completion is turned off.
    * Optimized delete line function when executed in a script.
    * Misc visual improvements and fixes.

Fixed
    * Word wrap indent issue when using variable width font.
    * Find/Replace issue after opening "Goto line...".
    * A few replace issues in the find/replace window.
    * PHP preview issue when using "Toggle browser view".
    * Markdown preview should handle Unicode.
    * Couldn't write text while color hint was open.
    * A few syntax highlighting issues in Ruby.
    * A browser preview temp file issue.

-----------------------------------------------------------
-----------------------------------------------------------

Fixed
    * Can't open files from Explorer in running instance.

-----------------------------------------------------------
Version 12.03 (Mar 11, 2017)
-----------------------------------------------------------

Windows 10 Creator Update (and insider preview)
    The program should run properly now. The theme (or VCL style) engine didn't
    work properly so I'm currently using the original Delphi version.

    System dialog theming is disabled (file open/save dialog windows...).

    Using the original theme engine solves a few other issues as well and is
    generally more stable, though it lacks some features. For instance both the
    32-bit and 64-bit versions now work on Linux using Wine.

Large file support
    The editor should handle large files (> 2GB) better now using the 64-bit
    version.
Word wrap
    Optimized some functions to speed up word wrap. Especially when using large
    files.

Misc
    * Minor visual changes in the main program.
    * Minor visual changes in Syntax Editor.
    * External compare menu items are only visible if a compare tool is set in options.
    * Find/Replace dialog may open faster now after first use.
    * Both 32 and 64 bit versions run on Linux using Wine.

Fixed
    * Case issue in file explorer highlight function when marking open documents.
    * Delete all in hex mode.
    * Save actions, e.g. remove trailing white spaces, didn't work in compare mode.
    * Code Explorer update issue.
-----------------------------------------------------------
Version 12.02 (Feb 28, 2017)
-----------------------------------------------------------

High DPI and menu font
    Fixed several scaling issues on high DPI displays.

    * Menu and GUI font issues.
    * Editor font settings and  display issues.
    * Home page issues.
    * Several issues with panels.

    Fixed some issues when moving the program between monitors using
    different scaling.

Chrome Preview
    Updated the libraries to version 56.0.2924.

Misc
    I've fixed several glitches and minor issues throughout the program. Some

-----------------------------------------------------------
Version 12.01 (Feb 25, 2017)
-----------------------------------------------------------

Toolbar and menu images
    Images are scaled up if running on a very high DPI monitor and you need
    larger images than 48x48.

Search bar
    Made several changes in the search bar.

Print selection
    Multiple selections are now supported.

Update check and Addons
    Made some changes in the download thread and replaced the HTTP component.
    All update checks and downloads now use HTTPS.

    NOTE! The system proxy is always used (if set).

Online help
    If you have a local help file in "<AppData>\Roaming\RJ TextEd\Help\" it will
    be used if you're not connected to Internet.

Fixed
    * Macro Editor errors when hovering the mouse over some areas.
    * Several issues in Regular Expression Creator.
    * Dark button text in toolbars when using some themes.
    * User toolbar icon issues.
    * Recent file menu issue when having many files in the list.
    * Export as RTF to file.
    * HTML script highlight issue.
    * Selecting recent FTP list item should work now.
    * All toolbar dividers are now grooved.
    * Join lines with option to remove leading spaces didn't remove tabs.
    * Macro manager label issue.
    * A minor find all issue.
    * Column mode issue with auto complete braces.

-----------------------------------------------------------
Version 12.0 (Feb 18, 2017)
-----------------------------------------------------------

High DPI awareness (per-monitor DPI aware)
    The application and tools should display properly on high DPI displays.
    The main program and all tools are per-monitor DPI aware so you can drag
    the program between monitors with different DPI.

    Almost all visual components have been replaced and toolbar, menu and button
    images are now available in several sizes.

Replaced visual components
    Replaced almost all visual components like tool bars, labels, check and
    radio boxes, spin controls and buttons.

    Updated, and made changes to, list boxes and list views with check boxes
    and images.

Automatically enclose selection with braces and quotes
    Added two new options to allow the enclosing of a selection with parenthesis
    and quotes, when pressing a left open bracket or quote.

    Automatically enclose selection with braces
        The option is enabled by default and allows you to enclose a selection
        with braces like (), [] or {}.
        E.g. Select a text like "ABC" and press '('. The selection is now
        enclosed "(ABC)".

    Automatically enclose selection with quotes
        The option is enabled by default and allows you to enclose a selection
        with quotes like "", '' or “”.
        E.g. Select a text like 'ABC' and press '"'. The selection is now
        enclosed '"ABC"'.

Select Braces and tags
    Added a new function to select braces that includes the braces. The current
    function only select the text in between the braces.

    I changed the behavior in HTML and XML documents.

    The text cursor is anywhere between tags:
        * "Select Brace Enclosed" will select everything between the tags.
        * "Select Brace Enclosed (with braces)" will select the tags as well.

    The text cursor is inside a tag:
        * "Select Brace Enclosed" will select everything inside the tag.
        * "Select Brace Enclosed (with braces)" will select "<" and ">" as well.

    The function "Select Tag" will always select the entire start/end tag block.

    covered by the functions above.

Convert panel
    and time pickers to make date and time selection easier.

Join lines (prompt for options)
    Added a new menu item to prompt for options before joining lines.

    Options available are:
        * Do not add spaces between lines
        * Preserve paragraphs
        * Remove leading white spaces

User toolbar (quickbar)
    Redesigned the quickbar and renamed it "User Toolbar". It only have
    two pages now. "Code" and "Script".

    The code toolbar is customizable so it's possible to display more buttons
    or hide some unwanted ones.

    All editor toolbar buttons are available in the user toolbar. They are
    hidden by default but if you wish, you can enable them (right click over
    toolbar and select customize) and close the editor toolbar.

Themes and editor colors
    colors that can be used with the "Onyx Blue" style.

Toolbar image lists
    The editor load the appropriate image list based on the DPI of the current
    monitor from disk. The standard lists are available in five sizes: 16x16,
    20x20, 24x24, 32x32 and 48x48.

    It is possible to create your own image lists used in toolbars, menus and
    panels throughout the program. In the program folder there is a tool called
    "ImageListEditor.exe", which I wrote for this purpose. You can add this as
    a tool to the "Tools" menu and start modify existing image lists or create
    new ones.

    You can actually add images of any size you want. The added images are then
    resized (the resize function produce very good quality images).
    But you still get the best quality if you use images (glyphs) of the same
    size as the image list use.

    The image lists are available in "<AppData>\Roaming\RJ TextEd\ImageLists\".
    In the same folder you'll find an option file "ImageLists.ini" you can
    edit and add your own image list(s) to.

    I would appreciate any contribution from users.
Import diff file
    Added menu items to import diff files. The imported file is used to patch
    the current document. You are able to make changes to the text before it
    is inserted.

Text compare
    Fixed several issues in the text compare algorithm. It should handle Unicode
    properly now and yield better results.

Chrome preview
    Updated the chrome libraries to version 3.2883 (Chrome v65).
    Flash is enabled and should work if you have a flash player installed.

Online help
    The help is now located Online. This to make sure the help is displayed
    properly on high DPI monitors.

    You can download the help as an CHM file and add it as a tool, if you want
    to use a local file instead. Available from https://www.rj-texted.se/downloads

Splash screen
    The splash screen should display on the correct monitor in a multi monitor
    setup. The splash window and text is scaled properly now on high DPI

    The splash screen should now always display the correct version and if
    it's a 32 or 64 bit executable.

Misc
    * SFTP component has been updated.
    * Regex component has been updated.

Bugs
    * Dual document state is not saved when you open the application using
      the /COMPARE switch.
    * Editor refresh issue.
    * Select highlighter in drop down menu could result in wrong highlighting.
    * No save warning in compare mode.
    * Can't open CHM file set as tool when no documents are open.
    * Font display issue in File Commander.
    * Issue when sync scroll is active and you close dual document view.
    * Issues with read-only files.
    * Halt script issue.
    * Trailing tab issue in column mode.
    * Program search issue when focusing the edit box using the mouse.
    * Selected section text color in options.
    * Couldn't use /MULTI /COMPARE %File1 %File2 as command line option.
    * JavaScript highlight issue.
    * Drag n drop issue.

-----------------------------------------------------------
Version 11.22 (Oct 4, 2016)
-----------------------------------------------------------

Startup issue
    A few users have reported an startup issue where the program opens in
    compare mode. It's been fixed in this version.

Explorer panels
    Updated the explorer panel components. This should fix several issues.

-----------------------------------------------------------
-----------------------------------------------------------

Text Compare
    Added a new menu item to create a text compare report. Use the report dialog
    window to set options and what to include in the report.

    * You can create a report for printing. Print preview is available.
    * You can create a report as HTML and open it in a browser or save it to file.

    You can include:
      - All lines
      - Changed lines only
      - Unchanged lines only

    Options are:
      - Syntax highlighting
      - Wrap text
      - Line numbers

    I've made some minor changes in menus and changed some menu icons.

Startup
    Changed how panels and some forms are created at startup. The startup time
    should be less than half compared to previous versions.

    The only drawback is the delay before visible panels are fully created when
    the program is started.

Script
    Added a new function to the MainApp object. NewDocumentEx().
    Added three new properties to the document object. CodePage, NewlineFormat and UseBOM.

    Ex. (C++ script)
    // HTML file, UTF-8 encoded with BOM and Windows linefeeds (CRLF)
    MainApp.NewDocumentEx(".html", 65001, true, "Windows");

    Ex. (C++ script)
    Document.CodePage = 65001; // Change encoding to UTF-8
    Document.UseBOM = true; // Use a BOM when saving file
    Document.NewlineFormat = "Unix"; // Convert to Unix linefeeds (LF)

Full screen mode
    Added two new keyboard shortcuts to toggle the menus and status bar on/off.
    You can already toggle the editor toolbar on/off. The state in full screen
    mode doesn't affect the state in normal mode, so you can have the editor toolbar
    hidden in full screen mode and displayed in normal mode.

    Toggle menu: Ctrl+Alt+M
    Toggle status bar: Ctrl+Alt+S

    The layout in full screen mode is remembered between sessions.

Misc
    * Added a new command line switch to open a new instance of the program /MULTI.
    * Added a new command line switch to compare 2 files /COMPARE [file1] [file2].
    * Auto completion window is opened a little bit faster.

Fixed
    * Plain text files that include binary data should open properly now.
    * Issues with fuzzy sort in auto completion.
    * Multi cursor select issue.
    * GUI font quality settings.
    * File - Close didn't display a keyboard shortcut.
    * Startup issues from command line.
    * Document map should not be displayed with binary files.
    * Project files are reloaded in the same order as when closed.
    * Minor text issue in customize keyboard.
    * Minor issue with bash highlighter.
    * A few rare undo/redo issues.
    * Add to script menu issue with "Cancel" button.

-----------------------------------------------------------
Version 11.20 (Sept 14, 2016)
-----------------------------------------------------------

Text Compare
    Added side by side text compare. Menu items have been added to the "Tools"
    menu, document tab context menu and the document context menu when in compare
    mode.

    * When in compare mode the "Insert/Overwrite" status bar field turns red and
      "Compare" is displayed to indicate you are in compare mode.

    * Added [+], deleted [-] and modified [~] lines are marked both in the
      left margin and using different background colors.
    * To display an action menu - click on the [+], [-] or [~] field in the left
      margin, or right click inside a difference section.
      The action menu contain items to copy a section or line to the other side,
      copy section to the clipboard, navigate between difference sections or

    * Below the two documents is the line inspector that shows the
      current line from both documents and highlight the differences.

    * The annotation bars always open in compare mode. In compare mode they
      only show you were the difference sections are.
      You can click on the annotation bar to navigate to that position.

Multi Cursor Mode
    Erased the previous implementation and wrote a new one. It works much better
    now. You can do almost anything you can do when using just one cursor.

    Use Ctrl+LeftMouse to place additional cursors or make additional selections.
    You can cancel a cursor with a Ctrl+MouseClick over the cursor you want to
    cancel.

    Exit multi cursor mode by hitting [ESC] or with a left mouse click anywhere
    in the text area.

    You can move all cursors left/right/up/down with the arrow keys. Almost all
    standard keys to move or making selections are supported.
    E.g. Ctrl+Right to move all cursors to the next word or Shift+Down to select
    to the next line below.
    You can use [Enter] to create new lines or split lines. For instance: place
    3 cursors on the same line. Hit [Enter]. You have now split the line into
    4 lines.

    Paste will insert the clipboard content at each cursor position (or replace
    selected text).
    But if you use "smart paste" Shift+Ctrl+V and you have 4 lines in the
    clipboard and 4 cursors - each line will be pasted at each cursor position.
    This will only work if the number of lines in the clipboard matches the number
    of cursors.

    Other functions that will work in multi cursor mode are:
    "Indent/Unindent"
    "Comment/Uncomment"
    "Sorting"
    "Move lines up/down"
    "Case functions"

    "Insert ascending numbers..." (found in the edit menu) now works in multi cursor
    mode.

Tool item type
    Added a new tool item type "URL". It can be used to open an online search
    page like "https://www.w3.org/2009/cheatsheet/#search".
    Ex.
    Sub menu: Online Search
    Menu text: W3 CheatSheet
    Type: URL
    Command: https://www.w3.org/2009/cheatsheet/#search,
    Argument: [CurrentWord]

Tool item argument
    Added a new argument type to retrieve the current highlighter.
    The highlighter variable [Highlighter] is replaced by the current highlighter
    used under the text cursor in lower case. E.g. html, php, css ...

Scripts
    Added a new property to the document object to get the current highlighter
    at the cursor position. The name is returned as a string in lower case.

Options
    * Added an option for a default save path used when saving new files.
    * Added an option for auto open and auto hide panels. If disabled you have to click
      on a hidden panel for it to open and click outside of the panel for it
      to close again.

Auto completion and "fussy" sorting
    When you open an auto completion list and start typing a search string - you
    The letters in the search string just has to be found in that same order.

    To activate fuzzy sorting press "F1" while the auto completion window is open.
    You can press F1 repeatedly if you want to toggle between normal and fuzzy
    sorting. When fuzzy sorting is active the window background change to a green
    color.

    Ex.
    To find "mysql_fetch_array" in an auto completion list inside a PHP file
    you could press Ctrl+Space and type "myfa".
    All items with the letters 'm','y','f','a', found in ascending order will
    be listed. Which is just 6 items.
    Trying to type "mysql" results in a very large list.

    Ex.
    You can still use it as you always have. To find the "base" tag in HTML you
    can hit Ctrl+Space and start typing "ba".

    there are many similar items.

Indent / UnIndent
    Using the tab key (or Shift+Tab) to indent (or unindent) a selected block of
    text will now always select the full lines.

    Indent (unindent) block, found in the format menu, still behaves as before
    where the selection follows the indented block.

Misc
    * It's now possible to assign a keyboard shortcut to open the highlighters
      drop down menu.
    * Added a print option to have the file dir in the header/footer.
    * Made some scroll speed changes when selecting text horizontally.
    * The highlighter drop down menu is no longer disabled when opening ASCII files.

Fixed
    * HSL color slider issue in the 64-bit version.
    * Several issues with "Format - Convert file encodings...".
    * Several issues in "Insert text on each line...".
    * A JSON highlighting issue.
    * Dbl click issue with empty lines.
    * Shortcut issues with external browsers.
    * A URL mapping issue with "OpenInBrowserAction".
    * Alt-codes like Alt+182 and Alt+0182 should work now.
    * Code Explorer issues with JSON code.
    * Tracking of current position in Code Explorer for JSON files.
    * Drag n drop cursors for copy/move fixed.
    * Bookmark list issue when closing documents.
    * Horizontal scroll issue when ruler is visible.
    * A few print issues.

-----------------------------------------------------------
Version 11.12 (July 28, 2016)
-----------------------------------------------------------

Fixed
    * Error when reopening projects.
    * A few update issues.

-----------------------------------------------------------
Version 11.11 (July 24, 2016)
-----------------------------------------------------------

Drag n drop
    Drag n drop should now work between the editor and external programs, like
    Internet browsers, email clients, text editors...

    You can:
    * Drag text from other programs and drop it inside a document.
    * Drag text from a document and drop it onto a browser edit field or
      inside another text editor.
    * Drag a HTML link to a document and insert title and full path.
    * Drag files from an explorer window to open the files (improved in this version).

Chrome preview
    The 32-bit version on 32-bit Windows can sometimes prevent the program from
    closing properly. It should work properly now.

Hibernate (Windows shutdown or unexpected closure)
    Some information was lost when using hibernate. E.g. code folding, bookmarks...
    The information is properly saved in this version and restored when you
    restart.

    If the program is open and Windows is shut down - the program should not
    try to delay the shut down. I made some code changes to fix this.

    Also fixed a few issues when having an open project.

JSON Pretty Print
    Wrote new code without the use of the Delphi JSON parser. The code is pretty
    simple and should produce the same result as many online beautifiers.

    Note! The code is not validated, so if your JSON code contains errors the
    result may not be formatted as you would have expected.

Double click on brace to select contents
    A double click on a brace ()[]{}""'' will select the entire contents including
    the braces.

    If you press ALT - only the content between braces is selected. Not the braces
    themselves.

Misc
    * Folder of the last opened/saved file is used when saving a new document, unless
      the explorer panel is opened (in which case the current path is used).
    * Password is displayed in plain text when exporting a document as encrypted.

Fixed
    * Double click to select all between braces when the end brace is at eol.
    * Auto block completion ({..}) after single quotes.

-----------------------------------------------------------
Version 11.10 (July 2, 2016)
-----------------------------------------------------------

Chrome preview (v51)
    Updated the preview component and libraries to version 51.0.2704.

    NOTE! This version of the Chrome libraries does not work on Windows XP/Vista.

    Updated the HTML syntax files and added several new tags and attributes.
    The change is extensive and you will see several new tag attributes in the
    auto completion lists.

    Several issues with attributes was fixed. Corrected some boolean attributes

    Auto completion of stop tags should work properly now.

    Tags are no longer drawn with an error highlight color when editing and
    no start or stop tag match is found. Only complete start and stop tags are
    highlighted.

Z shell and bash
    Updated the bash highlighter and added a new one for Z shell (zsh).

Auto completion
    Made the list a bit larger and changed the position and borders.

Macros
    Macros can now use loops and if..else..endif structures. Several new macro
    commands have been added.

    The macro editor has been completely redesigned. Macro code is, when opened,
    automatically indented to improve readability. Syntax highlighting and
    auto completion is used as well. Use Ctrl+Space to list all available
    macro commands.

Hibernate
    Added as a menu item to the "File" menu.
    Hibernate will save the current session (open files and project) in a temp
    folder and reopen them when you run RJ TextEd again. Modified or new files
    are not saved, but temporarily stored in the temp folder.

    I've added an option if you want to hibernate every time the program closes.

Drag n drop
    Drag n drop now works between documents in dual document view.

    Press CTRL during the drag operation to copy the text. Otherwise the text
    is moved.

    Please note that the text is no longer scrolling when you drag a text.
    You can still scroll, if you have to, using the mouse scroll wheel.

Double click on braces
    To select everything between two braces (including the braces) you use
    the mouse to double click on one of the braces.

    This should work with ()[]{}""'' for most programming languages.

Recently opened files
    Added a search field to the recent files drop down list.

    You can set the number of files to display in the drop down list by setting

Copy as RTF
    Copy selected code as RTF should work again in this version. The colors
    used are the same as when printing. This looks better when e.g. pasting
    the clipboard content into Words (which uses a white background).

Misc
    * Updated Tidy.exe to the latest version.
    * The description field when adding file extensions in options has been removed.
    * Minor changes to the search progress dialog box.
    * Relative paths should now work when opening files from the command line.
    * Updated the HTML and CSS tree's in the quick bar.
    * Changed how the HOME and END curor movment work in word wrap mode.

Fixed
    * Bookmarks dropdown list in "Goto Line" dialog window was empty.
    * Replace All should not replace anything when a document is marked read only.
    * Option for allowed instances.
    * Option to allow Chrome preview.
    * HTML stop tag auto completion should work properly now.
    * Validation and beautify HTML should work now on all systems.
    * A document tab drag n drop issue. Could cause a permanent drag state.
    * Double click on document tab bar to create a new document would sometimes
      close the tab.

Version 11.07 (May 22, 2016)
-----------------------------------------------------------

JSON
    Added two new menu items in the format menu.

    * Pretty print - will beautify the JSON code and add indention.
    * Minify - will compress the code to a single line.

    JSON code is now displayed in the code explorer tree.

Highlight color values
    Added a new menu item in the view menu called "Highlight color values".

    * Enable for selected file types
    * File types

    The "File types" menu item contain all available file types and the checked
    items specify in which files, color values should be highlighted.
Reopen with Encoding
    Added a menu item in the "File" menu to reopen the current file using a
    different encoding. You can also reopen it as a hexadecimal file.

    Note! If the file is a Unicode file and has a BOM, you will not be able to
    reopen the file with a different encoding.

Merge and Split
    Added a menu to the document tab right click menu with several functions to
    append, prepend or split documents.

Annotation bar
    Made some redraw changes to minimize speed impact on editing.

Text Clips
    You can add or subtract time in a text clip when using time and date variables.

    E.g.
        %tomorrow% = @d[dddd d of mmmm yyyy]{+1d}
        %yesterday% = @d{-1d}
        %lastyear% = @d[dddd d of mmmm yyyy]{-1y}

        %AnHourAgo% = @t{-1h}
Auto hide scrollbars
    Mouse move will always display the scrollbars.

Project Manager
    "Copy to clipboard as" will use a relative path from the current document
    if possible. Otherwise the file name is used.

    To use the complete file path - hold down the Shift-key.

File Commander
    The breadcrumb control has been replaced with a drop down list to solve
    a few theming issues.

    The drop down list will always display the full path, just like the breadcrumb control did.

Misc
    * The drop down list on the explorer panel will display the full path to the current folder.

Fixed
    * Editing can sometimes be "sluggish" when the annotation-bar is visible.
    * The convert panel date/time span calculation should didn't handle a second date
      that was earlier than the first (a negative time span).

-----------------------------------------------------------
Version 11.06 (May 10, 2016)
-----------------------------------------------------------

Highlight colors in CSS/LESS/SASS
    Added a menu item option to allow highlighted colors values in CSS, LESS and
    SASS files. The menu options is located in "View -> Highlight".
    It is turned on by default.

    The type of colors highlighted are:
    - HTML color names like blue, red, saddlebrown...
    - Color values like #80ff40.
    - RGB() and RGBA() values.
    - HSV() and HSVA() values.
    - HSL() and HSLA() values.

    When highlighted - the color value is drawn using the color as the background
    color.

Color hint
    I've made several changes in the color hint window (mouse hovers over a color
    value).

    The hint now display colors in all supported formats: #xxxxxx, HTML color name,
    RGB(), RGBA(), HSV(), HSVA(), HSL(), HSLA() and decimal.

    Covert between color formats
        Each format is underlined and clickable. Click on a value to convert
        the color under the mouse cursor to a different format.

        Ex.
          The color under the mouse is RGB(0,0,255). Click on "blue" in the color
          hint and the color under the mouse cursor is changed to "blue".

    Open color wheel window
        Click on the color preview box to open a color dialog window.

Color dialog window
    I've made several changes in the color dialog window.

    * The added sliders can now handle RGB, HSV or HSL values.
    * Added a new tab with HTML color names.
    * Added several new color output formats.

    I also fixed several issues.

JSON
    Added a JSON highlighter. It should handle syntax highlighting and code
    folding. I'll try to add properties to the Code explorer XML tree in a later
    version.
Horizontal and vertical scrollbar
    Added an option to auto hide the vertical and horizontal scroll bars.
    The options defaults to "off", but can be turned on in
    "Options - Editor - Display".

SFTP
    * Added log output.
    * Fixed a few issues.

CSS toolbar tree
    Added a huge number of new properties and values.
    Also added dialog entries to the tree. E.g. "»colors" which will open the
    color dialog window.

Fixed
    * Menu font settings not always having an effect.
    * SFTP when accessing several accounts on the same server.
    * Theme color issue when all files are closed.
    * Changing syntax highlighter didn't always work.
    * An issue with multiplying browsers in HTML menu.
    * An issue with multiplying browser preview mappings.
    * An issue with multiplying file extensions.
    * Floating panel resize issues.
    * Small issue with indent lines.
    * The default save path for new documents is set to the "Documents" folder.
    * Issue when program was running and Windows shut down.

-----------------------------------------------------------
Version 11.05 (April 24, 2016)
-----------------------------------------------------------

    Updated the CSS syntax files and added several properties and property
    values. I also added several new -moz-, -ms-, -o- and -webkit- properties.

    * Updated the highlighter to include most CSS3 properties and values.
    * @-rules, strings and some keywords are now highlighted in CSS files.
    * Property value completion is triggered after you press ":" or a <space>.

SASS
   * Added several new properties and updated the highlighter to use most
     CSS3 properties and values.
   * Property value completion is triggered after you press ":" or a <space>.
   * Fixed some issues.

LESS
   * Added several new properties and updated the highlighter to use most
     CSS3 properties and values.
   * Property value completion is triggered after you press ":" or a <space>.
   * Fixed some issues.

VBScript
    Classes should now be handled properly.

Misc
    * A few improvements to the syntax editor.
    * Added an option to save the right margin position for each file.

    * The unit converter panel sometimes opened blank.
    * Code explorer panel sometimes opened blank.
    * Resize issue with split window.
    * Word count issue with fancy single quote.
    * "Enter" on file in Explorer panel.
    * Issue with "File has been deleted..." message.
    * "Save All" issue with external text windows (tab outside of main window).
    * A tool issue when the active document is an external window.

-----------------------------------------------------------
Version 11.04 (April 12, 2016)
-----------------------------------------------------------

SASS syntax highlighting
    Created a new highlighter for sass. It's installed automatically at startup.

    The ctrl+space completion list contain sass functions and argument hints
    are displayed.

LESS syntax highlighting
    Created a new highlighter for less. It's installed automatically at startup.

    The ctrl+space completion list contain less functions and argument hints
    are displayed.

Themes
      standard system dialogs like file open/save and task dialog boxes.

    * Added several new program styles available in the customize themes
      dialog box.

    * Changed how program style preview works in customize themes.

Unit converter panel
    Added a new item to calculate date and time span.
    You can calculate the span between two dates or you can add a time span
    to a date and calculate the new date.

Addons
    Made several changes in the addons dialog box.

    * Highlighters are now selected using check boxes in a list box.
      Default file extensions are automatically added when a new highlighter
      is enabled.

    * The active language is selected with a checkbox in the language list.
    * The side bar has a new appearance and made some other visual changes.

Syntax Highlighting colors
    Made some minor changes to the highlighting colors in "Windows.xml", "Glossy.xml" and
    "Charcoal Dark Slate.xml". If you want to use them - you may have to import
    the colors from the theme manager.

    NOTE! You should probably not import these if you have set or changed any
          syntax highlighting colors yourself.

Project settings
    Made some visual changes.

Misc
    * Made some changes to the statusbar character/column/selection hint.
    * The syntax highlighter name is now shown in the syntax editor title.
    * Some minor syntax editor improvements.

Fixed
    * Text size in function argument hint.

-----------------------------------------------------------
Version 11.03 (March 23, 2016)
-----------------------------------------------------------
Projects and synchronized folders
    Synchronized folders can be added from the context menu and the project
    menu. For each added folder you enter a new file type filter string to filter
    out files you do not want in the project manager tree.

    Synchronized folders are updated (re-scanned) when adding new files, deleting
    files or changing any file in the folder that is being synchronized.

    Class and function list data is updated every time the synchronized folder
    is updated.

Split Window
    Annotation bar should work properly now with split window.

    The focused editor window is kept when you turn off split window.

Statusbar and mouse click menus
    * To change the document newline format - you can click on "newline format"
      column on the statusbar and select another newline format in the popup menu.

    * To change the document encoding or codepage - you can click on the
      "encoding" column on the statusbar and select another encoding.

Misc
    * Made changes to the configure explorer favorites dialog window.
    * Made changes to the manage script dialog window.

Fixed
    * Shell menu (explorer panels) theme issue.
    * Script issues with Document.ReplaceAll()
    * A few wordwrap issues.
    * Split window issues.

-----------------------------------------------------------
Version 11.02 (March 10, 2016)
-----------------------------------------------------------

Unit Converter Panel
    Added a new panel for conversion between units. Units supported are:

    * Area
    * Angles
    * Data storage (Bytes, bits, KB, MB ...)
    * Length
    * Time
    * Volume
    * Weight and Mass
    * Temperature
    * Numbers (dec, hex, bin, oct)
    * Date/Time formats

    Date/Time format conversion are done between different date and time formats
    used in different countries. E.g. if you need to list a dates in a XML file
    you can easily do so by selecting a country format and insert the date in
    your file.

    <dates>
        <swe>den 1 mars 2016</swe>
        <us>Tuesday, March 1, 2016</us>
        <ru>1 Март 2016 г.</ru>
    </dates>

    To edit a value click on a value twice (not a double click), or hit SPACE when
    an item is selected.

Character Viewer
    Double click on a character instantly insert the character to the clipboard string.
Fixed
    * Chrome preview should work properly now.
    * Title file name issue when closing all open files.
    * Small issue with "Open folder in Windows Explorer".
    * Hex view issue.
    * Toggle dual document view issue.
    * Toggle comment issue in CSS.
    * Document tab icon issue when save.
    * Key issue in find/replace dialog.
    * Tab issues in find/replace dialog.

-----------------------------------------------------------
Version 11.01 (Feb 27, 2016)
-----------------------------------------------------------

Character Viewer
    Renamed RJ Charview to Character Viewer and made several changes to the tool.

    * Only printable characters are displayed. No more squares.
    * The window is resizable. The character grid font is resized as well.
    * All Unicode characters are displayed at startup.
    * Made changes to the Unicode sub-ranges.
    * A hints is displayed when hovering over a character in the grid.
    * Window size and options are saved between sessions.

Layouts
    Layouts in the environment menu should work better now.

    * Available layouts are listed in the layout menu.
    * Panel layouts are saved properly.
    * Main window size is saved and restored.

    Note! You may have to re-save old layouts for them to work properly.
Run files from Windows Explorer
    Files will open faster in this version if opened from Windows Explorer.
    It doesn't matter if the program is already running or not.

    All files should also open now if you use a theme. That didn't always work in
    previous versions.

Misc
    * Clone window now open at the same line and text cursor position as the original.

Fixed
    * Tab draw issue when using dual document view.
    * Comment issue in CSS.

-----------------------------------------------------------
Version 11.0 (Feb 15, 2016)
-----------------------------------------------------------

Application search
    Added a search field inside the menu bar to the right. The search results are
    display in a grouped list. The search is context sensitive so all groups may
    not always be displayed in the same order or displayed at all.
    Each group is also collapsible.
    The displayed groups are:

    -Recent
    -Menu items
    -Recent projects
    -Recent sessions
    -File commander
    -Addons
    -Theme manager
    -Options
    -Help
    -Online resources

    Use the context menu to change which items should be displayed in the list.
    E.g. if you feel that the options list takes to long to complete, uncheck
    "Options".

    Menu items are always displayed in the list.
    Some menu items have a radio or check button to the right. This indicates a
    setting. You can select it as usual with [Enter] or the item can be toggled,
    without closing the result list, with [Shift][Enter].

    * Use [Up] and [Down] arrows to navigate the list. You can also use the mouse.
    * Select an item with [Enter], or a mouse click.
    * You can toggle a menu item setting, displayed as a radio or check button,
      by using [Shift][Enter].
    * Use [Esc] to exit the search.

Statusbar hint
    Added a hint to the stausbar when the mouse hover over the line, col and
    character panel.
    and character information (including the Unicode character name).

Code Explorer
    Made extensive code changes and several changes in the code explorer panel.

    Name spaces and classes should display properly now in the upper display.
    Nested items are displayed in a tree structure.

    Structures are displayed in the lower display including structure methods, if
    available. I may change this in a later version.

    Methods and sub-methods should be sorted properly now.

Auto complete
    The height is adjusted automatically when only a few items are displayed.

Auto update
    If you update from the previous release - only the changed files are
    downloaded and installed. This reduce the download size and makes the update
    process faster.


Change document encoding
    Fixed several issues when changing encoding. Both when converting between
    ANSI encodings and ANSI to UTF8.

Misc
    * (Un)Indent lines now preserve selection better.
    * Floating panels now have a shadowed border.
    * Arrays should be foldable now if they span several lines.
    * Only the active document tab  has the active tab color when in dual
      document view.
    * If you disable all output options with replace all, a quick replace information
      string is displayed in the status bar. It goes away after 5 seconds.
    * A split window now open at the same location as the original view.

Fixed
    * Text clips should preserve indention.
    * Emmet issue with ^
    * Emmet XSL (XSLT) issues.
    * Column mode issues.
    * Search result toolbar button issue.
    * Wrong column value in status bar.
    * Wrong selected lines value in status bar when selecting upwards.
    * Toggle browser view issue.
    * Annotation bar should always use the document background color.

-----------------------------------------------------------
Version 10.91 (Dec 20, 2015)
-----------------------------------------------------------

Printing
    Added an option to set the font used for printing. Like the text font, you
    can set individual fonts for different file types.

    To use a print font you have to enable it in options (font and tabs options).
    If not enabled, the current code or text font is used. Just as before.

Fixed
    * Emmet encoding issue.
    * Emmet extract abbreviation issue.
    * Tool UTF-8 output issue.
    * Execute text clip from a keyboard shortcut.
    * A comment issue with the CSS/LESS highlighter.
    * Copy, paste and refresh issues in word wrap mode.
    * Edit issues in word wrap mode when syntax highlighter use regex.
    * A click on the annotation bar should give focus to the editor window.
    * Open file issue in the Syntax Editor.
    * A tab issue with printing.

-----------------------------------------------------------
Version 10.90 (Dec 14, 2015)
-----------------------------------------------------------

Emmet
    Included latest Emmet JS code and added several "HTML->Emmet" menu items.

    Expand abbreviation at cursor (Shift+Enter)
        Type an abbreviation e.g. "ul>li*5" and select menu item or hit
        Shift+Enter to expand the abbreviation under the cursor.

    Expand abbreviation (Ctrl+,)
        Opens a small edit box. Type the abbreviation and hit enter to insert
        the expanded code.

    Wrap with abbreviation (Shift+Ctrl+,)
        Select some code and select menu item. Type the abbreviation in the
        opened edit box and hit enter to insert the expanded code.

    Next edit point
        Find next edit point, e.g. between tags.

    Previous edit point
        Find previous edit point.

    Added 3 common entities as snippets.
        nb -> &nbsp;
        lt -> &lt;
        gt -> &gt;

    Emmet is not available on Windows XP or below.

Annotation Bar
    Display a narrow annotation bar beside the vertical scrollbar.

    A left mouse click on the annotation bar will move the text cursor that place
    in the document.
    The annotation bar display:

    - The current line
    - Selection (including multiple selection)
    - Changed lines
    - Bookmarks
    - Matching HTML,XML tags
    - Matching fold items
    - Find All matches

Chrome preview
    Updated the 64-bit version to a newer version (v45).

Text clips
    All input macros can now have names.

    %var% = @i[John Doe] Full Name
    or
    %cl% = @c My Color

    These names are displayed in the variable input window. If only one variable
    needs input, the name may not be shown. E.g. if you have a single input request
    for a color, the color dialog is shown and the name is ignored. But for a
    prompt input (@i) the name is still shown in the prompt window.

    All macro names are optional so

    %cl% = @c

    is perfectly fine.

Quickbar
    Redesigned the dropdown buttons to switch toolbar and changed icons.

Panels
    Except the search result and message panels. They open as fast but close
    after a small delay.

    You can assign a keyboard shortcut to view/hide any panel in "Customize keyboard...".

Open as binary files
    Added an option to edit file extensions used to identify binary files.

Misc
    * "Paste from clipboard" is now much faster in large files.
    * Made some visual changes in the toolbar. Syntax and spell buttons are
      resized if necessary.
    * Save prompt is not displayed anymore for cloned documents.
    * Document.BeginUpdate should work better in scripts.
    * Project "Rescan all files" will remove non-existing files from the project.

Fixed
    * FTP/SFTP upload issues.
    * Variable input issues with text clips.
    * Sort undo issues.
    * Text compare issue.
    * Issue where editor toolbar buttons could disappear.
    * Toolbar display issues.
    * Regex issue with Unix or Mac line breaks and find all.
    * External change warning when deleting file in "Save As..." window.
    * Hex view scroll issues.
    * Hex view edit and copy issues.
    * Hex view undo issues.
    * Several find/replace issues.

-----------------------------------------------------------
Version 10.80 (Nov 14, 2015)
-----------------------------------------------------------

Memory usage
    Reduces memory usage when opening source files.
    The editor should use about the same amount of memory as with plain text files.

    The change is most notable if you open a large file with a large number
    of lines.

    I also fixed a few problems related to large files, like slow search and freeze issues.

File explorer panels and File Commander
    Replaced all components with new ones. These are actively updated, a bit
    faster and handles themes better.

    * Startup should be slightly faster when explorer panels are visible.
    * The explorer panel shell dropdown list should look okay now with themes.
    * Added a refresh toolbar button.
    * Added a few options. Auto refresh could slow down startup and dir changes
      and is disabled by default.

    The file commander shell dropdown lists have been replaced with shell
    breadcrumb components and made some visual changes.

    All found items are now highlighted when doing a "Find" or "Replace". The
    current item is highlighted using the section color and all other items
    using a lighter color.

    This gives you a better view of the found items in your document and makes
    "Find Next/Previous" more intuitive. It is also the standard behavior in
    most modern editors.

    The colors can be changed in "Themes -> Customize". You can also disable the
    highlighting, if you wish.

Find/Replace All
    Made some small changes too improve speed when searching project files and
    files in a folder.

Resizable toolbar buttons
    All toolbar buttons are now resizable. You can set one size for main,
    preview, quickbar and file commander toolbars, another for panel toolbars and
    one for the editor toolbar.
    This allows you to use a larger button size on high resolution displays and
    use different button sizes on e.g. the main toolbar and panel toolbars.

    Redesigned the quickbar and removed the tabs. You switch pane using a
    dropdown menu to the left.
    This saves some space and makes the quickbar "blend in" better.

Chrome Preview
    Updated the 32-bit libraries to a newer version (45.x).
    Flash is not supported anymore in the 32-bit version.

    The 64-bit libraries (v39.x) still support flash, but are little older.
    There are a few issues with the newer libraries from v45.x (Devtools need
    to open in an external window, default background color is set to a random
    color and can't be changed). So I decided not to use them.

    Fixed several issues with Chrome preview and made some improvements.

    - Pages should render faster now.
    - Panel preview is updated properly when opened.
    - Media contents (video...) could crash the editor.
    - Some mouse wheel scroll issues.

    Added an option to enable/disable the Chrome preview. The Chrome library
    is not loaded if disabled.
    This option require a restart to work properly.

Multi select by left margin click
    Ctrl+LMouse click in the left margin will now toggle selection.

    Note that a Ctrl+LMouse click will deselect any selection found on the same
    line. Even if it spans several lines.

SFTP
    Updated the component to the latest version and fixed a few issues.

Highlighter (syntax files)
    Blocks can now use regular expressions for start and stop strings.

Misc
    * Updated tidy.exe to the latest version.
    * Added "Find in project files..." to the project panel context menu.
    * Added folding for some new HTML5 tags.
    * Addons window should handle theme colors better now.

Fixed
    * Editor toolbar theming issue.
    * Images were not drawn properly in customize toolbars when using themes.
    * Document tab issue when turning off the option to show images in tabs.
    * Code explorer and fold issue in C++ code.
    * Shift+Del issue in search fields.
    * Replace prompt could not be positioned.
    * Text sort undo issue.

-----------------------------------------------------------
Version 10.70 (Oct 9, 2015)
-----------------------------------------------------------

Chrome preview
    Added a chrome preview tab, internal Chrome browser and Chrome browser views.
    Chrome Developer Tools (DevTools) have been added to the internal browser and
    Chrome tab.

    We need an up-to-date preview browser and Windows IE is not actively developed
    anymore. The Chrome preview is up-to-date, but it is quite large in size.

    Chrome preview is available in all versions (install, portable, win32, win64)
    and may eventually replace the IE preview completely.

    Chrome preview is available on Windows XP and higher using the 32-bit version,
    Windows 7 and higher using the 64-bit version. You can still run the 64-bit
    version on Windows Vista x64, but Chrome preview is not available.

Message and input windows
    All dialog windows should use themes now. This include simple message windows
    and more advanced input windows.

Panels
    Panels use the program themes now, instead of there own styles.
    The old panel styles are still available and can be selected in the
    theme manager, but the program theme is used by default.

    Added options to have images in panel tabs and in unpinned panels.
    Images in tabs are shown by default.
Bookmarks panel
    Added a panel to list bookmarks in the current document. The toolbar
    buttons lets you add, delete or clear all bookmarks.

    The bookmark list will show the bookmark type (numbered or plain),
    the line number and the text on the line.

Document icons
    Changed the default document icons in all recent file lists, document list
    file types.

    You can also use associated system icons (Options -> Style and fonts).

Word count
    Added a checkbox to switch case sensitive word count on.

Text clips
    Redesigned the add/edit clip window. Variables are now a bit simpler to add
    and I removed one of the text fields.

    Text clips use one input dialog with one or several fields where you can edit
    all your input values. This is especially useful if the text clips use many
    variables and they need many input values from the user.

    To enclose a selection use the static %sel% variable.
    E.g. <div class="">%sel%</div>

    The %sel% variable can only be used once. If you need to use the selection
    again just add another variable and use the command @csel.

    Added new commands. @csel = current selection, @clbrd = clipboard content.
    E.g.
        %csel% = @csel
        %clip% = @clbrd
        now you can use %csel% and %clip% anywhere in the clip text.

Project panel (context menu)

    -File name
    -HTML CSS link
    -HTML image tag
    -HTML script tag
    -HTML anchor tag
    -HTML href=""
    -PHP include
    -PHP require
    -C/C++ include

Tool argument commands
    Added a few new commands to extract the drive, path (without drive) and
    file extension of the current document path.

Misc
    * Word completion should handle objects better e.g. "object.".
    * Added an option to set the max number of items in find/replace dropdown lists.
    * Added an option to close a document tab by double clicking the tab.

Fixed
    * Theme issue with document map.
    * Bookmarks on wrapped lines.
    * Scroll issue in hex view.
    * Some issues with word count.
    * Unfold All issue with user defined folds from a selection.
    * A few sort issues in Syntax Editor.
    * Syntax editor layout issues.
    * Issue with escape characters.
    * Several issues with binary files and hex view.
    * Auto update issues.
    * Close document tab with close button on active tab only.

-----------------------------------------------------------
Version 10.60 (Aug 23, 2015)
-----------------------------------------------------------

Color hint under mouse cursor
    To display a color hint move the mouse cursor over a color value in the text
    and wait a second. The hint is displayed until you move the mouse.
    The hint display the color in a colored rectangle together with several color
    values in different formats.
    The first value is an RGB() value. Next is a web color value e.g. #F2A723
    and last a decimal value.

Word wrap
    It is now possible to word wrap at the window edge, right margin or a specified
    column. When using fonts like "Arial" the column# value means characters.
    E.g. if you specify column 120 - the text will wrap at character 120.

    Hard wrap by inserting line breaks is available for both wrap at right margin
    and wrap at column.

    I also added an option to wrap at the absolute margin. This option allow the text
    to be wrapped at the exact specified value, instead of at an natural break point.
    E.g. if you set word wrap at column 80, the text will wrap after 80 characters. Even
    if that happens to be in the middle of a word.

    Added two new items in the format menu to format paragraphs.

    Reformat paragraph (indent first line)
    Reformat paragraph (indent following lines)

Text Clips
    Added a drop down menu to the text clips panel with some new functions.

    Import text clips...
        Read an XML file with clips, display a tree to let you select which text
        clips to import. You can either import to an "Imported" tree node or to
        the currently selected node.

    Export text clips...
        Opens a tree to let you select the text clips you want to export to an
        XML file.

    New variables
        Added new variables that can be used in text clips to open:

        a color dialog @c
        a font dialog @fn
        a file dialog @fi[<initial dir>]

        e.g.
        %%
        %dir%=@fo[c:\Windows]
        %file%=@fi[c:\Windows]
        %color%=@c
        %font%=@fn
        %%
        This is the path to my pictures "%dir%", and this is my favorite picture
        "%file%". The background color is %color% and the title font "%font%".

    Restore text clips from backup...
        It's a simple implementation where the text clips are saved to a backup
        file the first time you make a change to a text clip in a session. The
        backup file is then not updated until the next time you run the program
        and make a change in your text clips.
        If something should happen to the clips, e.g. while importing from a file
        or due to a nasty program/system crash, chances are you may be able to
        restore most of the clips by using this function.

Sync edit mode
    Made some changes to the sync edit mode.

    Insert any character:
        You can now insert any characters to the edited string(s). Even symbols.

    Select string and edit all identical strings:
        now you can select any string, containing any characters, and edit all
        identical strings at the same time.
        First select a string as normal. Press the left or right arrow key to
        clear the selection. All identical strings are now marked and can be
        edited.

Script undo/redo
    Document.BeginUndo ... Document.EndUndo will only add one item to the undo/redo
    buffer in this version. You can see this item in the undo/redo history window
    including the script name.

    Undo/Redo of a script action using BeginUndo/EndUndo is a bit faster as well.

Code Explorer
    Function and method tracking should now be able to switch class automatically
    in the code explorer. E.g. if the text cursor is inside a method in class A
    and you move the cursor to a method in class B - class B will be selected in
    the code explorer and the current method highlighted.

Store modified documents in a temp folder
    Modified open files are now saved in regular intervals to a temp folder.
    If the program crash or exit unexpectedly the program should open the last
    saved version when restarted.
    Note that this file may be a few minutes old and may therefor not hold all
    your latest changes.

    The editor will still try to save everything to a temp folder if the program
    crash, but sometimes that doesn't work.

Backup extension (.bak)
    Added an option to add a backup extension (.bak) to all backup copies.

Navigation history
    Changed when navigation points are saved. The different points in the same
    document has to be at least one page apart (can be changed in options).
    A new point may be saved when you left mouse click in the document or move
    the text cursor left or right.

Document tab mouse wheel scroll
    You can now scroll through the document tabs using the mouse wheel.
    The wheel scroll is activated when the left/right scroll arrow buttons are
    visible.

Misc
    * Some code changes to speed up the explorer lists in the panels and file commander.
    * The folder menu button hint on the search bar now display selected options.

Fixed
    * Select tag function issues.
    * Reformat paragraph when selecting upwards.
    * Reload as binary should switch the view to hex view.
    * Tab color based on file extension.
    * Block comment undo issue.
    * Theme issues with plain text.
    * A large number of other minor issues...

-----------------------------------------------------------
Version 10.50 (July 17, 2015)
-----------------------------------------------------------
Hex View
    Hex view and hexadecimal editing abilities has been added to the text memo
    component. The 3d party hex editor component has been removed.
    The loaded text or binary file is not altered or loaded between components
    anymore when switching between text and hex mode. Everything is handled by
    my text memo component. This means undo/redo always work even if we switch
    between views and the hex view can use theme colors.

    * Options are available in the context menu.
    * You can display 16, 24 or 32 bytes per row.
    * You can group 1 or 2 bytes in each column.
    * You can display the text as ANSI or ASCII.
    * Undo/Redo now works even if you switch between text and hex view.
    * Colors can be set in the themes manager.
    * Font is set in Options -> Font and tabs.
    * Print font size is auto adjusted to make sure the display is fitted to each
      printed page.
    * Goto (Ctrl+G) a specified address in the file.
    * Some of the select functions work in hex view as well, like "Select All",
      "Select current line", "Select to EOL"...

    You can copy selected bytes (or words) as:
    ASCII/ANSI
    C/C++
    C#
    Java
    Pascal/Delphi
    Visual Basic .NET
    -
    Rich Text (RTL)

    Plain text and code is displayed as 16-bit words and it's indicated at
    top left corner. Binary files are displayed as 8-bit bytes.

ASCII
    ASCII files are handled differently in this version. All ASCII files are
    opened and loaded without any conversion to Unicode. They are handled as binary
    files internally. ASCII characters are still displayed correctly for all
    code pages.
    Converting between ASCII code pages will not actually change the file data.
    Nothing is altered, the characters are only displayed differently depending
    on which code page is selected.

    * You can even convert between ASCII and Unicode (and back).

    * Undo/Redo works now with conversion and changing encodings.

    * The symbol panel page "ASCII" is now adaptive and always display the full
      ASCII range based on the current code page used.
      If the current ASCII file use OEM Cyrillic - those characters are displayed in
      the ASCII page.

    * ALT + code should work properly now as well and insert the correct values.

Convert between ANSI/ASCII and Unicode
    All convert functions in the "Format" menu should work correctly now and work
    with undo/redo. You never risk loosing anything when doing a conversion. You
    can undo any conversion operation.

    Added an item to the "New" dropdown list on the main toolbar to create a new
    file. In the dialog window you can enter name, extension, file type,
    and encoding. You can also create a new binary file.

    It is also available on the "Home" page in the "Create new file" area.

Document map
    Added an option (in font and tabs section) to change the font size.
    The current line is highlighted in the document map.

Printing
    Added an option to auto adjust the printer font size to fit all text within
    the right margin (or column 80) to the printed page.
    This option is set by default and is available in the print dialog window.

Home page
    Made some visual changes to the home page and added an item to open the new
    dialog window for creating a new document.

Script menu
    Added a few new menu items to the script menu.

    * You can now add scripts to the script menu for quick access. This is a very
      simple implementation and only list the added scripts at the end of the
      menu.
      You can manage the added scripts (sort, remove...).

    * If you select the menu item "Run and select document..." you are prompted
      to select an open document. This document will be moved to the right side
      and used as the "Document" in the script.
Projects
    You can now assign a keyboard shortcut to all project commands (compile,
    build, run and user commands). Compile, Build and Run and Run without build can be
    enabled in the main toolbar. Use "Environment - Customize toolbar" to enable them.

    Added an option to save modified files before build.

Search bar
    Made a few changes to the search bar. You can now use a one-line bar when
    searching in folders or project files. Use the new folder button to open a menu
    with a list of recently used folders, search filters and other folder
    functions and options.

Document switch list (Ctrl+Tab)
    Document switch list now handles mouse click, double mouse clicks and
    mouse wheel scrolling.

    A single left mouse click will focus the item and display the document path.

    A double left mouse click will focus the item, display the document path
    and switch tab to the selected document. The document switch list remains
    open.

    If the vertical scrollbar is shown - you can scroll the list using the mouse

Line numbers
    Replaced the line number menu items in the "View" menu with one menu item.
    "Line numbers" will display or hide the line numbers for the current file
    type. So you can enable line numbers in text files, hide them in CSS files but
    display them in PHP files...

Misc
    * Optimized code and improved editing performance.
    * Minor changes to how tab controls are painted.
    * Added an output format item to the color dialog for just the RGB values.
    * Remote FTP file path is now displayed in the window title.
    * Added an option to set the navigation history offset. The default is 1 page.
    * Format - Wrap lines at margin... should work with selections now and handle
      the column# value properly when using a proportional font.
    * Added "Save Copy As..." to the tab context menu.
    * Multiple selections are displayed in the document map.
    * Document tab hint information is better formatted.

Fixed
    * Open and save binary files didn't work properly and could corrupt the file.
    * Open, save and edit ASCII files didn't work properly.
    * "Unwrap lines by removing line breaks..." now work on selected text.
    * Auto highlight issue when displaying find results.
    * Syntax change issue when saving a text file and using a different extension.
    * Window redraw issue, could result in jumping display in panels...
    * Document map draw issue when selecting text with auto highlight words.
    * Cursor position issue when document map is displayed.
    * Several other minor issues found when working on this release.

-----------------------------------------------------------
Version 10.40 (June 1, 2015)
-----------------------------------------------------------

Document map
    Added a document map view to the right inside the editor window. The view
    option is available in the "View" menu.

    The document map display a larger layout of the current document giving
    you a better overview. This can make it easier to edit, scroll and navigate.

    Highlighted words or selections are highlighted in the document map.
    Changed lines are marked by a line on the left.
    Bookmarks are marked by a small line to the right.
    The current page is indicated by a colored line to the left of the document map.

    Navigate by mouse click
        You can navigate by a mouse click in the document map.
        The document view is moved to the clicked position in the document map.

    Scrolling
        * Normal scrolling will scroll and move the page marker in the document map.
        * Press Ctrl + dragging the scroll thumb to scroll the document map only.
          When you release the mouse button the document view is moved to the
          new location.
        * Mouse wheel scroll is faster when over the document map.
        * Ctrl + mouse wheel scroll will scroll the document map only.
          The document view is moved when you release the Ctrl key.

    NOTE! Not all editing actions are immediately reflected in the document map.
    E.g. editing text on a single line is not immediately updated in the map.
    Selection is not updated until you release the mouse button etc.
    The document map is designed to have almost no impact on performance. But
    it should be updated when scrolling, clicking the mouse in the editor area
    or creating a new line...

Color selector
    Added output options to the color dialog window available in e.g. "Tools" menu.

    * You can select to output the color to the editor or the clipboard.
    * You can choose one of several color formats like Dec, Hex, RGB(r,g,b).
    * You can select output case e.g. #ffccaa, rgb(255,180,120) or #FFCCAA...

    Selected color in the document is used when opening the dialog window.
    All supported color formats can be used.

Home page
    Added a tab control with three tabs. Recent files, recent projects and
    recent sessions. This gives each recent list more space and we can display
    all three.

    Made some other minor layout changes as well.
Script menu
    Added a script menu. This allows you to handle scripts without the quickbar.

Script
    Added two new functions to the document object.

    Document.BeginUndo() - create an undo starting point
    Document.EndUndo()   - create the undo end point

    When the user press "Undo" all operations between BeginUndo() and EndUndo()
    will be undone.

Sessions
    Sessions are now listed in last saved order. New saved sessions are displayed
    first in the list. Old updated items are moved to the top when saved.

Search progress
    I've made the search progress window wider and added a progress bar.
    The total number of files is displayed with the current file number. And
    files are now displayed with a path (compressed if necessary).

Recent file list
    You can now set the number of items that should be displayed in both menu's
    and on "Home" page in options.

    Recent project and session lists are not affected. The number of projects
    and sessions displayed are unlimited.

Tools
    If you've set up the tool to display an output and the output is UTF8 encoded
    If the option is unset the output is assumed to be ANSI.

Undo/Redo history
    Made some visual changes and added a start point (undo state when the file
    was opened).

Misc
    * Removed the document tab menu item to change the tab color.

Fixed
    * A selection issue.
    * Document tab multi line hint issue.
    * Inserting text on each line.
    * Redo issue with "Insert text on each line".
    * Window title not updated when closing right view
    * Code explorer tab text color issue.
    * A few issues in the help file.
    * Document.Wordwrap in scripts.
    * RegExPos() in script should return 0 if nothing is found.
    * Switch highlighter manually didn't always work with files without extension.
    * Triple quote issue in Python.
    * Crash at Windows log off with modified files.
    * Recover files after crash, log off or reboot.

-----------------------------------------------------------
Version 10.30 (Apr 28, 2015)
-----------------------------------------------------------

Clone document window
    Added menu items to the document tab context menu (right click over tab) to
    clone the current window. You can clone the document as many times as you want.

    Cloned documents are the exact same document in new document tabs. Basically
    it's the same as split window, but the clones reside in there own tab.
    Any change made to one document is immediately seen in all the others.
    You can move them around, drag them out to an external window or close them
    in any order. Just like a normal document.

Wordwrap with hard return
    Added option to enable wordwrap at right margin by inserting hard return
    (CRLF) when wrapping the lines. It works with indent wrapped lines.

Wrap lines at margin with line breaks
    This feature was previously called "Insert line breaks". I've changed the
    name and redesigned the feature and options.
    You can now wrap all lines at the window edge, right margin, a specified column,
    or as displayed if wordwrap is turned on.
    You can also choose to indent wrapped lines.

    A menu item is available in the format menu.

UnWrap lines by removing line breaks
    Unwrap lines by removing line breaks will unwrap lines and preserve paragraphs.
    This feature has been renamed was previously called "Remove line breaks".
    Information text was made clearer.

    A menu item is available in the format menu.

Join lines (in edit menu and as script function)
    The join lines function should now by default add spaces between joined lines
    and join lines even if they are blank.

    - Document.JoinLines
      The script function Document.JoinLines(bAddSpaces, bSkipBlankLines) now have
      two new arguments. This allows you to change the behavior.
      bAddSpaces - add space between joined lines, or not.
      bSkipBlankLines - preserve paragraphs by skipping blank lines, or not.

    - Document.DeleteCurrentLine
      Added a new function to delete the current line. This is already available
      in the editor but was not added as a script function.

    - Document.DeleteLine(line)
      Added a new function to delete a given line.

Code explorer panel
    A double click on a class name should move the text cursor to the class
    in your source code.

Reopen as binary file
    Added "Reopen as binary file" as a context menu item to the document tab.
    It will reload the file and display it using binary mode.

    In binary mode control characters are displayed as symbols, text is wrapped
    at the right margin and contents is always displayed as ANSI. The file may
    contain zero's or other ANSI control values between 0 and 32.

    Added a menu item to the "File" menu to save a copy of the current file.

Install and update the portable version
    Added a folder called "Install and Update" which include an InstallUpdate.exe
    tool and a ReadMe.txt file.

    The tool is very easy to use and is able to copy the portable version to a
    new location or update an existing one.

Menu and theme fixes
    Disabled text is now drawn properly using the correct colors.
    Selected text should use the correct colors.

Misc
    * Delete from disk in the file menu now moves the file to recycle bin.
    * Added a button to "Save Session" dialog to insert current date/time as a description.
    * Changed how HereDocs are highlighted in PHP code.

Fixed
    * Mouse wheel scroll over the explorer tab should work again.
    * Slow clear of items in code explorer tag tree.
    * Tab color issues with themes.
    * A few install issues with multiple user accounts.
    * Regular expression find in Unix or Mac files.
    * Menu item colors when using themes.
    * Main tabs should remain hidden even if you switch to one.
    * Some syntax issues.
    * Select issue when scrolling.
    * Draw issue with themes (Canvas can not be drawn to).
    * Several find/replace issues.
    * A few undo/redo issues.
    * Redraw issues.
    * Several other misc issues.

-----------------------------------------------------------
Version 10.24 (Apr 17, 2015)
-----------------------------------------------------------

Fixed a line change marking issue with replace all.

-----------------------------------------------------------
Version 10.23 (Apr 17, 2015)
-----------------------------------------------------------

Document tabs
    Made several changes to the document tabs and moved most tab display options
    to the theme manager. Tab colors are now connected to a theme so you can have
    different colors for different themes.

    Redesigned the tab close button. Should look better with most themes.

    The tabs themselves are drawn a bit differently and a few display issues has
    been fixed.

Tree views (search result, project view, code explorer...)
    Tree views didn't work properly with themes and had several issues. I've
    made several code changes to both the tree view control and the scrollbars.
    This should fix several issues and tree's should look better using themes.

Text clips (clipboard history)
    The clipboard history view should use proper theme colors now.

Color picker buttons
    Made code changes to the color picker buttons (options, theme manager...)
    to handle themes better.

    PHP and ASP tags are now highlighted just like HTML/XML tags.
    You can also use the "Search -> Matching bracket" function to jump between
    the enclosing tags.

Scope in search dialog window
    Replaced the dropdown list "Find where" with radio buttons. It was replaced
    on both the find and replace page.

Search (and search in files)
    In customize keyboard you can assign a shortcut to an action called "FindInFilesAction".
    This action will preset the scope and enable the folder field and buttons.

    intuitive.

Incremental Find (Ctrl+E)
    When the edit field has focus you can move up and down the found items by
    pressing the UP/DOWN arrows.

    Fixed an issue with the options dropdown menu.

Misc
    * The document tab list now uses the same file order as the document list panel.
    * Number of selected lines are displayed in the statusbar.
    * Mixed line breaks are preserved when switching hex view.
    * Made some code changes to how proxy authentication is handled.
    * Added search result option (in context menu) to "Open all nodes after search".

Fixed
    * Hex view colors issue in options.
    * Open binary files e.g. .exe or .mp3.
    * Toggle hex view with binary files.
    * Split window issue with some file types like HTML files.
    * Remove folder from project.
    * Incremental search option issue in 64-bit version.
    * Replace in folder using 64-bit version.
    * A few display line breaks issues.
    * Find/Replace result view context menu "Close all nodes".
    * Theme manager issues and editor tab color problems.
    * Remove recent items on main tab "Home" when using filter.
    * Scrolling in split view.
    * Several find,replace and count issues.
    * Several minor issues when dragging the document tab to a new external window.
    * Several theme related glitches.
-----------------------------------------------------------
Version 10.22 (Mars 21, 2015)
-----------------------------------------------------------

Mixed line breaks
    The editor will now handle files with mixed line breaks.
    The status bar will add a *Mixed to indicate this e.g. Text file (*Mixed Windows).
    The mixed line breaks are preserved and will still be there when you save the file.

    * With "View line breaks" turned on - different line breaks will be displayed
      using different characters.

    * Moving the text cursor to the end of line will display the line break in
      the status bar.

    NOTE!
    A file should only contain one type of line breaks.

    Windows (\r\n), Unix/Mac (\n), Classic Mac (\r).

    If you open a file on different platforms you may end up with a file
    containing mixed line breaks. This is certainly not desirable and you should
    use the menu commands in "Format -> Newline format" to clean up the file.

FTP (Client and panel)
    The FTP client and FTP panel now include a log window displaying sent and
    received commands.
    A log view toolbar button has been added in the FTP panel.

    All file transfers are now verified if the FTP server support checksums. This
    includes synchronize transfers, upload, download and editing remote files.

    Added an action to display the word completion list. Even if the word complete
    option is disabled.
    To use it assign a keyboard shortcut to the action "ShowWordCompletionListAction"
    in "Environment -> Customize keyboard...".

Editor settings
    A backup is now created and restored if the main settings file is (for some reason)
    lost. If the settings and backup are both lost a backup of the original settings
    are restored.

Search field on "Home" page
    Added search fields for recently opened files and recently opened projects.
    You can use a simple phrase or use wild cards.
    I also removed the "Open..." buttons.

Context menu on "Home" page
    Added context menus in the recently opened lists. Menu items are Open, Remove
    and Clear. Open and remove work on all selected files, but only on one item
    in the recent projects list.

File commander
    Removed the buttons at the bottom and redesigned the vertical toolbar.
    File manager buttons are visible when not connected to a remote server and
    FTP client buttons (download/upload/sync/log) are only visible when connected.

Option to check HTML/XML tags for file encoding
    The editor always check HTML and XML files for charset and encoding tag
    attributes. If found the encoding is used when opening the file.
    This is still the standard behavior, but now there is a way to disable
    this check.

Block selection
    on the end position while pressing SHIFT+ALT will temporarily turn column mode
    on and select a column.

    You can still use the SHIFT+ALT+Arrows or ALT+LeftMouse drag to select a
    column block.

Misc
    * Changed selection behavior when moving lines up or down.
    * Selection folds are working again in plain text files.
    * Selection is stored when closing the file, just as cursor position.
    * "Open file at cursor" will now check environment paths to find the file.

Fixed
    * A few issues with SFTP and using key files.
    * A selection issue with move line down function.
    * Ctrl+DblMouseClick over a parenthesis didn't always select the enclosed
      text over multiple lines.
    * Remove object from project error.
    * <?= should be highlighted in PHP files.
    * FTP proxy server issue.
    * Several Syntax Editor issues when editing regular expression keywords.
    * Recent files with UNC paths could slow down startup.

-----------------------------------------------------------
Version 10.21 (Feb 24, 2015)
-----------------------------------------------------------
Vertical scrolling
    Made several code changes to make scrolling faster when using up and down
    arrow keys. A few repaint issues were solved as well.

    Several code changes were made to improve speed with a visible ruler.

Indent lines
    Fixed several draw issues with indent lines and made it more robust.
    Matching code elements should be better indicated in most programming
    languages.

Auto completion
    Made "Word completion" is a bit faster and it should use less memory.

    * Fixed some paint issues when using themes.
    * Fixed a lowercase issue with word completion.

Scripts
    The default file extensions for all script languages have been changed.
    The new extensions are:

    BasicScript (.vbfs), JScript (.jsfs), C++Script (.cppfs) and PacalScript (.pasfs).

    The old extensions still work but to ensure that the syntax highlighting and
    auto completion work - add an "fs" at the end of the file extension.
    E.g. "MyScript.js" => "MyScript.jsfs"

Tools and Zen window
    External tools and Zen window are now theme aware and will use the same theme
    as the main program window.

Search folder (in search-bar)
    The drop down list width is adapted to the contents. The longer the folder
    paths the wider the drop down list.

Misc
    * Made drawing faster when the ruler is visible.
    * General text drawing should be a bit faster. In some situations a lot faster...

Fixed
    * Some options were not saved properly.
    * Copy and paste issues in find/replace dialog.
    * Menu position issue when using multiple monitors.
    * Duplicate line undo issue with empty lines.
    * Close document with "File has been deleted..." warning message.
    * Folder search should open the full search-bar.
    * Disable background colors for syntax elements in the theme manager didn't work.
    * Wordwrap issue with complex scripts (Unicode).
    * "View -> Set font..." only set the font temporarily.
    * Context help hints in project settings didn't work.
    * Document tab issue when closing tabs (in some situations).
    * Issues when saving keyboard shortcut changes (or creating the file, if missing, at startup).
    * Auto highlight selected words didn't always work.

-----------------------------------------------------------
Version 10.20 (Feb 7, 2015)
-----------------------------------------------------------

Open a document in a new window
    If you drag a document outside the page control and release the mouse button,
    the document is opened in a new external  window. This can be very helpful

    I also added a menu item for this in the document tab context menu.

    Closing the document window will return it to the main window as a normal tab.

Indent lines
    Indent lines are drawn differently to make code elements and folds easier
    to see.

    Added an option to only display an indent line when the text cursor is on
    an code fold node. This is very helpful when you want to identify a code
    block or matching tags, but don't want the code cluttered with indent lines.


Explorer tab dropdown list (combo)
    Added a toolbar button on the explorer tab to show/hide the dropdown list.
    This gives you the option to only display the tree, just the dropdown list
    or both. You probably shouldn't hide both though.

Toolbar icons
    Replaced several toolbar icons that should look better on dark themes.

Command line option /SILENT
    Added a new command line option to open the editor silently. This means no
    splash screen, no reopening of last opened documents and the editor opens
    even if the "Only allow one instance..." option is set.

    You can for instance use it to open the current document in a new instance.

    Ex.
    Menu Text: Open in new instance
    Command: c:\Programs...\RJ TextEd\TextEd.exe
    Arguments: /Silent [FilePath]

Script functions and streams
    Added three new functions and fixed several issues with streams.
    The help file has been updated and examples reviewed.

    New functions are:
    function DirectoryExists(filename: String): Boolean
    function FileExists(filename: String): Boolean
    function FileSize(filename: String): Integer

Misc
    * Append to clipboard will append the current line if nothing is selected and
    * The toolbar items "New,Open,Save" are always visible and can't be removed.
      This is done to avoid issues that may occur otherwise.
    * Some minor changes in the project manager search function.
    * Cut/Copy/Paste should work better in find/replace fields.
    * Count (Search) now display found matched expression for normal search as well.

Fixed
    * Multi edit issue when placing cursors in random order.
    * User dictionaries are working again.
    * Scrollbar display issues with themes.
    * URL:s were not highlighted.
    * Auto indent should only insert spaces when the option "Tabs insert spaces" is set.
    * Save issue when running a tool.
    * Fold issues when comment folding was turned off.
    * Minor issue with document tab switch and MRU sort.
    * Close document tab issue (may occur very seldom).
    * Tool output issue when run in the background.
    * Find issue in the explorer tab.
    * Customize theme issues.

-----------------------------------------------------------
Version 10.11 (Jan 8, 2015)
-----------------------------------------------------------

Search field in project panel
    Added a search field on the project panel. It can find and handle both local
    and remote files.

Misc
    * Some minor visual changes.
    * Holding the keyboard shortcut to close the current document, will close all
      documents first after 3 documents have been closed.

    * Crash when closing a document or the program.
    * Selection issue when using some save options.
    * An issue with reload document.

-----------------------------------------------------------
Version 10.10 (Jan 5, 2015)
-----------------------------------------------------------

Search result panel
    Added a toolbar button to view/hide (toggle) the search result panel. It's
    not visible by default. You can change that in "Environment -> Customize Toolbars".
    The keyboard shortcut SHIFT+ALT+F10 should work now too.

Import old (v9.x) syntax colors
    Added a dropdown menu item in themes manager to import old syntax color
    settings (v9.x). The dropdown menu is located to the right of the highlighter
    dropdown list.

    To import the C++ syntax color settings made in version 9.x - open the theme
    manager and select C++ as the current highlighter.
    Choose to "Import old syntax colors from settings" in the right dropdown menu.
    This will copy your old color settings and it should be visible in the list
    below.

Gutter selection (left mouse click in left margin)
    Gutter selection now always select full lines and expand selection when
    doing a SHIFT+LeftMouseClick in the left margin above the current selection.
    If a partial selection is already made, the selection is expanded to include
    full lines.

Script case functions
    Script case functions now use Windows API for better Unicode support.

    The default save folder is only used for new documents. When you try to save
    the new documents, the save file dialog opens in the default save folder.

    E.g.
    TextEd.exe /DIR "F:\MyFiles\MyFolder"

    when you create and save a new document the save dialog opens in
    "F:\MyFiles\MyFolder".

Misc
    * File Explorer tab issue. Changing tab could trigger drag n drop.
    * Key issues when editing file names in FTP tab (del, backspace...).
    * CloseAction (shortcut to close document) will close all documents if held down.
    * Made several minor visual changes.

Fixed
    * Issues with Unicode Big Endian encoded files.
    * Word count.
    * Splash screen position at startup.
    * Several find bar issues.
    * Backup document issues.
    * Mouse scroll issues in dialog windows and some lists.
    * An replace issue.
    * Text cursor issues.
    * Several issues with XML folding and in code explorer.
    * Shell combobox issues with themes.

Version 10.0(1) (Dec 2, 2014)
-----------------------------------------------------------

Minor update
    Updated the archive to fix a minor, but very annoying issue.

-----------------------------------------------------------
Version 10.0 (Dec 1, 2014)
-----------------------------------------------------------

32 and 64 bit version
    The main program and all included tools are available in 32 and 64 bit versions.

Program language
    If you install the program for the first time you are presented with the option
    to select the language to use in menus, windows and other texts.
    You can still change it manually in "Environment->Languages".

Panels
    The sidebars and bottom-bar has been removed and replaced by dock able panels.
    Panels can be pinned, unpinned and dragged to almost any position you want.

Themes
    Everything that changes the appearance are now handled as themes. This include
    application skins, panel styles and editor syntax highlighting and other editor
    colors.

    Themes are managed in the theme manager dialog window, available in the
    environment menu.
    All skins options have been moved from addons and syntax highlight settings
    have been moved from the options dialog. Everything is now handled in the

    All created themes are listed in the (Environment -> Themes) menu. A menu item
    to open the "Theme manager..." has been added as well.

    For the average user this will make it much simpler to change the appearance.
    Changing a themes changes the application skin, panel style and editor colors.
    The more advanced users can still change all colors and set individual colors
    for different file types. It will also be possible to import/export syntax colors.

Visual appearance
    The entire design is a bit flatter and some dialogs and icons have been changed.

Addons
    Redesigned the addons dialog window to make things more intuitive and updating
    addons simpler.

Script and extensions
    The programming languages and components is now fully support Unicode.

    Characters now have there own type. They are not handled as integers anymore.
    This means you can use declarations like:

    char ch = str[1];
    char ch = #32;


    if (ch == "Z") { ... };

    The char type can handle Unicode characters.

File associations
    Associations can be added directly in the options dialog window
    "Options -> File". The Associate.exe file has been removed from the installation.
    It is no longer needed.

Symbols panel
    Symbols are now read from a file "AppData\RJ TextEd\Data\PanelSymbols.txt".
    You are free to modify this file if you wish. It is not overwritten when
    updating the program.
Font quality
    It is now possible to set the font quality of the text rendered in the editor,
    menus and all program windows.
    To change the font quality setting open the option pages:

    Editor text
    Options -> Display.

    Menus, windows...
    Options -> Style and fonts.

    Or simply use the search feature in options.

Open recent files (Sessions,Favorites)
    Made some changes and placed the checkboxes to the left side.

HTML preview
    The Firefox and Chrome previews have been removed from the program. They are
    both outdated and incredibly buggy. I spend most of my time just trying to fix
    issues in those two components, or find some workaround just to make them run.
    That time could have been used to make improvements to the rest of the program
    instead.

    The IE preview is still available and I have no intension to remove it. It's
    always up to date and is very stable.

Passwords
    Passwords to remote FTP servers are encrypted, when store locally. This new
    version is not compatible with the old versions, so you will have to re-enter
    all passwords to your FTP/SFTP servers and proxy servers again.

Install script
    The setup file include both 32-bit and 64-bit binary files. On a 64-bit
    files are installed.
    If a 32-bit version of the program is found on a 64-bit Windows, You are
    asked to uninstall it.

Portable version
    The portable version include both 32-bit and 64-bit versions. I also created
    links to make it easy to run each version.

Fixed
    Fixed several issues reported by users.

-----------------------------------------------------------
Version 9.20 (July 15, 2014)
-----------------------------------------------------------

Sort lines (Asc, desc, advanced)
    Re-wrote the sort routines to increase speed and use
    less memory.
    The undo/redo functions use much less memory as well.

Scripts
    Added a "Printer" object to enable printing from a script.

    Added a new class called "TMemInifile". Use it to create or
    read ini files.

    Added the class "TElMainMenu". Use it to create a main menu
    in a script form. The help include an example script.

    Added new events: OnApplicationActivate, OnApplicationDeactivate and
    OnDocumentReload.

    Updated the help to include some more non-visual classes,
    visual components and dialogs.
    The TTnt classes were removed. They are not needed in version 10.
    All classes and components will support Unicode in version 10.

HTML Preview
    Both Firefox and Chrome preview components have been removed from
    the installation. They can still be installed using the "Addons"
    dialog window.

Addons
    Added pages to handle HTML preview components. Both Firefox and Chrome
    preview components can be installed or removed.

File Commander
    Added 7-zip support and made some changes to the compress option
    dialog window.

Misc
    Fixed some minor issues.


-----------------------------------------------------------
Version 9.10 (June 7, 2014)
-----------------------------------------------------------

Application recovery and restart
    If the program crashes Windows will ask if you want to restart the program,
    shut it down or continue running. Application recovery and restart only work
    on Windows Vista or later.

    All open files can be recovered. Even modified, remote or new files.
    An open project is recovered as well.

    If you restart the program the currently opened files are saved and
    reopened after restart.
    If you close the program all files are saved and you are asked to recover
    the files the next time you run the program.

Undo/Redo
    Macros are now undone or redone in one single step.

Backup files
    It's now possible to backup up to 100 copies of the document. The current
    date and time is added to the backup files.

    If you want to backup to a folder you can either type a folder name or give
    a full path. If you only type a name - a subfolder is created for the backup
    files. E.g. type "_Backup" in options if you want the backups in subfolders
    with the name "_Backups".

    Fixed a few issues.

Select tag text block
    Added a menu item to select the text between a start tag and an end tag.
    "Edit -> Select -> Select tag text block".

Scripts
    Added new Unicode enabled classes to be used in scripts.

    TTntStringlist
    A Unicode string list.

    TTntForm

    TTntGroupBox/TTntCheckBox/TTntRadioButton
    Unicode enabled group box, check box and radio button.

    TTntLabel/TTntButton
    Unicode label and button.

    TTntComboBox/TTntListBox
    Unicode enabled combo and list box.

    TTntEdit/TTntMemo
    Unicode enabled text edit controls.

    TTntFileStream/TTntMemoryStream
    Streams that use UTF-16 instead of ANSI.

Help
    Added new topics in the script section for common visual components like
    labels, buttons, listboxes, comboboxes, forms, edit controls, memos, groupboxes,
    checkboxes and radiobuttons.

Misc
    * Added "Halt a running script" in the "Tools" menu.
    * Auto save only save modified document.
    * Sort functions should work in a macro now.

Fixed
    * A language issue in the Dutch language file.
    * List of addons to download was not updated properly.
    * Hex editor options.
    * Several issues in options.
    * Highlighter dropdown list issues with user highlighters.
    * Reformat block with indent.
    * Reformat paragraph sometimes added a space at the beginning of a line.
    * Command line option /L didn't work if the program was already running.
    * Reload document shouldn't change the file encoding.
    * Code fold issues.

-----------------------------------------------------------
Version 9.0 (May 19, 2014)
-----------------------------------------------------------

Navigation history
    Added navigation history buttons in the main toolbar. Back button, forward
    button and dropdown lists. You can also use Alt-Left or Alt-Right.

    In options (Program -> Navigation history) you can set the number of saved
    navigation points and if you want to include main tab changes, like a switch
    to the file commander tab or the preview tabs.
    You can also activate full path hints, if the displayed file name is not
    enough.
Scripts
    Characters are now handled as integers (char = int). To assign a character
    variable you can do the following:

    char wch = Ord("A");

    or

    int wch = Ord("A");

    or

    string s = "ABC";
    char wch = s[1]; // wch now contain the integer value of "A", which is 65.


    if ( wch == Ord("A") ) { .. }

    or

    if ( Chr(wch) == "A" ) { .. }

    Ord() converts a character, given as a string, to an integer value.
    Chr() converts an integer value to a character, given as a string.

Options "Apply"
    Added an "Apply" button in the options dialog window. This will set all options
    without closing the window.

Advanced tab color settings
    You can now add folders as well as file extensions to set document tab colors.
    Also added up and down buttons to change the items position and priority in
    the list.

Delete duplicate lines
    Added a function in "Edit -> More line operations" to remove duplicate lines.
    The function will preserve the first occurrence and then remove all duplicates
    inside the selection, or entire document if nothing is selected.

Search box in text clip tab
    When you start type something all found clips are listed below the search
    box. Click or hit RETURN to select.

Recent files
    Added an option to display the file name and full path on the same line.
    Added an option to display full path hints in the drop down menu.

Favorite files
    Added an option to display the file name and full path on the same line.

Explorer tabs
    Added a tree view button to the explorer tab toolbar. This will open or close
    a folder tree above the file list.

Misc
    * Made some changes to the syntax editor.
    * Made some changes to all dialog windows.
    * Added spell check options for line color and width.
    * Added a help menu item for regular expression.
    * Added a regular expression  help button on the create regular expression window.
    * Changed some icons in the help menu.

Fixed
    * Right ALT key in keyboard shortcuts should work now on English keyboard layouts.
    * Some search issues in the options windows.
    * Undo issue with multiple editing.
    * Error message when closing many files using a keyboard shortcut for "Close document".
    * Network files were not added to the recently opened file list.
    * Empty [CurrentWord] argument when running help files as tools.
    * Fixed some links on the "Home" page.

-----------------------------------------------------------
Version 8.95 (April 8, 2014)
-----------------------------------------------------------

Beautify and verify HTML/XML
    Made some changes in the HTML menu and added menu items to beautify,
    verify and set options. The functions use the included Tidy.exe to generate
    output and validation.

    There are a huge set of options you can set individually for HTML, xHTML and
    XML files.

Scripts

    void KeyPress(TObject sender, char key)

    to

    void KeyPress(TObject sender, int key)

Explorer Tab
    Removed the explorer tree and made some changes to increase speed. This should
    fix the issues some users experience with freezing program, which could happen
    at startup or when opening or saving a file.

    The speed improvement should be noticeable on all systems.

File Open/Save dialogs
      Removed the built in file dialog. On Vista, and above, the standard file
      dialogs are used. On XP, and below, the Office text file dialog is used.
      This should solve the freeze issues on some systems.

      The options to select file dialog type has been removed as well.

Misc
    * Renamed "Addons -> Themes" to "Addons -> Skins".

Fixed
    * When opening a file from Windows Explorer or context menu the text area
      sometimes went black.
    * Some search-bar resize issues.
    * Insert text on each line when inserting text at the end.
    * Find next/prev issues when using regex.
    * Display and highlight issue when switching between highlighters.
    * Display and highlight issue when saving a file using a different file extension.
    * Some search-bar popup menu issues.
    * A "Find Note/Todo" issue.
    * A "Find Bookmark" issue.

-----------------------------------------------------------
Version 8.91  (Mar 15, 2014)
-----------------------------------------------------------

Scripts and Extensions
    Rewrote the entire script engine to use wide strings (UTF16) instead of
    ANSI/UTF8 strings. All string types are now Unicode strings
    (String = Widestring).

    Functions and classes now use Unicode strings as well.

    E.x. C++ script

    {
        TTntStringlist ls = TTntStringlist.Create;
        ls.Add("Hello World!");
        ls.Add("Привет мир!");
        Document.SelText = ls.Text;
        ls.Free;
    }

    Some properties and methods have been removed since they are not necessary
    anymore.

    Use:
        Document.SelText    (not Document.WideSelText)
        Document.Text       (not Document.WideText)

        ...

FTP (open remote file)
    If the editor fail to open a remote file, a new attempt is made using the
    full FTP path to the file.

Language files
    Updated a few language files and fixed an issue in the Dutch language file.



===========================================================
 RJ TextEd is a full featured text and source editor with
 Unicode support. You can download the latest version at
           https://www.rj-texted.se
===========================================================